package fachada;

import java.sql.SQLException;
import java.util.Vector;

import negocio.NegocioAluno;
import negocio.NegocioCompoe;
import negocio.NegocioDanca;
import negocio.NegocioDespesa;
import negocio.NegocioDias;
import negocio.NegocioEscolaParceira;
import negocio.NegocioFestival;
import negocio.NegocioFuncionario;
import negocio.NegocioMensalidade;
import negocio.NegocioModalidade;
import negocio.NegocioTurma;
import negocio.TurmaExistenteException;
import Excecao.AlunoExistenteException;
import Excecao.AtendenteExistenteException;
import Excecao.DancaExistenteException;
import Excecao.DespesaExistenteException;
import Excecao.EscolaExistenteException;
import Excecao.FestivalExistenteException;
import Excecao.FuncionarioExistenteException;
import Excecao.ModalidadeExistenteException;
import Excecao.ProfessoreExistenteException;
import basicas.Aluno;
import basicas.Atendente;
import basicas.Danca;
import basicas.Despesa;
import basicas.Dias;
import basicas.EscolaParceira;
import basicas.Festival;
import basicas.Funcionario;
import basicas.Modalidade;
import basicas.Professor;
import basicas.Turma;

public class Fachada {

	private NegocioAluno negAluno;
	private NegocioEscolaParceira negEscola;
	private NegocioFuncionario negFunc;
	private NegocioDespesa negDespesa;
	private NegocioFestival negFestival;
	private NegocioDanca negDanca;
	private NegocioModalidade negModalidade;
	private NegocioTurma negTurma;
	private NegocioDias negDias;
	private NegocioCompoe negCompoe;
	private NegocioMensalidade negMens;


	public Fachada() {

		negAluno = new NegocioAluno();
		negEscola = new NegocioEscolaParceira();
		negFunc = new NegocioFuncionario();
		negDespesa = new NegocioDespesa();
		negFestival = new NegocioFestival();
		negDanca = new NegocioDanca();
		negModalidade = new NegocioModalidade();
		negTurma = new NegocioTurma();
		negDias = new NegocioDias();
		negCompoe = new NegocioCompoe();
		negMens = new NegocioMensalidade();

	}

	//INSERIR
	
	public void inserirAluno(Aluno aluno) throws AlunoExistenteException {

		negAluno.inserirAluno(aluno);
	}

	public void inserirEscolaParceira(EscolaParceira escola) throws EscolaExistenteException{

		negEscola.inserirEscolaParceira(escola);
	}

	public void inserirDespesa(Despesa despesa) throws DespesaExistenteException {
		
		negDespesa.inserirDespesa(despesa);

	}

	public void inserirDanca(Danca danca) throws DancaExistenteException {
		
		negDanca.inserirDanca(danca);
	}

	public void inserirFestival(Festival festival) throws FestivalExistenteException{
		
		negFestival.inserirFestival(festival);
	}

	public void inserirModalidade(Modalidade modalidade) throws ModalidadeExistenteException{
		
		negModalidade.inserirModalidade(modalidade);

	}

	public void inserirProfessor(Professor professor) throws ProfessoreExistenteException{
		negFunc.inserirProfessor(professor);
	}

	public void inserirAtendente(Atendente atendente) throws AtendenteExistenteException{
		negFunc.inserirAtendente(atendente);
	}

	public void inserirFuncionario(Funcionario funcionario) throws FuncionarioExistenteException{
		negFunc.inserirOutroFuncionario(funcionario);
	}
	
	public void inserirTurma(Turma turma) throws TurmaExistenteException{
		negTurma.inserirTurma(turma);
	}
	
	// GERAR RELATORIO

	public Vector<Aluno> gerarRelatorioAluno(){
		return negAluno.gerarRelatorioAluno();
	}

	public Vector<EscolaParceira> gerarRelatorioEscola(){
		return negEscola.gerarRelatorioEscola();
	}

	public Vector<Funcionario> gerarRelatorioFuncionario(){
		return negFunc.gerarRelatorioFuncionario();
	}
	
	public Vector<Despesa> gerarRelatorioDespesa(){
		return negDespesa.gerarRelatorioDespesa();
	}
	
	public Vector<Festival> gerarRelatorioFestival(){
		
		return negFestival.gerarRelatorioFestival();
	}
	
	public Vector<Danca> gerarRelatorioDanca(){
		return negDanca.gerarRelatorioDanca();
	}
	
	public Vector<Modalidade> gerarRelatorioModalidade(){
		return negModalidade.gerarRelatorioModalidade();
	}
	
	public Vector<Turma> gerarRelatorioTurma(){
		return negTurma.gerarRelatorioTurma();
	}


	// ATUALIZAR
	
	public void atualizarAluno(Aluno aluno){
		negAluno.atualizarAluno(aluno);
	}

	public void atualizarEscola(EscolaParceira escola){
		negEscola.atualizarEscola(escola);		
	}

	public void atualizarProfessor(Professor professor){
		negFunc.atualizarProfessor(professor.getCpf(), professor);		
	}
	
	public void atualizarAtendente(String cpf, Atendente a){
		negFunc.atualizarAtendente(cpf, a);
	}
	
	public void atualizarFuncionario(Funcionario f){
		negFunc.atualizarOutroFuncionario(f.getCpf(), f);
	}
	
	public void atualizarDespesa(Despesa f){
		negDespesa.atualizarDespesa(Integer.parseInt(f.getCodigoDespesa()), f);
	}
	
	public void atualizarFestival(Festival f){
		negFestival.atualizarFestival(f);
	}
	
	public void atualizarDanca(Danca d){
		negDanca.atualizarDanca(d);
	}
	
	public void atualizarModalidade(Modalidade mod){
		negModalidade.atualizarModalidade(mod);
	}
	
	public void atualizarTurma(Turma d){
		negTurma.atualizarTurma(d);
	}


	
	
	
	// REMOVER
	

	public void removerAluno(int cod){
		negAluno.removerAluno(cod);
	}

	public void removerEscola(int cod){
		negEscola.removerEscola(cod);
	}

	public void removerFuncionario(String cpf, String funcao){

		if(funcao.equalsIgnoreCase("professor")){

			negFunc.removerProfessor(cpf);
		} else if(funcao.equalsIgnoreCase("Atendente")){

			negFunc.removerAtendente(cpf);

		} else {
			negFunc.removerOutroFuncionario(cpf);

		}
	}
	
	public void removerDespesa(String cod_despesa){
		negDespesa.removerDespesa(Integer.parseInt(cod_despesa));
	}
	
	public void removerFestival(String cod_fest){
		negDespesa.removerDespesa(Integer.parseInt(cod_fest));
	}
	
	public void removerDanca(String cod_fest){
		negDanca.removerDanca(Integer.parseInt(cod_fest));
	}
	
	public void removerModalidade(String nome){
		negModalidade.removerModalidade(nome);
	}
	
	public void removerTurma(String cod_turma){
		negTurma.removerTurma(Integer.parseInt(cod_turma));
	}

	public Vector<Professor> gerarRelatorioProfessor() {
		
		return negFunc.gerarRelatorioProfessor();
	}

	public Vector<Aluno> consultarAlunoPorMae(String textoUm) {
		return negAluno.consultarAlunoPorMae(textoUm);
	}

	public Vector<Aluno> consultarAlunoPorIdade(int parseInt, int parseInt2) {
		return negAluno.consultarAlunoPorIdade(parseInt,parseInt2);
	}

	public Vector<Aluno> consultarAlunoPorNome(String textoUm) {
		// TODO Auto-generated method stub
		return negAluno.consultarAlunoPorNome(textoUm);
	}

	public Vector<Funcionario> consultarFuncionarioPorNome(String textoUm) {
		// TODO Auto-generated method stub
		return negFunc.consultarFuncionarioPorNome(textoUm);
	}

	public Vector<Funcionario> consultarFuncionarioPorCPF(String textoUm) {
		// TODO Auto-generated method stub
		return negFunc.consultarFuncionarioPorCPF(textoUm);
	}

	public Vector<Funcionario> consultarFuncionarioPorFuncao(String textoUm) {
		// TODO Auto-generated method stub
		return negFunc.consultarFuncionarioPorFuncao(textoUm);
	}

	public Vector<Despesa> consultarDespesaPorDataVencimento(String textoUm) {
		// TODO Auto-generated method stub
		return negDespesa.consultarDespesaPorDataVencimento(textoUm);
	}

	public Vector<Despesa> consultarDespesaPorEmpresa(String textoUm) {
		// TODO Auto-generated method stub
		return negDespesa.consultarDespesaPorEmpresa(textoUm);
	}

	public Vector<Funcionario> consultarAtendentePorLogin(String textoUm) {
		// TODO Auto-generated method stub
		return negFunc.consultarAtendentePorLogin(textoUm);
	}

	public Vector<Turma> consultarTurmaPorCpfProfessor(String textoUm) {
		// TODO Auto-generated method stub
		return negTurma.consultarTurmaPorCpfProfessor(textoUm);
	}

	public Vector<Aluno> consultarAlunoPorDanca(String cod_danca,
			int codigoFestival) {
		// TODO Auto-generated method stub
		return negAluno.consultarAlunoPorDanca(cod_danca, codigoFestival);
	}

	public Vector<Aluno> consultarAlunoPorTurma(String codigoTurma) {
		// TODO Auto-generated method stub
		return negAluno.consultarAlunoPorTurma(codigoTurma);
	}

	public Vector<Turma> consultarTurmaPorNome(String nome) {
		return negTurma.consultarTurmaPorNome(nome);
	}

	public Vector<Modalidade> consultarModalidadePorNome(String nome) {
		// TODO Auto-generated method stub
		return negModalidade.consultarModalidadePorNome(nome);
	}

	public Vector<Turma> consultarTurmaPorNomeModalidade(String nome) {
		// TODO Auto-generated method stub
		return negTurma.consultarTurmaPorModalidade(nome);
	}

	public Vector<Turma> consultarTurmaPorSala(String string) {
		// TODO Auto-generated method stub
		return negTurma.consultarTurmaPorSala(string);
	}

	public Vector<EscolaParceira> consultarEscola(String nome) {
		// TODO Auto-generated method stub
		return negEscola.consultarEscolaParceira(nome);
	}

	public Vector<Aluno> consultarAlunoPorSexo(String string) {
		// TODO Auto-generated method stub
		return negAluno.consultarAlunoPorSexo(string);
	}

	public Vector<Aluno> consultarAlunosPagadores() {
		// TODO Auto-generated method stub
		return negAluno.consultarAlunoPagadores();
	}

	public Vector<Aluno> consultarAlunosDevedores() {
		// TODO Auto-generated method stub
		return negAluno.consultarAlunosDevedores();
	}

	public Vector<Despesa> consultarDespesaPorStatus(String string) {
		// TODO Auto-generated method stub
		return negDespesa.consultarDespesaPorStatus(string);
	}

	public Vector<Dias> consultarDiasPorCodigoTurma(String codigoTurma) {

		return  negDias.consultarDiasPorCodigoTurma(codigoTurma);
	}

	public void inserirDias(Dias dia) {

		negDias.inserirDias(dia);
	}
	
	public void inserirCompoe(Vector<Integer> codigoTurmas, int codigoAluno){
		
		negCompoe.inserirCompoe(codigoTurmas, codigoAluno);
		
	}

	public Vector<Turma> consultarPeloCodigo(int parseInt) {
		// TODO Auto-generated method stub
		return negTurma.consultarTurmaPorCodigo(parseInt);
	}

	public Vector<Turma> consultarTurmaPorAluno(int cod) {
		
		return negCompoe.consultarTurmaPorAluno(cod);
	}

	public Vector<Turma> consultarTurmaPorIdade(int parseInt) {
		// TODO Auto-generated method stub
		return negTurma.consultarTurmaPorIdade(parseInt);
	}

	public void pagarMensalidade(String data, int parseInt, String data2,
			double mensalidade) {

		negMens.pagarMensalidade(data,parseInt,data2,mensalidade);
	}

	public String consultarProximaMensalidade(Aluno aluno, int codAluno) throws SQLException {

		return negMens.consultarProxMensalidade(aluno,codAluno);
	}

	public boolean removerCompoe(int codigoA, int codigoT) {

		return negCompoe.removerCompoe(codigoA, codigoT);
	}

	public void removerDias(String dia, int parseInt) {

		negDias.removerDias(dia,parseInt);
	}

	public Vector<Turma> consultarTurmaPorAluno(String textoUm) {
		// TODO Auto-generated method stub
		return negCompoe.consultarTurmaPorAluno(Integer.parseInt(textoUm));
	}

	public boolean removerTodasTurmas(int parseInt) {

		return negCompoe.removerTodasTurmas(parseInt);
	}

/*	public Vector<Turma> consultarPeloCodigo(int parseInt) {
		// TODO Auto-generated method stub
		return negTurma.consultarPeloCodigo(parseInt);
	}*/



}
