package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTabbedPane;

import org.omg.PortableInterceptor.INACTIVE;

import basicas.Dias;
import basicas.Modalidade;
import basicas.Turma;

public class JanelaAtualizacaoSelecaoTurma extends JFrame implements MouseListener{

	private Tabela tabela;
	private JTabbedPane painel;

	private JLabel labelImagem;
	private ImageIcon imagem;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;

	private JanelaPrincipal janelaPrincipal;

	private Vector<Modalidade> modalidades;

	private Vector<Turma> turmas ;

	private Vector<Vector<Turma>> turmasModalidade;

	private Vector<Tabela> tabelas;

	private Vector<Integer> codigosTurma;

	private int codigoAluno;
	private double mensalidade;
	private JanelaAtualizarAluno janelaC;
	
	public JanelaAtualizacaoSelecaoTurma(JanelaAtualizarAluno janelaC,JanelaPrincipal janela, Vector<Modalidade> modalidades, int cod_Aluno){
		this.modalidades = modalidades;
		this.janelaPrincipal = janela;
		this.turmas = new Vector<Turma>();
		this.codigoAluno = cod_Aluno;
		this.janelaC = janelaC;
		this.criarJanela();
	}

	private void criarJanela() {
		this.setTitle("Selecione as turmas");
		this.setSize(620, 450);
		//this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		criarImagem();
		this.painel = new JTabbedPane();

		int mod = modalidades.size();
		this.turmasModalidade = new Vector<Vector<Turma>>();
		this.tabelas = new Vector<Tabela>();
		int i = 0;
		Vector<Turma> turmasAluno = this.janelaPrincipal.getFachada().consultarTurmaPorAluno(this.codigoAluno);
		Vector<Integer> codigosTurma = new Vector<Integer>();
		int size = turmasAluno.size();
		System.out.println("aluno turma" + size);
		
		for (int k = 0; k < size; k++) {
			codigosTurma.add(Integer.parseInt(turmasAluno.get(k).getCodigoTurma()));

		}

		Vector<Integer> indicesTurma  = new Vector<Integer>();;

		while( mod > i) {

			indicesTurma.clear();
			this.turmas = this.janelaPrincipal.getFachada().consultarTurmaPorNomeModalidade(modalidades.get(i).getNome());
			this.turmasModalidade.add(this.turmas);
			String[][] turma = new String[turmas.size()][5];
			for(int j = 0; j < turmas.size(); j++){
				for(int v = 0; v < turmasAluno.size(); v++){
					if(turmasAluno.get(v).getCodigoTurma().equalsIgnoreCase(turmas.get(j).getCodigoTurma())){
						indicesTurma.add(j);
					}
				}


				Vector<Dias> dias = this.janelaPrincipal.getFachada().consultarDiasPorCodigoTurma(turmas.get(j).getCodigoTurma());
				int quantDias = dias.size();

				turma[j][0] = turmas.get(j).getNome();

				if(quantDias == 0){
					turma[j][1] = " ";
					turma[j][2] = " ";
				}else{

					int m = quantDias - 1;
					turma[j][1] = dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));
					m--;
					while(m >= 0){

						turma[j][1] = turma[j][1] + " / " + dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));

						m--;

					}			

					if(turmas.get(j).getIdadeMaxima() == 0){
						turma[j][2] = "A partir de " + turmas.get(j).getIdadeMinima();

					} else {
						turma[j][2] = turmas.get(j).getIdadeMinima() + " a " + turmas.get(j).getIdadeMaxima();

					}
				}

				if(turmas.size() == 0) {
					turma[0][0] = "";
					turma[0][1] = "";
					turma[0][2] = "";
					turma[0][3] = "";
					turma[0][4] = "";
				}
			}
	
			this.tabela = new Tabela("", 30, 60, 540, 235, 10, turma, indicesTurma);
			this.tabela.setLayout(null);
			this.tabela.setOpaque(true);
			painel.addTab(modalidades.get(i).getNome(), tabela);

			this.tabelas.add(tabela);

			i++;
		}

		cadastrar = criarLabel("Cadastrar", 510, 360);
		cadastrar.setFont(new Font("Verdana", Font.BOLD, 13));

		cancelar = criarLabel("Cancelar", 90, 360);
		cancelar.setFont(new Font("Verdana", Font.BOLD, 13));

		this.add(painel);

		this.setVisible(true);

	}

	private void criarImagem() {

		//imagem = new ImageIcon("Teste3.jpg");
		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 450, 345);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 30, 345);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);

		//criarLabelImagem2(labelImagem, imagem,0,0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(90, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}
	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {


		if(arg0.getComponent() == botaoOk){

			int tamanho = this.turmasModalidade.size();
			int tamanho2;

			this.codigosTurma = new Vector<Integer>(); 
			for(int i = 0;i < tamanho; i++){
				tamanho2 = this.turmasModalidade.get(i).size();
				for(int j = 0; j < tamanho2; j++){	
					if(tabelas.get(i).getModelo().getValueAt(j, 0).equals(true)){
						this.codigosTurma.add(Integer.parseInt(turmasModalidade.get(i).get(j).getCodigoTurma()));
					}
				}
			}

			if(this.codigosTurma.size() == 0){
				JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Nenhuma turma foi selecionada. Deseja sair assim mesmo?");
				int a = janelaTemCerteza.responder();

				if(a == 0){ // yes
					this.dispose();				
				} 
			} else {
				int size = codigosTurma.size();

				for(int i = 0; i < size; i++) {
					String nomeModalidade = this.janelaPrincipal.getFachada().consultarPeloCodigo(this.codigosTurma.get(i)).get(0).getNomeModalidade();
					mensalidade = mensalidade + this.janelaPrincipal.getFachada().consultarModalidadePorNome(nomeModalidade).get(0).getValor();
				}

				janelaC.caixaTextoMensalidade.setText(String.valueOf(mensalidade));
				this.dispose();
			
			}

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 


		} 

	}

	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}

	}

	@Override
	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public Vector<Integer> getCodigosTurma() {
		return codigosTurma;
	}

	public void setCodigosTurma(Vector<Integer> codigosTurma) {
		this.codigosTurma = codigosTurma;
	}

	public double getMensalidade() {
		return mensalidade;
	}

	public void setMensalidade(double mensalidade) {
		this.mensalidade = mensalidade;
	}



}
