package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import basicas.Aluno;
import basicas.EscolaParceira;
import basicas.Modalidade;

public class JanelaAtualizarAluno extends JFrame implements ActionListener, MouseListener{

	private JLabel nome;
	private JTextField caixaTextoNome;
	private JLabel rg;
	private JTextField caixaTextoRG;
	private JLabel cpf;
	private JTextField caixaTextoCPF;
	private JLabel sexo;
	private JRadioButton sexoM;
	private JRadioButton sexoF;
	//private JLabel codigo;
	//private JTextField caixaTextoCodigo;
	private JLabel dataNascimento;
	private JTextField caixaTextoDataNascimento;
	private JLabel endereco;
	private JLabel rua;
	private JTextField caixaTextoRua;
	private JLabel numero;
	private JTextField caixaTextoNumero;
	private JLabel cidade;
	private JTextField caixaTextoCidade;
	private JLabel bairro;
	private JTextField caixaTextoBairro;
	private JLabel cep;
	private JTextField caixaTextoCEP;
	private JLabel complemento;
	private JTextField caixaTextoCompleto;
	private JLabel telefone;
	private JTextField caixaTextoTelefone;
	private JLabel email;
	private JTextField caixaTextoEmail;
	private JLabel problemaSaude;
	private JTextField caixaTextoProblemaSaude;
	private JLabel planoSaude;
	private JTextField caixaTextoPlanoSaude;
	private JLabel escola;
	private JComboBox escolaBox;
	private JTextField caixaTextoEscolaParceira;
	private JLabel serie;
	private JComboBox serieBox;
	//private JTextField caixaTextoSerie;
	private JLabel autorizacao;
	private JCheckBox autorizacaoBox;
	private JLabel possuiIrmao;
	private JCheckBox possuiIrmaoBox;
	private JLabel mae;
	private JLabel nomeMae;
	private JTextField caixaTextoNomeMae;
	private JLabel profissaoMae;
	private JTextField caixaTextoProfissaoMae;
	private JLabel contatoMae;
	private JTextField caixaTextoContatoMae;
	private JLabel pai;
	private JLabel nomePai;
	private JTextField caixaTextoNomePai;
	private JLabel profissaoPai;
	private JTextField caixaTextoProfissaoPai;
	private JLabel contatoPai;
	private JTextField caixaTextoContatoPai;

	private JLabel diaVencimento;
	private JTextField caixaTextoDiaVencimento;
	private JLabel mensalidade;
	public JTextField caixaTextoMensalidade;


	private JanelaPrincipal janelaPrincipal;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoEscolherTurma;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotao;

	private JLabel imagemFundo;
	private ImageIcon imagem;
	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;

	private JButton escolherTurma;

	private JPanel painel;
	private JScrollPane scrollPane;

	private ButtonGroup grupo;
	private Aluno aluno;

	private JanelaAtualizacaoSelecaoTurma janelaAtualizacaoSelecaoTurma;

	String[] lista;
	String[] series = {"Nenhuma", "Maternal", "Jardim I", "Jardim II", "Jardim III", "1 ano (Ensino Fundamental)", 
			"2 ano (Ensino Fundamental)", "3 ano (Ensino Fundamental)", 
			"4 ano (Ensino Fundamental)", "5 ano (Ensino Fundamental)", 
			"6 ano (Ensino Fundamental)", "7 ano (Ensino Fundamental)", 
			"8 ano (Ensino Fundamental)", "9 ano (Ensino Fundamental)",
			"1 ano (Ensino Mdio)", "2 ano (Ensino Mdio)", "3 ano (Ensino Mdio)"};


	public JanelaAtualizarAluno(JanelaPrincipal janela, Aluno aluno){

		this.janelaPrincipal = janela;
		this.aluno = aluno;
		this.criarJanela();
		this.passarInformacao(aluno);
	}

	public void criarJanela(){

		this.setTitle("Atualizar Aluno");
		this.setSize(620, 580); //620 840
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();
		this.painel = new JPanel();
		this.painel.setLayout(null);
		this.scrollPane = new JScrollPane(painel);
		painel.setPreferredSize(new Dimension(590, 900));
		this.scrollPane.setBounds(0, 0, 620, 840);
		this.setContentPane(scrollPane);

		this.nome = criarLabel("Nome:*", 30, 30);
		this.caixaTextoNome = criarCaixaTexto(300, 20, 80, 30);

		//this.codigo = criarLabel("Cdigo:*", 420, 30);
		//this.caixaTextoCodigo = criarCaixaTexto(100, 20, 475, 30);

		this.rg = criarLabel("RG:", 30, 80);
		this.caixaTextoRG = criarCaixaTexto(100, 20, 80, 80);

		this.cpf = criarLabel("CPF:", 260, 80);
		this.caixaTextoCPF = criarCaixaTexto(80, 20, 300, 80);

		this.sexo = criarLabel("Sexo:*", 430, 80);
		this.sexoM = this.criarRadioButton("M", 475, 80);
		this.sexoF = this.criarRadioButton("F", 515, 80);

		grupo = new ButtonGroup();
		grupo.add(sexoM);
		grupo.add(sexoF);

		this.dataNascimento = criarLabel("Data de Nascimento:*", 30, 130);
		this.caixaTextoDataNascimento = criarCaixaTexto(70, 20, 160, 130);

		this.autorizacao = criarLabel("Autorizao para sair", 250, 130);
		this.autorizacaoBox = criarCheckBox(380, 130);

		this.possuiIrmao = criarLabel("Irmo matriculado", 420, 130);
		this.possuiIrmaoBox = criarCheckBox(530, 130);

		this.endereco = criarLabel("Endereo", 30, 180);

		this.rua = criarLabel("Rua:", 30, 210);
		this.caixaTextoRua = criarCaixaTexto(300, 20, 80, 210);

		this.numero = criarLabel("Nmero:", 420, 210);
		this.caixaTextoNumero = criarCaixaTexto(100, 20, 475, 210);

		this.bairro = criarLabel("Bairro:", 30, 240);
		this.caixaTextoBairro = criarCaixaTexto(200, 20, 80, 240);

		this.cidade = criarLabel("Cidade:", 310, 240);
		this.caixaTextoCidade = criarCaixaTexto(215, 20, 360, 240);

		this.cep = criarLabel("CEP:", 30, 270);
		this.caixaTextoCEP = criarCaixaTexto(55, 20, 80, 270);

		this.complemento = criarLabel("Complemento:", 150, 270);
		this.caixaTextoCompleto = criarCaixaTexto(335, 20, 240, 270);

		this.telefone = criarLabel("Telefone:", 30, 320);
		this.caixaTextoTelefone = criarCaixaTexto(100, 20, 100, 320);

		this.email = criarLabel("E-mail:", 230, 320);
		this.caixaTextoEmail = criarCaixaTexto(295, 20, 280, 320);

		this.problemaSaude = criarLabel("Problema de Sade:", 30, 370);
		this.caixaTextoProblemaSaude = criarCaixaTexto(150, 20, 150, 370);

		this.planoSaude = criarLabel("Plano de Sade:", 320, 370);
		this.caixaTextoPlanoSaude = criarCaixaTexto(155, 20, 420, 370);

		this.escola = criarLabel("Escola:", 30, 420);
		Vector<EscolaParceira> vetorEscolas = janelaPrincipal.getFachada().gerarRelatorioEscola();
		int j = 0;
		int tamanho = vetorEscolas.size();
		lista = new String[tamanho + 2];
		lista[0] = "Selecione a escola";
		j = 1;
		while(tamanho >= j){
			lista[j] = vetorEscolas.get(j-1).getNome();
			j++;
		}
		lista[j] = "outros";

		this.escolaBox = criarComboBox(lista, 250, 20, 80, 420);

		this.caixaTextoEscolaParceira = criarCaixaTexto(225, 20, 350, 420);
		this.caixaTextoEscolaParceira.setEnabled(false);

		this.serie = criarLabel("Srie:", 30, 470);

		this.serieBox = criarComboBox(series, 200, 20, 80, 470);

		//this.caixaTextoSerie = criarCaixaTexto(30, 20, 80, 400);

		this.mae = criarLabel("Dados da me", 30, 520);

		this.nomeMae = criarLabel("Nome:", 30, 550);
		this.caixaTextoNomeMae = criarCaixaTexto(290, 20, 100, 550);

		this.profissaoMae = criarLabel("Profisso:", 30, 580);
		this.caixaTextoProfissaoMae = criarCaixaTexto(180, 20, 100, 580);

		this.contatoMae = criarLabel("Contato:", 415, 580);
		this.caixaTextoContatoMae = criarCaixaTexto(100, 20, 475, 580);

		this.pai = criarLabel("Dados do pai", 30, 630);

		this.nomePai = criarLabel("Nome:", 30, 660);
		this.caixaTextoNomePai = criarCaixaTexto(290, 20, 100, 660);

		this.profissaoPai = criarLabel("Profisso:", 30, 690);
		this.caixaTextoProfissaoPai = criarCaixaTexto(180, 20, 100, 690);

		this.contatoPai = criarLabel("Contato:", 415, 690);
		this.caixaTextoContatoPai = criarCaixaTexto(100, 20, 475, 690);

		this.diaVencimento = criarLabel("Dia do Vencimento:*", 30, 770);
		this.caixaTextoDiaVencimento = criarCaixaTexto(20, 20, 150, 770);

		this.mensalidade = criarLabel("Mensalidade (R$):", 430, 770);
		this.caixaTextoMensalidade = criarCaixaTexto(35, 20, 540, 770);
		this.caixaTextoMensalidade.setText("0");

		this.cadastrar = criarLabel("Atualizar", 500, 835);
		this.cadastrar.setFont(new Font("Verdana",Font.BOLD,13));

		this.cancelar = criarLabel("Cancelar", 100, 835);
		this.cancelar.setFont(new Font("Verdana",Font.BOLD,13));

		this.escolherTurma = new JButton("Escolha a Turma");
		this.escolherTurma.setSize(150, 20);
		this.escolherTurma.setLocation(250, 730);
		this.escolherTurma.addActionListener(this);
		this.painel.add(escolherTurma);

		this.criarImagem();
		this.limitarTexto();
		Vector<Modalidade> vetorModalidade = this.janelaPrincipal.getFachada().gerarRelatorioModalidade();
		this.janelaAtualizacaoSelecaoTurma = new JanelaAtualizacaoSelecaoTurma(this, this.janelaPrincipal, vetorModalidade, Integer.parseInt(this.aluno.getCodigoAluno()));
		this.setVisible(true);

	}


	private void criarImagem() {

		imagem = new ImageIcon("Teste1.jpg");
		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");	


		botaoOk = criarLabel("", 430 , 820);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");	
		botaoCancelar = criarLabel("", 30 , 820);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);

		criarLabelImagem2(imagemFundo, imagem,0,0, 620, 900);

	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.painel.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.painel.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.painel.add(caixaTexto);
		caixaTexto.setLayout(null);
		caixaTexto.setText("");
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	public JCheckBox criarCheckBox(int xPosicao, int yPosicao){
		JCheckBox box = new JCheckBox();
		this.painel.add(box);
		box.setLayout(null);
		box.setSize(20, 20);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}

	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.painel.add(radio);
		radio.setSize(35, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public JComboBox criarComboBox(String[] texto, int xTamanho, int yTamanho, int xPosicao, int yPosicao) {
		JComboBox box = new JComboBox(texto);
		this.painel.add(box);
		box.setSize(xTamanho, yTamanho);
		box.setLocation(xPosicao, yPosicao);
		box.addActionListener(this);

		return box;
	}

	/*public JComboBox criarComboBox(String[] texto, int xPosicao, int yPosicao){
		JComboBox box = new JComboBox(texto);
		this.add(box);
		box.addActionListener(this);
		box.setSize(250, 20);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}*/

	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}

	public void actionPerformed(ActionEvent e) {


		if(e.getActionCommand().equalsIgnoreCase("escolha a turma")){
			Vector<Modalidade> modalidades = this.janelaPrincipal.getFachada().gerarRelatorioModalidade();
			janelaAtualizacaoSelecaoTurma = new JanelaAtualizacaoSelecaoTurma(this,janelaPrincipal, modalidades,Integer.parseInt(aluno.getCodigoAluno()));
		}

		String nomeEscola = (String)this.escolaBox.getSelectedItem();

		if(nomeEscola.equalsIgnoreCase("outros")){
			this.caixaTextoEscolaParceira.setEnabled(true);
		}

		if(!nomeEscola.equalsIgnoreCase("outros")){
			this.caixaTextoEscolaParceira.setText("");
			this.caixaTextoEscolaParceira.setEnabled(false);
		}
	}



	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		} 

	}

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	public void limitarTexto(){

		caixaTextoRG.setDocument(new MeuDocument(20));
		caixaTextoCPF.setDocument(new MeuDocument(11));
		caixaTextoNome.setDocument(new MeuDocument(80));
		caixaTextoDataNascimento.setDocument(new MeuDocument(10));
		caixaTextoProblemaSaude.setDocument(new MeuDocument(100));
		caixaTextoNomeMae.setDocument(new MeuDocument(80));
		caixaTextoProfissaoMae.setDocument(new MeuDocument(30));
		caixaTextoContatoMae.setDocument(new MeuDocument(10));
		caixaTextoNomePai.setDocument(new MeuDocument(80));
		caixaTextoProfissaoPai.setDocument(new MeuDocument(30));
		caixaTextoContatoPai.setDocument(new MeuDocument(10));		
		caixaTextoDiaVencimento.setDocument(new MeuDocument(2));
		caixaTextoMensalidade.setDocument(new MeuDocument(5));
		caixaTextoTelefone.setDocument(new MeuDocument(10));

	}

	@Override
	public void mousePressed(MouseEvent arg0) {

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {

	}
	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = checarCampos();

			if(b == true){

				Aluno aluno = getInformacoes();

				Vector<Integer> codTurma = this.janelaAtualizacaoSelecaoTurma.getCodigosTurma();
				janelaPrincipal.getFachada().atualizarAluno(aluno);

				int t;
				if(codTurma != null){
					 t = codTurma.size();
				} else {
					t = 0;
				}
					for (int i = 0; i < t; i++) {

						this.janelaPrincipal.getFachada().removerCompoe(Integer.parseInt(this.aluno.getCodigoAluno()), codTurma.get(i));
					}
					
					if(t != 0)
					this.janelaPrincipal.getFachada().inserirCompoe(codTurma, Integer.parseInt(this.aluno.getCodigoAluno()));


					JanelaAviso janelaAviso = new JanelaAviso("Bailarino(a) atualizado(a) com sucesso", 1);	
					this.dispose();

				} else {

					JanelaAviso janelaAviso = new JanelaAviso("Preencha todos os campos obrigatorios *", 2);	

				}

			} else if(arg0.getComponent() == botaoCancelar){

				JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
				int a = janelaTemCerteza.responder();

				if(a == 0){ // yes
					this.dispose();				
				} 

			}
		}


	public boolean checarCampos() {

		if(  caixaTextoNome.getText().equalsIgnoreCase("") 
				||  caixaTextoDataNascimento.getText().equalsIgnoreCase("") 
				|| caixaTextoDiaVencimento.getText().equalsIgnoreCase("") 

		){
			return false;
		} else {
			return true;
		}

	}

	public boolean validarCampos() {

		boolean validar = true;

		try { 
			ValidaNumero(caixaTextoRG);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo RG s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoRG.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoCPF);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo CPF s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoCPF.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoNumero);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Nmero s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoNumero.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoCEP);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo CEP s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoCEP.grabFocus(); 
		} 


		try { 
			ValidaNumero(caixaTextoTelefone);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Telefone s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoTelefone.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoContatoMae);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Contato s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoContatoMae.grabFocus(); 
		} 


		try { 
			ValidaNumero(caixaTextoDiaVencimento);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Vencimento s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoDiaVencimento.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoContatoPai);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Contato s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoContatoPai.grabFocus(); 
		} 

		return validar;
	}

	public void ValidaNumero(JTextField Numero) throws NumberFormatException { 

		long valor; 
		if (Numero.getText().length() != 0){ 
			//try { 
			valor = Long.parseLong(Numero.getText()); 
			/*}catch(NumberFormatException ex){ 
				JOptionPane.showMessageDialog(null, "Esse Campo s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
				Numero.grabFocus(); 
			} */
		} 
	} 


	public void passarInformacao(Aluno aluno){

		//int cod = Integer.parseInt(caixaTextoCodigo.getText());

		caixaTextoNome.setText(aluno.getNome());		 
		caixaTextoDataNascimento.setText(aluno.getNascimento());

		caixaTextoCPF.setText(aluno.getCpf());
		caixaTextoRG.setText(aluno.getRg());

		char sexo = aluno.getSexo();

		if(sexo == 'F'){
			sexoF.setSelected(true);
		} else  {
			sexoM.setSelected(true);
		} 
		sexoF.setEnabled(false);
		sexoM.setEnabled(false);


		caixaTextoProblemaSaude.setText(aluno.getAlergias());
		Vector<String> telefones = aluno.getTelefones();
		caixaTextoTelefone.setText(telefones.get(0));

		String escola = aluno.getNomeEscola();
		boolean temEscola = false;

		for(int i = 0; i < lista.length; i++){
			if(lista[i].equals(escola)){				
				escolaBox.setSelectedIndex(i);
				temEscola = true;
				i = lista.length;
			}
		}

		if(!temEscola){
			escolaBox.setSelectedIndex(lista.length - 1);
			caixaTextoEscolaParceira.setText(aluno.getNomeEscola());
		}

		String serie = aluno.getSerie();

		for(int i = 0; i < series.length; i++){

			if(series[i].equals(serie)){				
				serieBox.setSelectedIndex(i);
				i = serie.length();
			}

		}

		caixaTextoNomePai.setText(aluno.getNomePai());
		caixaTextoProfissaoPai.setText(aluno.getProfissaoPai());
		caixaTextoContatoPai.setText(telefones.get(2));

		caixaTextoNomeMae.setText(aluno.getNomeMae());
		caixaTextoProfissaoMae.setText(aluno.getProfissaoMae());
		caixaTextoContatoMae.setText(telefones.get(1));


		if(aluno.isAutorizacao()){
			autorizacaoBox.setSelected(true);
		} else {
			autorizacaoBox.setSelected(false);

		}

		if(aluno.isTemIrmao()){

			possuiIrmaoBox.setSelected(true);
		} else {
			possuiIrmaoBox.setSelected(false);

		}

		caixaTextoDiaVencimento.setText(String.valueOf(aluno.getDiaVencimento()));
		caixaTextoMensalidade.setText(String.valueOf(aluno.getMensalidade()));

		String end = aluno.getEndereco();
		String rua = "";
		int i = 0;

		while(end.charAt(i) != '#') {
			rua = rua + end.charAt(i);
			i++;
		}

		caixaTextoRua.setText(rua);
		rua = "";
		i++;

		while(end.charAt(i) != '#') {
			rua = rua + end.charAt(i);
			i++;
		}

		caixaTextoNumero.setText(rua);
		rua = "";
		i++;

		while(end.charAt(i) != '#') {
			rua = rua + end.charAt(i);
			i++;
		}

		caixaTextoCompleto.setText(rua);
		rua = "";
		i++;

		while(end.charAt(i) != '#') {
			rua = rua + end.charAt(i);
			i++;
		}

		caixaTextoBairro.setText(rua);
		rua = "";
		i++;

		while(end.charAt(i) != '#') {
			rua = rua + end.charAt(i);
			i++;
		}
		caixaTextoCidade.setText(rua);
		rua = "";
		i++;

		if(i == end.length() ) {

			return;

		} else {

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
				if(i == end.length()){
					break;
				}
			}
			caixaTextoCEP.setText(rua);


		}


	}

	public Aluno getInformacoes(){


		Aluno aluno = null;

		String nome = caixaTextoNome.getText();		 
		String dataNascimento = caixaTextoDataNascimento.getText();
		String endereco = caixaTextoRua.getText() + "#" + caixaTextoNumero.getText()+ "#" + caixaTextoCompleto.getText() + "#" + caixaTextoBairro.getText() + "#" + caixaTextoCidade.getText() + "#" + caixaTextoCEP.getText();
		String cpf = caixaTextoCPF.getText();
		String rg = caixaTextoRG.getText();

		char sexo = ' ';

		if(sexoF.isSelected()){
			sexo = 'F';
		} else if (sexoM.isSelected()) {
			sexo = 'M';		} 

		String alergias = caixaTextoProblemaSaude.getText();
		String planoSaude = caixaTextoPlanoSaude.getText();
		String telefone = caixaTextoTelefone.getText();

		String nomeEscola = (String)this.escolaBox.getSelectedItem();

		if(nomeEscola.equals("outros")){
			nomeEscola = caixaTextoEscolaParceira.getText();
		} 

		String serie = (String)this.serieBox.getSelectedItem();
		String email = caixaTextoEmail.getText();

		String nomeMae = caixaTextoNomeMae.getText();
		String profissaoMae = caixaTextoProfissaoMae.getText();
		String contatoMae = caixaTextoContatoMae.getText();

		String nomePai = caixaTextoNomePai.getText();
		String profissaoPai = caixaTextoProfissaoPai.getText();
		String contatoPai = caixaTextoContatoPai.getText();

		boolean autorizacao = autorizacaoBox.isSelected();
		boolean temIrmao = possuiIrmaoBox.isSelected();

		int diaVencimento = Integer.parseInt(caixaTextoDiaVencimento.getText());
		double desconto = janelaAtualizacaoSelecaoTurma.getMensalidade();

		Vector<String> telefones = new Vector<String>();
		telefones.add(telefone);
		telefones.add(contatoMae);
		telefones.add(contatoPai);


		aluno = new Aluno(nome, this.aluno.getCodigoAluno() , cpf, rg, endereco, sexo, dataNascimento, alergias, nomeEscola
				, serie, nomeMae, profissaoMae, nomePai, profissaoPai, autorizacao, diaVencimento,
				desconto,null, temIrmao, telefones, email, planoSaude, "12/11/1111");

		return aluno;

	}

	class MeuDocument extends PlainDocument{
		int maximo;

		public MeuDocument(int max){
			maximo = max;
		}

		public void insertString(int offs, String str, 
				AttributeSet a) throws BadLocationException{
			if((getLength() + str.length()) <= maximo)
				super.insertString(offs, str, a);
		}
	}
}
