package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import Excecao.SenhaInvalidaException;
import basicas.Atendente;

public class JanelaAtualizarAtendente extends JFrame implements MouseListener{

	private JLabel nome;
	private JTextField caixaTextoNome;
	private JLabel salario;
	private JTextField caixaTextoSalario;
	private JLabel rg;
	private JTextField caixaTextoRG;
	private JLabel cpf;
	private JTextField caixaTextoCPF;
	private JLabel sexo;
	private JRadioButton sexoM;
	private JRadioButton sexoF;
	private JLabel dataNascimento;
	private JTextField caixaTextoDataNascimento;
	private JLabel login;
	private JTextField caixaTextoLogin;
	private JLabel senha;
	private JTextField caixaTextoSenha;
	private JLabel confirmarSenha;
	private JTextField caixaTextoConfirmarSenha;
	private JLabel endereco;
	private JLabel rua;
	private JTextField caixaTextoRua;
	private JLabel numero;
	private JTextField caixaTextoNumero;
	private JLabel cidade;
	private JTextField caixaTextoCidade;
	private JLabel bairro;
	private JTextField caixaTextoBairro;
	private JLabel cep;
	private JTextField caixaTextoCEP;
	private JLabel complemento;
	private JTextField caixaTextoCompleto;
	private JLabel telefone;
	private JTextField caixaTextoTelefone;
	private JLabel email;
	private JTextField caixaTextoEmail;

	private JLabel labelImagem;
	private ImageIcon imagem;
	private JanelaPrincipal janelaPrincipal;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;

	public JanelaAtualizarAtendente(JanelaPrincipal janela, Atendente atendente){
		this.janelaPrincipal = janela;
		this.criarJanela();
		this.passarInformacao(atendente);
	}

	public void criarJanela(){
		this.setTitle("Atualizar Atendente");
		this.setSize(620, 500);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.nome = criarLabel("Nome:*", 30, 30);
		this.caixaTextoNome = criarCaixaTexto(300, 20, 80, 30);

		this.salario = criarLabel("Salrio:*", 430, 30);
		this.caixaTextoSalario = criarCaixaTexto(100, 20, 485, 30);

		this.rg = criarLabel("RG:*", 30, 80);
		this.caixaTextoRG = criarCaixaTexto(100, 20, 80, 80);

		this.cpf = criarLabel("CPF:*", 250, 80);
		this.caixaTextoCPF = criarCaixaTexto(80, 20, 300, 80);

		this.sexo = criarLabel("Sexo:*", 440, 80);
		this.sexoM = this.criarRadioButton("M", 485, 80);
		this.sexoF = this.criarRadioButton("F", 525, 80);

		ButtonGroup grupo = new ButtonGroup();
		grupo.add(sexoM);
		grupo.add(sexoF);
		sexoM.setSelected(true);

		this.dataNascimento = criarLabel("Data de Nascimento:*", 355, 130);
		this.caixaTextoDataNascimento = criarCaixaTexto(100, 20, 485, 130);

		this.login = criarLabel("Login:*", 30, 130);
		this.caixaTextoLogin = criarCaixaTexto(100, 20, 80, 130);

		caixaTextoLogin.setEditable(false);

		/*this.salario = criarLabel("Salrio:", 425, 80);
		this.caixaTextoSalario = criarCaixaTexto(100, 20, 475, 80);*/ 

		this.senha = criarLabel("Senha:*", 30, 160);
		this.caixaTextoSenha = criarCaixaTexto(100, 20, 80, 160); //130

		this.confirmarSenha = criarLabel("Confirme a senha:*", 190, 160);
		this.caixaTextoConfirmarSenha = criarCaixaTexto(100, 20, 310, 160);

		/*this.confirmarSenha = criarLabel("Confirme a senha:", 30, 140);
		this.caixaTextoConfirmarSenha = criarCaixaTexto(130, 20, 150, 140);*/

		this.endereco = criarLabel("Endereo", 30, 210);

		this.rua = criarLabel("Rua:", 30, 240);
		this.caixaTextoRua = criarCaixaTexto(300, 20, 80, 240);

		this.numero = criarLabel("Nmero:", 420, 240);
		this.caixaTextoNumero = criarCaixaTexto(100, 20, 475, 240);

		this.bairro = criarLabel("Bairro:", 30, 270);
		this.caixaTextoBairro = criarCaixaTexto(200, 20, 80, 270);

		this.cidade = criarLabel("Cidade:", 310, 270);
		this.caixaTextoCidade = criarCaixaTexto(215, 20, 360, 270);

		this.cep = criarLabel("CEP:", 30, 300);
		this.caixaTextoCEP = criarCaixaTexto(55, 20, 80, 300);

		this.complemento = criarLabel("Complemento:", 150, 300);
		this.caixaTextoCompleto = criarCaixaTexto(335, 20, 240, 300);

		this.telefone = criarLabel("Telefone:", 30, 350);
		this.caixaTextoTelefone = criarCaixaTexto(100, 20, 100, 350);

		this.email = criarLabel("E-mail:", 230, 350);
		this.caixaTextoEmail = criarCaixaTexto(295, 20, 280, 350);

		cadastrar = criarLabel("Atualizar", 500, 410);
		cadastrar.setFont(new Font("Verdana", Font.BOLD, 13));

		cancelar = criarLabel("Cancelar", 90, 410);
		cancelar.setFont(new Font("Verdana", Font.BOLD, 13));

		criarImagem();
		this.limitarTexto();

		this.setVisible(true);

	}

	public void limitarTexto(){

		caixaTextoRG.setDocument(new MeuDocument(20));
		caixaTextoCPF.setDocument(new MeuDocument(11));
		caixaTextoNome.setDocument(new MeuDocument(80));
		caixaTextoDataNascimento.setDocument(new MeuDocument(10));
		caixaTextoTelefone.setDocument(new MeuDocument(10));
		caixaTextoEmail.setDocument(new MeuDocument(10));
		caixaTextoSalario.setDocument(new MeuDocument(40));
		caixaTextoLogin.setDocument(new MeuDocument(6));
		caixaTextoSenha.setDocument(new MeuDocument(8));

	}

	private void criarImagem() {

		imagem = new ImageIcon("Teste3.jpg");
		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 440, 395);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 30, 395);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);

		criarLabelImagem2(labelImagem, imagem,0,0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setText("");
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.add(radio);
		radio.setSize(35, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = this.checarCampos();

			if(b){
				boolean v = validarCampos();
				if(v){

					Atendente atendente = this.getInformacoes();
					this.janelaPrincipal.getFachada().atualizarAtendente(atendente.getCpf(), atendente);
					JanelaAviso janelaAviso = new JanelaAviso("Funcionrio atualizado com sucesso", 1);
					this.dispose();

				} 
			} else {				
				JanelaAviso janelaAviso = new JanelaAviso("Preecha todos os campos obrigatrios", 1);
			}

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 
		} 
	}

	public boolean checarCampos(){

		if(caixaTextoNome.getText().equals("")
				||caixaTextoCPF.getText().equals("")
				||caixaTextoRG.getText().equals("")
				||caixaTextoDataNascimento.getText().equals("")
				|| caixaTextoLogin.getText().equals("")
				|| caixaTextoSenha.getText().equals("")
				|| caixaTextoConfirmarSenha.getText().equals("")
				|| caixaTextoSalario.getText().equals("")){

			return false;
		} else {

			return true;
		}

	}

	public void passarInformacao(Atendente atendente){

		caixaTextoNome.setText(atendente.getNome());		 
		caixaTextoDataNascimento.setText(atendente.getNascimento());

		String end = atendente.getEndereco();
		String rua = "";
		int i = 0;

		if(i < end.length()){
			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoRua.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoNumero.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoCompleto.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoBairro.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}
			caixaTextoCidade.setText(rua);
			rua = "";
			i++;

			boolean j = true;

			if(i == end.length()){


			} else {
				while(end.charAt(i) != '#' && j == true) {
					rua = rua + end.charAt(i);
					i++;
					if(i == end.length()){
						break;
					}
				}

			}
		}

		caixaTextoCEP.setText(rua);

		caixaTextoCPF.setText(atendente.getCpf());
		caixaTextoRG.setText(atendente.getRg());

		char sexo = atendente.getSexo();

		if(sexo == 'F'){
			sexoF.setSelected(true);
		} else  {
			sexoM.setSelected(true);
		} 

		//	caixaTextoTelefone.setText(atendente.get);
		caixaTextoEmail.setText(atendente.getEmail());
		caixaTextoSalario.setText(String.valueOf(atendente.getSalario()));
		caixaTextoLogin.setText(atendente.getLogin());
		caixaTextoSenha.setText(atendente.getSenha());
		caixaTextoConfirmarSenha.setText(atendente.getSenha());
		caixaTextoTelefone.setText(atendente.getTelefone());

	}

	public Atendente getInformacoes(){

		String nome = caixaTextoNome.getText();
		String rg = caixaTextoRG.getText();
		String cpf = caixaTextoCPF.getText();
		float salario = Float.parseFloat(caixaTextoSalario.getText());
		String endereco = caixaTextoRua.getText() + "#" + caixaTextoNumero.getText()+ "#" + caixaTextoCompleto.getText() + "#" + caixaTextoBairro.getText() + "#" + caixaTextoCidade.getText() + "#" + caixaTextoCEP.getText();
		String telefone = caixaTextoTelefone.getText();
		String email = caixaTextoEmail.getText();
		String dataNascimento = caixaTextoDataNascimento.getText();
		String login = caixaTextoLogin.getText();
		String senha = caixaTextoSenha.getText();
		char sexo = ' ';

		if(sexoF.isSelected()){
			sexo = 'F';
		} else if (sexoM.isSelected()) {
			sexo = 'M';		
		} 



		Atendente atendente = new Atendente(cpf, rg, nome, sexo, dataNascimento, endereco, email, "Atendente", salario, login, senha, telefone);


		return atendente;
	}

	public boolean conferirSenha(String senha, String confirma) throws SenhaInvalidaException{

		if(senha.equals(confirma)){
			return true;
		} else {
			throw new SenhaInvalidaException();
		}


	}


	public void ValidaNumero(JTextField Numero) throws NumberFormatException { 
		long valor; 
		if (Numero.getText().length() != 0){ 
			//try { 
			valor = Long.parseLong(Numero.getText()); 
			/*}catch(NumberFormatException ex){ 
				JOptionPane.showMessageDialog(null, "Esse Campo s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
				Numero.grabFocus(); 
			} */
		} 
	} 

	public boolean validarCampos() {

		boolean validar = true;

		try {
			conferirSenha(caixaTextoSenha.getText(), caixaTextoConfirmarSenha.getText());
		} catch (SenhaInvalidaException e) {
			validar = false;
			JOptionPane.showMessageDialog(null, "Confira a sua senha" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoRG.grabFocus(); 
		}
		try { 
			ValidaNumero(caixaTextoRG);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo RG s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoRG.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoCPF);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo CPF s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoCPF.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoNumero);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Nmero s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoNumero.grabFocus(); 
		} 

		try { 
			ValidaNumero(caixaTextoCEP);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo CEP s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoCEP.grabFocus(); 
		} 


		try { 
			ValidaNumero(caixaTextoTelefone);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Telefone s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoTelefone.grabFocus(); 
		} 

		return validar;


	}
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}

	}

	@Override
	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	// classe personalizada que amplia PlainDocument
	class MeuDocument extends PlainDocument{
		int maximo;

		public MeuDocument(int max){
			maximo = max;
		}

		public void insertString(int offs, String str, 
				AttributeSet a) throws BadLocationException{
			if((getLength() + str.length()) <= maximo)
				super.insertString(offs, str, a);
		}
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}
}
