package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import Excecao.FestivalExistenteException;
import Excecao.ModalidadeExistenteException;
import basicas.Festival;
import basicas.Modalidade;


public class JanelaAtualizarModalidade extends JFrame implements ActionListener, MouseListener{

	private JLabel nome;
	private JTextField caixaTextoNome;
	private JLabel valor;
	private JTextField caixaTextoValor;
	private JanelaPrincipal janelaPrincipal;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;
	private JLabel imagemFundo;
	private ImageIcon imagem;
	
	private Modalidade modalidade;
	
	public JanelaAtualizarModalidade(JanelaPrincipal janela, Modalidade modalidade) {
		
		this.modalidade = modalidade;
		this.janelaPrincipal = janela;
		this.criarJanela();
		this.mostrarInformacao();
	}

	public void criarJanela() {

		this.setTitle("Atualizar Modalidade");
		this.setSize(340, 190);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.nome = criarLabel("Nome:*", 30, 30);
		this.caixaTextoNome = criarCaixaTexto(200, 20, 100, 30);

		this.valor = criarLabel("Valor (R$):*", 30, 60);
		this.caixaTextoValor = criarCaixaTexto(40, 20, 100, 60);

		this.cadastrar = criarLabel("Cadastrar",240, 115);
		this.cadastrar.setFont(new Font("Verdana",Font.BOLD,13));

		this.cancelar = criarLabel("Cancelar", 70, 115);
		this.cancelar.setFont(new Font("Verdana",Font.BOLD,13));

		criarImagem();
		this.setVisible(true);

	}

	private void criarImagem() {


		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 180, 100);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 10, 100);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);
		imagem = new ImageIcon("Teste3.jpg");

		criarLabelImagem2(imagemFundo, imagem,0,0, 620, 840);
		//		criarLabelImagem2(labelImagem, imagem, 0, 0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setText("");
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	private void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = checarCampos();

			if(b == true){

				Modalidade modalidade = getInformacao();

				//try {

					janelaPrincipal.getFachada().atualizarModalidade(modalidade);
					JanelaAviso janelaAviso = new JanelaAviso("Modalidade cadastrada com sucesso", 1);	
					this.dispose();

				/*} catch (ModalidadeExistenteException e) {

					JanelaAviso janelaAviso = new JanelaAviso("Modalidade j cadastrado", 4);	

				}*/

			} else {

				JanelaAviso janelaAviso = new JanelaAviso("Preencha todos os campos obrigatrios *", 1);	

			}



		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 
		}
	}

	public boolean checarCampos(){

		if(caixaTextoNome.getText().equals("")
				|| caixaTextoValor.getText().equals("")){

			return false;
		} else {
			return true;
		}
	}
	
	public void mostrarInformacao(){

		caixaTextoNome.setText(modalidade.getNome());
		caixaTextoNome.setEditable(false);
		caixaTextoValor.setText(String.valueOf(modalidade.getValor()));
	}

	public Modalidade getInformacao(){

		String nome = caixaTextoNome.getText();
		double valor = Double.parseDouble(caixaTextoValor.getText());
		Modalidade mod = new Modalidade(nome, valor);
		return mod;

	}
	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		} 
	}

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}	
}
