package gui;

import gui.JanelaCadastroProfessor.MeuDocument;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;


import Excecao.ProfessoreExistenteException;
import basicas.Atendente;
import basicas.Professor;

public class JanelaAtualizarProfessor extends JFrame implements MouseListener{

	private JLabel nome;
	private JTextField caixaTextoNome;
	private JLabel rg;
	private JTextField caixaTextoRG;
	private JLabel cpf;
	private JTextField caixaTextoCPF;
	private JLabel sexo;
	private JRadioButton sexoM;
	private JRadioButton sexoF;
	private JLabel dataNascimento;
	private JTextField caixaTextoDataNascimento;
	private JLabel horaAula;
	private JTextField caixaTextoHoraAula;
	private JLabel endereco;
	private JLabel rua;
	private JTextField caixaTextoRua;
	private JLabel numero;
	private JTextField caixaTextoNumero;
	private JLabel cidade;
	private JTextField caixaTextoCidade;
	private JLabel bairro;
	private JTextField caixaTextoBairro;
	private JLabel cep;
	private JTextField caixaTextoCEP;
	private JLabel complemento;
	private JTextField caixaTextoCompleto;
	private JLabel telefone;
	private JTextField caixaTextoTelefone;
	private JLabel email;
	private JTextField caixaTextoEmail;

	private JLabel labelImagem;
	private ImageIcon imagem;
	private JanelaPrincipal janelaPrincipal;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;

	private Professor professor;
	public JanelaAtualizarProfessor(JanelaPrincipal janela, Professor p){
		this.professor = p;
		this.janelaPrincipal = janela;
		this.criarJanela();
		this.passarInformacao(professor);
	}

	public void criarJanela(){
		this.setTitle("Atualizar Professor");
		this.setSize(620, 460);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.nome = criarLabel("Nome:*", 30, 30);
		this.caixaTextoNome = criarCaixaTexto(300, 20, 80, 30);

		this.horaAula = criarLabel("Hora Aula (R$):*", 440, 30);
		this.caixaTextoHoraAula = criarCaixaTexto(40, 20, 535, 30);

		this.rg = criarLabel("RG:*", 30, 80);
		this.caixaTextoRG = criarCaixaTexto(100, 20, 80, 80);

		this.cpf = criarLabel("CPF:*", 250, 80);
		this.caixaTextoCPF = criarCaixaTexto(80, 20, 300, 80);

		this.sexo = criarLabel("Sexo:", 440, 80);
		this.sexoM = this.criarRadioButton("M", 485, 80);
		this.sexoF = this.criarRadioButton("F", 525, 80);

		ButtonGroup grupo = new ButtonGroup();
		grupo.add(sexoM);
		grupo.add(sexoF);

		this.dataNascimento = criarLabel("Data de Nascimento:*", 30, 130);
		this.caixaTextoDataNascimento = criarCaixaTexto(70, 20, 160, 130);


		this.endereco = criarLabel("Endereo", 30, 180);

		this.rua = criarLabel("Rua:", 30, 210);
		this.caixaTextoRua = criarCaixaTexto(300, 20, 80, 210);

		this.numero = criarLabel("Nmero:", 420, 210);
		this.caixaTextoNumero = criarCaixaTexto(100, 20, 475, 210);

		this.bairro = criarLabel("Bairro:", 30, 240);
		this.caixaTextoBairro = criarCaixaTexto(200, 20, 80, 240);

		this.cidade = criarLabel("Cidade:", 310, 240);
		this.caixaTextoCidade = criarCaixaTexto(215, 20, 360, 240);

		this.cep = criarLabel("CEP:", 30, 270);
		this.caixaTextoCEP = criarCaixaTexto(55, 20, 80, 270);

		this.complemento = criarLabel("Complemento:", 150, 270);
		this.caixaTextoCompleto = criarCaixaTexto(335, 20, 240, 270);

		this.telefone = criarLabel("Telefone:", 30, 320);
		this.caixaTextoTelefone = criarCaixaTexto(100, 20, 100, 320);

		this.email = criarLabel("E-mail:", 230, 320);
		this.caixaTextoEmail = criarCaixaTexto(295, 20, 280, 320);

		cadastrar = criarLabel("Cadastrar", 500, 380);
		cadastrar.setFont(new Font("Verdana", Font.BOLD, 13));

		cancelar = criarLabel("Cancelar", 90, 380);
		cancelar.setFont(new Font("Verdana", Font.BOLD, 13));

		criarImagem();
		this.limitarTexto();

		this.setVisible(true);

	}

	private void criarImagem() {

		imagem = new ImageIcon("Teste3.jpg");
		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 440, 365);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 30, 365);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);

		criarLabelImagem2(labelImagem, imagem,0,0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setText("");
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.add(radio);
		radio.setSize(35, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = this.checarCampos();

			if(b){

				Professor professor = this.getInformacoes();
				this.janelaPrincipal.getFachada().atualizarProfessor(professor);
				JanelaAviso janelaAviso = new JanelaAviso("Funcionrio atualizado com sucesso", 1);
				this.dispose();



			} else {				
				JanelaAviso janelaAviso = new JanelaAviso("Preecha todos os campos obrigatrios", 1);
			}

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 
		} 
	}

	public boolean checarCampos(){

		if(caixaTextoNome.getText().equals("")
				||caixaTextoCPF.getText().equals("")
				||caixaTextoRG.getText().equals("")
				||caixaTextoDataNascimento.getText().equals("")
				|| caixaTextoHoraAula.getText().equals("")){

			return false;
		} else {

			return true;
		}

	}


	public Professor getInformacoes(){

		String nome = caixaTextoNome.getText();
		String rg = caixaTextoRG.getText();
		String cpf = caixaTextoCPF.getText();
		float horaAula = Float.parseFloat(caixaTextoHoraAula.getText());
		String endereco = caixaTextoRua.getText() + "#" + caixaTextoNumero.getText()+ "#" + caixaTextoCompleto.getText() + "#" + caixaTextoBairro.getText() + "#" + caixaTextoCidade.getText() + "#" + caixaTextoCEP.getText();
		String telefone = caixaTextoTelefone.getText();
		String email = caixaTextoEmail.getText();
		String dataNascimento = caixaTextoDataNascimento.getText();
		char sexo = ' ';

		if(sexoF.isSelected()){
			sexo = 'F';
		} else if (sexoM.isSelected()) {
			sexo = 'M';		
		} 
		Professor prof = new Professor(cpf, rg, nome, sexo, dataNascimento, endereco, email, "Professor", 0, horaAula,telefone);
		return prof;
	}

	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}

	}

	@Override
	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}
	
	public void passarInformacao(Professor prof){

		caixaTextoNome.setText(prof.getNome());		 
		caixaTextoDataNascimento.setText(prof.getNascimento());

		String end = prof.getEndereco();
		String rua = "";
		int i = 0;

		if(i < end.length()){
			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoRua.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoNumero.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoCompleto.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}

			caixaTextoBairro.setText(rua);
			rua = "";
			i++;

			while(end.charAt(i) != '#') {
				rua = rua + end.charAt(i);
				i++;
			}
			caixaTextoCidade.setText(rua);
			rua = "";
			i++;

			boolean j = true;

			if(i == end.length()){


			} else {
				while(end.charAt(i) != '#' && j == true) {
					rua = rua + end.charAt(i);
					i++;
					if(i == end.length()){
						break;
					}
				}

			}
		}

		caixaTextoCEP.setText(rua);

		caixaTextoCPF.setText(prof.getCpf());
		caixaTextoRG.setText(prof.getRg());

		char sexo = prof.getSexo();

		if(sexo == 'F'){
			sexoF.setSelected(true);
		} else  {
			sexoM.setSelected(true);
		} 

		//	caixaTextoTelefone.setText(atendente.get);
		caixaTextoEmail.setText(prof.getEmail());
		caixaTextoHoraAula.setText(String.valueOf(prof.getHora_aula()));
		

	}


	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}
	
	public void limitarTexto(){

		caixaTextoRG.setDocument(new MeuDocument(20));
		caixaTextoCPF.setDocument(new MeuDocument(11));
		caixaTextoNome.setDocument(new MeuDocument(80));
		caixaTextoDataNascimento.setDocument(new MeuDocument(10));
		caixaTextoTelefone.setDocument(new MeuDocument(10));
		caixaTextoEmail.setDocument(new MeuDocument(10));
		caixaTextoHoraAula.setDocument(new MeuDocument(5));


	}

	// classe personalizada que amplia PlainDocument
	class MeuDocument extends PlainDocument{
		int maximo;

		public MeuDocument(int max){
			maximo = max;
		}

		public void insertString(int offs, String str, 
				AttributeSet a) throws BadLocationException{
			if((getLength() + str.length()) <= maximo)
				super.insertString(offs, str, a);
		}
	}
}
