package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import negocio.TurmaExistenteException;
import Excecao.ModalidadeFaltandoException;
import Excecao.ProfessorFaltandoException;
import basicas.Dias;
import basicas.Funcionario;
import basicas.Modalidade;
import basicas.Professor;
import basicas.Turma;

public class JanelaAtualizarTurma extends JFrame implements ActionListener,
ItemListener, MouseListener {

	private JLabel nome;
	private JTextField caixaTextoNome;
	private JLabel sala;
	private JRadioButton salaUm;
	private JRadioButton salaDois;
	private JLabel horario;
	private JLabel segunda;
	private JCheckBox seg;
	private JTextField caixaTextoInicioSegunda;
	private JLabel as1;
	private JTextField caixaTextoTerminoSegunda;
	private JLabel terca;
	private JCheckBox ter;
	private JTextField caixaTextoInicioTerca;
	private JLabel as2;
	private JTextField caixaTextoTerminoTerca;
	private JLabel quarta;
	private JCheckBox qua;
	private JTextField caixaTextoInicioQuarta;
	private JLabel as3;
	private JTextField caixaTextoTerminoQuarta;
	private JLabel quinta;
	private JCheckBox qui;
	private JTextField caixaTextoInicioQuinta;
	private JLabel as4;
	private JTextField caixaTextoTerminoQuinta;
	private JLabel sexta;
	private JCheckBox sex;
	private JTextField caixaTextoInicioSexta;
	private JLabel as5;
	private JTextField caixaTextoTerminoSexta;
	private JLabel sabado;
	private JCheckBox sab;
	private JTextField caixaTextoInicioSabado;
	private JLabel as6;
	private JTextField caixaTextoTerminoSabado;
	private JLabel modalidade;
	private JComboBox modalidades;
	private JLabel faixaEtaria;
	private JTextField caixaTextoIdadeMinima;
	private JLabel a;
	private JTextField caixaTextoIdadeMaxima;
	private JLabel professor;
	private JComboBox professores;

	private JLabel labelImagem;
	private ImageIcon imagem;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;

	private JanelaPrincipal janelaPrincipal;

	private Vector<Modalidade> vetorModalidade;
	private Vector<Professor> vetorProfessor;


	private Turma turma;

	public JanelaAtualizarTurma(JanelaPrincipal janelaPrincipal, Turma turma) {
		this.turma = turma;
		this.janelaPrincipal = janelaPrincipal;
		this.criarJanela();
		mostrarInformacao();
	}

	public void criarJanela() {

		this.setTitle("Atualizar Turma");
		this.setSize(480, 400);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.nome = criarLabel("Nome:", 30, 30);
		this.caixaTextoNome = criarCaixaTexto(150, 20, 80, 30);

		this.sala = criarLabel("Sala:", 297, 30);
		salaUm = this.criarRadioButton("1", 337, 30);
		salaUm.setSelected(true);
		salaDois = this.criarRadioButton("2", 377, 30);

		ButtonGroup grupo = new ButtonGroup();
		grupo.add(salaUm);
		grupo.add(salaDois);

		this.horario = criarLabel("Horrio:", 30, 80);

		this.segunda = criarLabel("Segunda", 30, 110);
		this.seg = criarCheckBox(87, 110);
		this.seg.addItemListener(this);
		this.caixaTextoInicioSegunda = criarCaixaTexto(40, 20, 120, 110);
		this.caixaTextoInicioSegunda.setEnabled(false);
		this.as1 = criarLabel("s", 165, 110);
		this.caixaTextoTerminoSegunda = criarCaixaTexto(40, 20, 185, 110);
		this.caixaTextoTerminoSegunda.setEnabled(false);

		this.terca = criarLabel("Tera", 30, 140);
		this.ter = criarCheckBox(87, 140);
		this.ter.addItemListener(this);
		this.caixaTextoInicioTerca = criarCaixaTexto(40, 20, 120, 140);
		this.caixaTextoInicioTerca.setEnabled(false);
		this.as2 = criarLabel("s", 165, 140);
		this.caixaTextoTerminoTerca = criarCaixaTexto(40, 20, 185, 140);
		this.caixaTextoTerminoTerca.setEnabled(false);

		this.quarta = criarLabel("Quarta", 30, 170);
		this.qua = criarCheckBox(87, 170);
		this.qua.addItemListener(this);
		this.caixaTextoInicioQuarta = criarCaixaTexto(40, 20, 120, 170);
		this.caixaTextoInicioQuarta.setEnabled(false);
		this.as3 = criarLabel("s", 165, 170);
		this.caixaTextoTerminoQuarta = criarCaixaTexto(40, 20, 185, 170);
		this.caixaTextoTerminoQuarta.setEnabled(false);

		this.quinta = criarLabel("Quinta", 240, 110);
		this.qui = criarCheckBox(297, 110);
		this.qui.addItemListener(this);
		this.caixaTextoInicioQuinta = criarCaixaTexto(40, 20, 330, 110);
		this.caixaTextoInicioQuinta.setEnabled(false);
		this.as4 = criarLabel("s", 375, 110);
		this.caixaTextoTerminoQuinta = criarCaixaTexto(40, 20, 395, 110);
		this.caixaTextoTerminoQuinta.setEnabled(false);

		this.sexta = criarLabel("Sexta", 240, 140);
		this.sex = criarCheckBox(297, 140);
		this.sex.addItemListener(this);
		this.caixaTextoInicioSexta = criarCaixaTexto(40, 20, 330, 140);
		this.caixaTextoInicioSexta.setEnabled(false);
		this.as5 = criarLabel("s", 375, 140);
		this.caixaTextoTerminoSexta = criarCaixaTexto(40, 20, 395, 140);
		this.caixaTextoTerminoSexta.setEnabled(false);

		this.sabado = criarLabel("Sbado", 240, 170);
		this.sab = criarCheckBox(297, 170);
		this.sab.addItemListener(this);
		this.caixaTextoInicioSabado = criarCaixaTexto(40, 20, 330, 170);
		this.caixaTextoInicioSabado.setEnabled(false);
		this.as6 = criarLabel("s", 375, 170);
		this.caixaTextoTerminoSabado = criarCaixaTexto(40, 20, 395, 170);
		this.caixaTextoTerminoSabado.setEnabled(false);

		this.faixaEtaria = criarLabel("Faixa Etria", 30, 220);
		this.caixaTextoIdadeMinima = criarCaixaTexto(20, 20, 120, 220);
		this.a = criarLabel("a", 145, 220);
		this.caixaTextoIdadeMaxima = criarCaixaTexto(20, 20, 165, 220);

		this.modalidade = criarLabel("Modalidade", 30, 270);

		vetorModalidade = this.janelaPrincipal.getFachada().gerarRelatorioModalidade();

		int tamanhoVetor = vetorModalidade.size();
		String[] arrayModalidades = new String[tamanhoVetor];

		for(int i = 0; i < tamanhoVetor; i++){

			arrayModalidades[i] = vetorModalidade.get(i).getNome();
		}

		this.modalidades = criarComboBox(arrayModalidades, 130, 20, 100, 270);
		modalidades.addActionListener(this);


		vetorProfessor = this.janelaPrincipal.getFachada().gerarRelatorioProfessor();
		int tam = vetorProfessor.size();

		String[] arrayProfessor = new String[tam];

		for(int i = 0; i < tam; i++){

			arrayProfessor[i] = vetorProfessor.get(i).getNome();
		}


		this.professor = criarLabel("Professor", 240, 270);
		this.professores = criarComboBox(arrayProfessor, 150, 20, 300, 270);
		professores.addActionListener(this);

		//480 400

		cadastrar = criarLabel("Atualizar", 370, 320);
		cadastrar.setFont(new Font("Verdana", Font.BOLD, 13));

		cancelar = criarLabel("Cancelar", 90, 320);
		cancelar.setFont(new Font("Verdana", Font.BOLD, 13));
		criarImagem();

		this.setVisible(true);

	}

	private void criarImagem() {


		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 310, 305);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 30, 305);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);

		imagem = new ImageIcon("Teste3.jpg");
		criarLabelImagem2(labelImagem, imagem, 0, 0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x,
			int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x, y);
		this.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao) {
		JLabel label = new JLabel(nome);
		Font fonte = new Font("Verdana", 11, 11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(90, 20);
		label.setLocation(xPosicao, yPosicao);
		this.add(label);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao,
			int yPosicao) {
		JTextField caixaTexto = new JTextField();
		caixaTexto.setText("");
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		this.add(caixaTexto);
		return caixaTexto;
	}

	public JCheckBox criarCheckBox(int xPosicao, int yPosicao) {
		JCheckBox box = new JCheckBox();
		this.add(box);
		box.setLayout(null);
		box.setSize(20, 20);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}

	public JComboBox criarComboBox(String[] texto, int xTamanho, int yTamanho, int xPosicao, int yPosicao) {
		JComboBox box = new JComboBox(texto);
		this.add(box);
		box.setSize(xTamanho, yTamanho);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}

	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.add(radio);
		radio.setSize(35, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	public void mouseClicked(MouseEvent arg0) {

		if (arg0.getComponent() == botaoOk) {

			boolean b = checarCampos();

			if(b){

				try {

					this.turma = this.getInformacoes();

					this.janelaPrincipal.getFachada().atualizarTurma(this.turma);
					this.alocarDias(Integer.parseInt(turma.getCodigoTurma()));
					JanelaAviso janelaAviso = new JanelaAviso("Turma atualizada com sucesso", 1);
					this.dispose();



				} catch (ModalidadeFaltandoException e) {

					new JanelaAviso("Selecione a modalidade correspondente", 1);

				} catch (ProfessorFaltandoException e) {

					new JanelaAviso("Selecione o professor correspondente", 1);

				}



			} else {

				new JanelaAviso("Preecha todos os campos obrigatrios",1);

			}



		} else if (arg0.getComponent() == botaoCancelar) {

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza(
			"Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if (a == 0) { // yes
				this.dispose();
			}

		}

	}

	/*private void verificarCamposInvalidos() throws y{

		Integer.parseInt(caixaTextoIdadeMinima.getText());
		Integer.parseInt(caixaTextoIdadeMaxima.getText());
	}*/

	private Turma getInformacoes() throws ModalidadeFaltandoException, ProfessorFaltandoException {

		String nome = caixaTextoNome.getText();

		int sala = 0;
		if(salaUm.isSelected()){
			sala = 1;
		} else {
			sala = 2;
		}

		int idadeMin = 0;
		int idadeMax  = 0;

		idadeMin = Integer.parseInt(caixaTextoIdadeMinima.getText());

		try{
			idadeMax = Integer.parseInt(caixaTextoIdadeMaxima.getText());

		} catch (Exception e) {
			idadeMax = 0;
		}

		String modalidade = modalidades.getSelectedItem().toString();
		String professor = professores.getSelectedItem().toString();

		if(modalidade.equalsIgnoreCase("Modalidades")){

			throw new ModalidadeFaltandoException();

		}

		if(professor.equalsIgnoreCase("Professor(a)")){

			throw new ProfessorFaltandoException();
		}

		int indexProf = professores.getSelectedIndex();

		Turma turma = new Turma(this.turma.getCodigoTurma(), modalidade, vetorProfessor.get(indexProf).getCpf(),nome, idadeMin, idadeMax,sala);
		return turma;


	}

	public void alocarDias(int turma){

		this.janelaPrincipal.getFachada().removerDias("Segunda", turma);
		this.janelaPrincipal.getFachada().removerDias("Tera", turma);
		this.janelaPrincipal.getFachada().removerDias("Quarta", turma);
		this.janelaPrincipal.getFachada().removerDias("Quinta", turma);
		this.janelaPrincipal.getFachada().removerDias("Sexta", turma);
		this.janelaPrincipal.getFachada().removerDias("Sbado", turma);

		if(seg.isSelected()){

			String horaInicial = caixaTextoInicioSegunda.getText();

			int horaInicio1 = Integer.parseInt(horaInicial.substring(0,2));
			int minInicio1 = Integer.parseInt(horaInicial.substring(3,5));

			String horaFim = caixaTextoTerminoSegunda.getText();
			int horaInicio2 = Integer.parseInt(horaFim.substring(0,2));
			int minInicio2 = Integer.parseInt(horaFim.substring(3,5));

			Dias dia = new Dias("Segunda", turma,horaInicio1, 
					minInicio1, horaInicio2, minInicio2);

			this.janelaPrincipal.getFachada().inserirDias(dia);

		}

		if(ter.isSelected()){

			String horaInicial = caixaTextoInicioTerca.getText();

			int horaInicio1 = Integer.parseInt(horaInicial.substring(0,2));
			int minInicio1 = Integer.parseInt(horaInicial.substring(3,5));

			String horaFim = caixaTextoTerminoTerca.getText();
			int horaInicio2 = Integer.parseInt(horaFim.substring(0,2));
			int minInicio2 = Integer.parseInt(horaFim.substring(3,5));

			Dias dia = new Dias("Tera", turma, horaInicio1, 
					minInicio1, horaInicio2, minInicio2);
			this.janelaPrincipal.getFachada().inserirDias(dia);

		}
		if(qua.isSelected()){

			String horaInicial = caixaTextoInicioQuarta.getText();

			int horaInicio1 = Integer.parseInt(horaInicial.substring(0,2));
			int minInicio1 = Integer.parseInt(horaInicial.substring(3,5));

			String horaFim = caixaTextoTerminoQuarta.getText();
			int horaInicio2 = Integer.parseInt(horaFim.substring(0,2));
			int minInicio2 = Integer.parseInt(horaFim.substring(3,5));


			Dias dia = new Dias("Quarta", turma,horaInicio1, 
					minInicio1, horaInicio2, minInicio2);
			this.janelaPrincipal.getFachada().inserirDias(dia);

		}
		if(qui.isSelected()){

			String horaInicial = caixaTextoInicioQuinta.getText();

			int horaInicio1 = Integer.parseInt(horaInicial.substring(0,2));
			int minInicio1 = Integer.parseInt(horaInicial.substring(3,5));

			String horaFim = caixaTextoTerminoQuinta.getText();
			int horaInicio2 = Integer.parseInt(horaFim.substring(0,2));
			int minInicio2 = Integer.parseInt(horaFim.substring(3,5));


			Dias dia = new Dias("Quinta", turma,horaInicio1, 
					minInicio1, horaInicio2, minInicio2);

			this.janelaPrincipal.getFachada().inserirDias(dia);
		}
		if(sex.isSelected()){

			String horaInicial = caixaTextoInicioSexta.getText();

			int horaInicio1 = Integer.parseInt(horaInicial.substring(0,2));
			int minInicio1 = Integer.parseInt(horaInicial.substring(3,5));

			String horaFim = caixaTextoTerminoSexta.getText();
			int horaInicio2 = Integer.parseInt(horaFim.substring(0,2));
			int minInicio2 = Integer.parseInt(horaFim.substring(3,5));


			Dias dia = new Dias("Sexta", turma,horaInicio1, 
					minInicio1, horaInicio2, minInicio2);

			this.janelaPrincipal.getFachada().inserirDias(dia);
		}

		if(sab.isSelected()){

			String horaInicial = caixaTextoInicioSabado.getText();
			int horaInicio1 = horaInicial.charAt(0) + horaInicial.charAt(1);
			int minInicio1 = horaInicial.charAt(3) + horaInicial.charAt(4);

			String horaFim = caixaTextoTerminoSabado.getText();
			int horaInicio2 = horaFim.charAt(0) + horaFim.charAt(1);
			int minInicio2 = horaFim.charAt(3) + horaFim.charAt(4);


			Dias dia = new Dias("Sbado", turma,horaInicio1, 
					minInicio1, horaInicio2, minInicio2);

			this.janelaPrincipal.getFachada().inserirDias(dia);
		}
	}


	public boolean checarCampos(){

		if(caixaTextoNome.getText().equals("")
				|| caixaTextoIdadeMinima.getText().equals("")){

			return false;

		} else {
			return true;
		}

	}


	public void actionPerformed(ActionEvent e) {

		/*
		 * JComboBox cb = (JComboBox)e.getSource(); String petName =
		 * (String)cb.getSelectedItem(); System.out.println("alou");
		 */
	}

	/*
	 * public static void main(String[] args) { new JanelaCadastroTurma(); }
	 */

	public void itemStateChanged(ItemEvent e) {
		if (this.seg.isSelected()) {
			this.caixaTextoInicioSegunda.setEnabled(true);
			this.caixaTextoTerminoSegunda.setEnabled(true);
		} else {
			this.caixaTextoInicioSegunda.setText("");
			this.caixaTextoTerminoSegunda.setText("");
			this.caixaTextoInicioSegunda.setEnabled(false);
			this.caixaTextoTerminoSegunda.setEnabled(false);
		}

		if (this.ter.isSelected()) {
			this.caixaTextoInicioTerca.setEnabled(true);
			this.caixaTextoTerminoTerca.setEnabled(true);
		} else {
			this.caixaTextoInicioTerca.setText("");
			this.caixaTextoTerminoTerca.setText("");
			this.caixaTextoInicioTerca.setEnabled(false);
			this.caixaTextoTerminoTerca.setEnabled(false);
		}

		if (this.qua.isSelected()) {
			this.caixaTextoInicioQuarta.setEnabled(true);
			this.caixaTextoTerminoQuarta.setEnabled(true);
		} else {
			this.caixaTextoInicioQuarta.setText("");
			this.caixaTextoTerminoQuarta.setText("");
			this.caixaTextoInicioQuarta.setEnabled(false);
			this.caixaTextoTerminoQuarta.setEnabled(false);
		}

		if (this.qui.isSelected()) {
			this.caixaTextoInicioQuinta.setEnabled(true);
			this.caixaTextoTerminoQuinta.setEnabled(true);
		} else {
			this.caixaTextoInicioQuinta.setText("");
			this.caixaTextoTerminoQuinta.setText("");
			this.caixaTextoInicioQuinta.setEnabled(false);
			this.caixaTextoTerminoQuinta.setEnabled(false);
		}

		if (this.sex.isSelected()) {
			this.caixaTextoInicioSexta.setEnabled(true);
			this.caixaTextoTerminoSexta.setEnabled(true);
		} else {
			this.caixaTextoInicioSexta.setText("");
			this.caixaTextoTerminoSexta.setText("");
			this.caixaTextoInicioSexta.setEnabled(false);
			this.caixaTextoTerminoSexta.setEnabled(false);
		}

		if (this.sab.isSelected()) {
			this.caixaTextoInicioSabado.setEnabled(true);
			this.caixaTextoTerminoSabado.setEnabled(true);
		} else {
			this.caixaTextoInicioSabado.setText("");
			this.caixaTextoTerminoSabado.setText("");
			this.caixaTextoInicioSabado.setEnabled(false);
			this.caixaTextoTerminoSabado.setEnabled(false);
		}

	}

	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		} 

	}

	@Override
	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	public void mostrarInformacao(){

		this.caixaTextoNome.setText(turma.getNome());
		this.caixaTextoIdadeMinima.setText(String.valueOf(turma.getIdadeMinima()));

		if(turma.getIdadeMaxima() != 0){
			caixaTextoIdadeMaxima.setText(String.valueOf(turma.getIdadeMaxima()));
		}

		Vector<Dias> dias = this.janelaPrincipal.getFachada().consultarDiasPorCodigoTurma(turma.getCodigoTurma());
		int t = dias.size();

		for (int i = 0; i < t; i++) {

			if(dias.get(i).getDia().equalsIgnoreCase("Segunda")){
				
				seg.setSelected(true);

				if(dias.get(i).getMinutoInicio() == 0){
					
				caixaTextoInicioSegunda.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio() + '0');

				} else {
					caixaTextoInicioSegunda.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio());

				}

				if(dias.get(i).getMinutoFinal() == 0){

					caixaTextoTerminoSegunda.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal() + '0');

				} else {

					caixaTextoTerminoSegunda.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal());

				}


			} else if(dias.get(i).getDia().equalsIgnoreCase("Tera")){

				ter.setSelected(true);

				if(dias.get(i).getMinutoInicio() == 0){

					caixaTextoInicioTerca.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio() + '0');

				} else {
					caixaTextoInicioTerca.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio());

				}

				if(dias.get(i).getMinutoFinal() == 0){

					caixaTextoTerminoTerca.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal() + '0');

				} else {

					caixaTextoTerminoTerca.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal());

				}


			} else if(dias.get(i).getDia().equalsIgnoreCase("Quarta")){

				qua.setSelected(true);


				if(dias.get(i).getMinutoInicio() == 0){

					caixaTextoInicioQuarta.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio() + '0');

				} else {
					caixaTextoInicioQuarta.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio());

				}

				if(dias.get(i).getMinutoFinal() == 0){

					caixaTextoTerminoQuarta.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal() + '0');

				} else {

					caixaTextoTerminoQuarta.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal());

				}





			} else if(dias.get(i).getDia().equalsIgnoreCase("Quinta")){

				qui.setSelected(true);

				if(dias.get(i).getMinutoInicio() == 0){

					caixaTextoInicioQuinta.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio() + '0');

				} else {
					caixaTextoInicioQuinta.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio());

				}

				if(dias.get(i).getMinutoFinal() == 0){

					caixaTextoTerminoQuinta.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal() + '0');

				} else {

					caixaTextoTerminoQuinta.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal());

				}


			} else if(dias.get(i).getDia().equalsIgnoreCase("Sexta")){
				sex.setSelected(true);

				if(dias.get(i).getMinutoInicio() == 0){

					caixaTextoInicioSexta.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio() + '0');

				} else {
					caixaTextoInicioSexta.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio());

				}

				if(dias.get(i).getMinutoFinal() == 0){

					caixaTextoTerminoSexta.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal() + '0');

				} else {

					caixaTextoTerminoSexta.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal());

				}



			} else if(dias.get(i).getDia().equalsIgnoreCase("Sbado")){
				sab.setSelected(true);

				if(dias.get(i).getMinutoInicio() == 0){

					caixaTextoInicioSabado.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio() + '0');

				} else {
					caixaTextoInicioSabado.setText(dias.get(i).getHoraInicio() + ":" + dias.get(i).getMinutoInicio());

				}

				if(dias.get(i).getMinutoFinal() == 0){

					caixaTextoTerminoSabado.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal() + '0');

				} else {

					caixaTextoTerminoSabado.setText(dias.get(i).getHoraFinal() + ":" + dias.get(i).getMinutoFinal());

				}

			} 

			String prof = turma.getCpfProfessor();
			Vector<Funcionario> p = this.janelaPrincipal.getFachada().consultarFuncionarioPorCPF(prof);
			for(int j = 0; j < vetorProfessor.size(); j++){

				if(vetorProfessor.get(j).getNome().equals(p.get(0).getNome())){				
				professores.setSelectedIndex(j);
					j = vetorProfessor.size();
				}

			}
			
			String mod = turma.getNomeModalidade();
			for(int j = 0; j < vetorModalidade.size(); j++){

				if(vetorModalidade.get(j).getNome().equals(mod)){				
					modalidades.setSelectedIndex(j);
					j = vetorModalidade.size();
				}

			}
		}
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

}
