package gui;

import java.awt.Dimension;

import javax.swing.*;

public class JanelaBuscaRemocao extends JFrame{
	
	private JLabel texto;
	private JTextField caixaTexto;
	
	public JanelaBuscaRemocao(String nome){
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.criarJanela(nome);
	}
	
	public void criarJanela(String nome){
		this.setTitle("Remover " + nome);
		this.setSize(400, 180);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();
		String text = "Informe o nome do " + nome + " a ser removido:";
		this.texto = criarLabel(text, (this.getWidth() - 270) / 2, 30);
		this.caixaTexto = criarCaixaTexto(320, 20, (this.getWidth() - 325) / 2, 60);
		
		this.setVisible(true);
	}
	
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		label.setLayout(null);
		label.setSize(270, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}
	
	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}
	
}
