package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import Excecao.DespesaExistenteException;
import basicas.Despesa;

public class JanelaCadastrarDespesa extends JFrame implements ActionListener, MouseListener{

	private JLabel empresa;
	private JTextField caixaTextoEmpresa;
	private JLabel valor;
	private JTextField caixaTextoValor;
	private JLabel vencimento;
	private JTextField caixaTextoDataVencimento;
	private JLabel pagamento;
	private JTextField caixaTextoDataPagamento;
	/*private JLabel barraData1;
	private JTextField caixaTextoVencimentoMes;
	private JLabel barraData2;*/
	//private JTextField caixaTextoVencimentoAno;
	private JLabel status;
	private JRadioButton radioPago;
	private JRadioButton radioNaoPago;
	private JanelaPrincipal janela;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;
	private JLabel imagemFundo;
	private ImageIcon imagem;

	public JanelaCadastrarDespesa(JanelaPrincipal janela) {
		this.janela = janela;
		this.criarJanela();
	}

	public void criarJanela() {

		this.setTitle("Cadastrar Despesa");
		this.setSize(460, 260);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.empresa = criarLabel("Empresa beneficiada:*", 30, 30);
		this.caixaTextoEmpresa = criarCaixaTexto(265, 20, 160, 30);

		this.vencimento = criarLabel("Data de Vencimento:*", 30, 80); //posicao x e y
		this.caixaTextoDataVencimento = criarCaixaTexto(70, 20, 155, 80); // tamanho x, y, posicao x, y

		this.pagamento = criarLabel("Data de Pagamento:", 230, 80);
		this.caixaTextoDataPagamento = criarCaixaTexto(70, 20, 355, 80);

		this.valor = criarLabel("Valor (R$):*", 30, 130);
		this.caixaTextoValor = criarCaixaTexto(80, 20, 100, 130);

		/*this.barraData1 = criarLabel("/", 10, yTamanho, 155, 110);
		this.add(this.barraData1);
		this.caixaTextoVencimentoMes = criarCaixaTexto(40, yTamanho, 165, 110);
		this.add(this.caixaTextoVencimentoMes);
		this.barraData2 = criarLabel("/", 10, yTamanho, 210, 110);
		this.add(this.barraData2);*/
		//this.caixaTextoVencimentoAno = criarCaixaTexto(40, yTamanho, 220, 110);

		this.status = criarLabel("Pago:", 230, 130);
		this.radioPago = criarRadioButton("Sim", 50, 20, 270, 130); //40
		this.add(this.radioPago);
		this.radioNaoPago = criarRadioButton("No", 50, 20, 320, 130); //60
		this.add(this.radioNaoPago);
		ButtonGroup grupo = new ButtonGroup();
		grupo.add(radioPago);
		grupo.add(radioNaoPago);

		this.cadastrar = criarLabel("Cadastrar",300, 190);
		this.cadastrar.setFont(new Font("Verdana",Font.BOLD,13));

		this.cancelar = criarLabel("Cancelar", 80, 190);
		this.cancelar.setFont(new Font("Verdana",Font.BOLD,13));


		this.criarImagem();
		this.limitarTexto();

		this.setVisible(true);

	}

	private void criarImagem() {


		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 380, 170);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 20, 170);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);
		imagem = new ImageIcon("Teste3.jpg");

		criarLabelImagem2(imagemFundo, imagem,0,0, 620, 840);
		//		criarLabelImagem2(labelImagem, imagem, 0, 0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(150, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		caixaTexto.setText("");
		this.add(caixaTexto);
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	private JRadioButton criarRadioButton(String nome, int xTamanho, int yTamanho, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		radio.setLayout(null);
		radio.setSize(xTamanho, yTamanho);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	private void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub

	}

	public boolean checarCampos(){

		if(caixaTextoEmpresa.getText().equals("")
				|| caixaTextoDataVencimento.getText().equals("")
				|| caixaTextoValor.getText().equals("")){

			return false;

		} else {

			return true;
		}

	}
	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = checarCampos();
			
			if(b){
				
				/*boolean v = validarCampos();
				
				if(v){*/
					
					Despesa despesa = getInformacoes();

					try {

						this.janela.getFachada().inserirDespesa(despesa);
						JanelaAviso janelaAviso = new JanelaAviso("Despesa cadastrada com sucesso", 1);

						this.dispose();

					} catch (DespesaExistenteException e) {
						JanelaAviso janelaAviso = new JanelaAviso("Despesa j existente", 1);

					}
			//	}

			} else {
				JanelaAviso janelaAviso = new JanelaAviso("Preencha todos os campos obrgatrios", 1);
			}

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 
		}
	}

	public Despesa getInformacoes(){

		Despesa despesa = null;

		String empresa = caixaTextoEmpresa.getText();
		String dataVencimento = caixaTextoDataVencimento.getText();
		String dataPagamento = caixaTextoDataPagamento.getText();
		float valor = Float.parseFloat(caixaTextoValor.getText());
		despesa = new Despesa("null", this.janela.getLogin(), dataVencimento, dataPagamento, valor, empresa);

		return despesa;


	}

	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		} 
	}
	
/*	public boolean validarCampos() {

		boolean validar = true;
		
		try { 
			ValidaNumero(caixaTextoValor);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Valor s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoValor.grabFocus(); 
		} 
		
		return validar;
	}*/
	
	public void ValidaNumero(JTextField Numero) throws NumberFormatException { 
		long valor; 
		if (Numero.getText().length() != 0){ 
			//try { 
			valor = Long.parseLong(Numero.getText()); 
			/*}catch(NumberFormatException ex){ 
				JOptionPane.showMessageDialog(null, "Esse Campo s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
				Numero.grabFocus(); 
			} */
		} 
	} 

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void limitarTexto(){

		caixaTextoDataPagamento.setDocument(new MeuDocument(10));
		caixaTextoDataVencimento.setDocument(new MeuDocument(10));
		caixaTextoEmpresa.setDocument(new MeuDocument(30));
	}

	// classe personalizada que amplia PlainDocument
	class MeuDocument extends PlainDocument{
		int maximo;

		public MeuDocument(int max){
			maximo = max;
		}

		public void insertString(int offs, String str, 
				AttributeSet a) throws BadLocationException{
			if((getLength() + str.length()) <= maximo)
				super.insertString(offs, str, a);
		}
	}

}
