package gui;


import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import Excecao.FestivalExistenteException;
import basicas.Festival;


public class JanelaCadastrarFestival extends JFrame implements MouseListener {

	private JanelaPrincipal janelaPrincipal;
	//private JLabel codigo;
	private JLabel nome;
	private JLabel data;
	private JLabel horario;
	private JLabel lotacao;
	private JLabel local;

	//private JTextField caixaCodigo;
	private JTextField caixaNome;
	private JTextField caixaData;
	private JTextField caixaHorario;
	private JTextField caixaLotacao;
	private JTextField caixaLocal;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;
	private JLabel imagemFundo;

	private JButton cadastrarDanca;
	private ImageIcon imagem;


	public JanelaCadastrarFestival(JanelaPrincipal janela) {

		this.janelaPrincipal = janela;
		criarJanela();	
	}

	public void criarJanela(){

		this.setTitle("Cadastrar Festival");
		this.setSize(430, 300);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.nome = criarLabel("Nome:*", 30, 30);
		//this.codigo = criarLabel("Cdigo:", 300, 30);
		this.data = criarLabel("Data:", 30, 80);
		this.horario = criarLabel("Horrio:", 180, 80);
		this.local = criarLabel("Local:", 30, 130);
		this.lotacao = criarLabel("Lotao:", 30, 180);

		//this.caixaCodigo = criarCaixaTexto(50, 20, 350, 30);
		this.caixaNome = criarCaixaTexto(200, 20, 80, 30);
		this.caixaData = criarCaixaTexto(70, 20, 80, 80);
		this.caixaHorario = criarCaixaTexto(70, 20, 240, 80);
		this.caixaLotacao = criarCaixaTexto(40, 20, 90, 180);
		this.caixaLocal = criarCaixaTexto(320, 20, 80, 130);

		this.cadastrar = criarLabel("Cadastrar",330, 225);
		this.cadastrar.setFont(new Font("Verdana",Font.BOLD,13));

		this.cancelar = criarLabel("Cancelar", 90, 225);
		this.cancelar.setFont(new Font("Verdana",Font.BOLD,13));

		criarImagem();
		limitarTexto();

		this.setVisible(true);


	}

	private void criarImagem() {


		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 270, 210);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 30, 210);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);
		imagem = new ImageIcon("Teste3.jpg");

		criarLabelImagem2(imagemFundo, imagem,0,0, 620, 840);
		//		criarLabelImagem2(labelImagem, imagem, 0, 0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao) {
		JLabel label = new JLabel(nome);
		Font fonte = new Font("Verdana", 11, 11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(90, 20);
		label.setLocation(xPosicao, yPosicao);
		this.add(label);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao,
			int yPosicao) {
		JTextField caixaTexto = new JTextField();
		caixaTexto.setText("");
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		this.add(caixaTexto);
		return caixaTexto;
	}

	public JCheckBox criarCheckBox(int xPosicao, int yPosicao) {
		JCheckBox box = new JCheckBox();
		this.add(box);
		box.setLayout(null);
		box.setSize(20, 20);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}

	public JComboBox criarComboBox(String[] texto, int xPosicao, int yPosicao) {
		JComboBox box = new JComboBox(texto);
		this.add(box);
		box.setSize(100, 20);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}

	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.add(radio);
		radio.setSize(35, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}


	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = checarCampos();

			if(b == true){

				boolean v = validarCampos();

				if(v){

					Festival festival = getInformacoes();

					try {

						janelaPrincipal.getFachada().inserirFestival(festival);
						JanelaAviso janelaAviso = new JanelaAviso("Festival cadastrado com sucesso", 1);	
						this.dispose();
					} catch (FestivalExistenteException e) {

						JanelaAviso janelaAviso = new JanelaAviso("Festival j cadastrado", 4);	

					}

				}


			} else {

				JanelaAviso janelaAviso = new JanelaAviso("Preencha todos os campos obrigatorios *", 4);	

			}

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 
		}
	}

	private Festival getInformacoes() {

		String nome = caixaNome.getText();
		String data = caixaData.getText();
		String horario = caixaHorario.getText();
		int lotacao;
		try{
			lotacao = Integer.parseInt(caixaLotacao.getText()) ;

		} catch (Exception e) {
			lotacao = 0 ;
		}
		
		String local = caixaLocal.getText();

		Festival festival = new Festival("null", nome, data,horario,lotacao,local);
		return festival;
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		} 
	}

	public boolean validarCampos() {

		boolean validar = true;

		try { 
			ValidaNumero(caixaLotacao);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Lotao s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaLotacao.grabFocus(); 
		} 

		return validar;
	}

	public void ValidaNumero(JTextField Numero) throws NumberFormatException { 
		long valor; 
		if (Numero.getText().length() != 0){ 
			//try { 
			valor = Long.parseLong(Numero.getText()); 
			/*}catch(NumberFormatException ex){ 
			JOptionPane.showMessageDialog(null, "Esse Campo s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			Numero.grabFocus(); 
		} */
		} 
	} 

	public void limitarTexto(){

		caixaData.setDocument(new MeuDocument(10));
		caixaHorario.setDocument(new MeuDocument(5));
		caixaLocal.setDocument(new MeuDocument(30));
		caixaLotacao.setDocument(new MeuDocument(5));
		caixaNome.setDocument(new MeuDocument(50));
	}

	public boolean checarCampos() {

		if( caixaNome.getText().equalsIgnoreCase("")){
			return false;
		} else {
			return true;
		}

	}

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}
}

//classe personalizada que amplia PlainDocument
class MeuDocument extends PlainDocument{
	int maximo;

	public MeuDocument(int max){
		maximo = max;
	}

	public void insertString(int offs, String str, 
			AttributeSet a) throws BadLocationException{
		if((getLength() + str.length()) <= maximo)
			super.insertString(offs, str, a);
	}
}

