package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;


import Excecao.DancaExistenteException;
import basicas.Danca;


public class JanelaCadastroDanca extends JFrame implements ActionListener, MouseListener{

	private JLabel musica;
	private JTextField caixaTextoMusica;
	private JLabel valor;
	private JTextField caixaTextoValor;
	private JButton escolherAlunos;
	private JanelaPrincipal janelaPrincipal;
	private ImageIcon imagemBotaoOk;
	private JLabel botaoOk;
	private JLabel botaoCancelar;
	private ImageIcon imagemBotaoCancelar;
	private ImageIcon imagem;
	private JLabel labelImagem;
	private JLabel cadastrar;
	private JLabel cancelar;

	public JanelaCadastroDanca(JanelaPrincipal janela) {

		this.janelaPrincipal = janela;
		this.criarJanela();
	}

	public void criarJanela() {

		this.setTitle("Cadastrar Dana");
		this.setSize(340, 260);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.musica = criarLabel("Musica:", 30, 30);
		this.caixaTextoMusica = criarCaixaTexto(200, 20, 100, 30);

		this.valor = criarLabel("Valor (R$):", 30, 60);
		this.caixaTextoValor = criarCaixaTexto(40, 20, 100, 60);

		this.escolherAlunos = new JButton("Escolha os bailarinos");
		this.escolherAlunos.setSize(170, 20);
		this.escolherAlunos.setLocation(85, 110);
		this.escolherAlunos.addActionListener(this);
		this.add(escolherAlunos);

		cadastrar = criarLabel("Cadastrar", 250, 165);
		cadastrar.setFont(new Font("Verdana", Font.BOLD, 13));

		cancelar = criarLabel("Cancelar", 70, 165);
		cancelar.setFont(new Font("Verdana", Font.BOLD, 13));


		criarImagem();
		this.setVisible(true);

	}

	private void criarImagem() {

		imagem = new ImageIcon("Teste3.jpg");
		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 190, 150);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 10, 150);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);

		criarLabelImagem2(labelImagem, imagem,0,0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	private void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getActionCommand().equalsIgnoreCase("Escolha os bailarinos")){
			JanelaSelecaoBailarinos janelaSelecaoBailarinos = new JanelaSelecaoBailarinos(this.janelaPrincipal);
		}

	}



	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = checarCampos();

			if(b){

				Danca danca = getInformacoes();
				try {

					this.janelaPrincipal.getFachada().inserirDanca(danca);
					this.dispose();

				} catch (DancaExistenteException e) {

					JanelaAviso janelaAviso = new JanelaAviso("Danca j existente", 1);

				}


			} else {

				JanelaAviso janelaAviso = new JanelaAviso("Preencha todos os campos obrigatrios", 1);

			}



		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 

		}
	} 

	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}

	}

	public boolean checarCampos(){

		if(caixaTextoMusica.getText().equals("")
				|| caixaTextoValor.getText().equals("")){

			return false;

		} else {


			return true;
		}
	}

	public Danca getInformacoes(){

		Danca danca = null;
		String nome = caixaTextoMusica.getText();
		double valor = Double.parseDouble(caixaTextoValor.getText());

		//00 codfestival
		danca = new Danca("null",  nome, 00 , valor);
		return danca;
	}

	public int gerarCodigo(){
		return 0;
	}

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}		
}

