package gui;

import gui.JanelaCadastroProfessor.MeuDocument;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import Excecao.EscolaExistenteException;
import basicas.EscolaParceira;

public class JanelaCadastroParceria extends JFrame implements ActionListener , MouseListener{

	private JLabel escolaParceira;
	private JTextField caixaTextoParceria;
	private JLabel endereco;
	private JLabel rua;
	private JTextField caixaTextoRua;
	private JLabel numero;
	private JTextField caixaTextoNumero;
	private JLabel cidade;
	private JTextField caixaTextoCidade;
	private JLabel bairro;
	private JTextField caixaTextoBairro;
	private JLabel cep;
	private JTextField caixaTextoCEP;
	private JLabel complemento;
	private JTextField caixaTextoCompleto;
	private JLabel telefone;
	private JTextField caixaTextoTelefone;
	private JLabel responsavel;
	private JTextField caixaTextoResponsavel;
	private JLabel desconto;
	private JTextField caixaTextoDesconto;
	private JanelaPrincipal janelaPrincipal;

	private JLabel cadastrar;
	private JLabel cancelar;

	private JLabel botaoOk;
	private JLabel botaoCancelar;

	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;
	private JLabel imagemFundo;
	private ImageIcon imagem;
	
	
	public JanelaCadastroParceria(JanelaPrincipal janela) {
		this.janelaPrincipal = janela;
		this.criarJanela();
	}

	public void criarJanela() {

		this.setTitle("Cadastrar Parceira");
		this.setSize(620, 350);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();

		this.escolaParceira = criarLabel("Escola Parceira*:", 30, 30);
		this.caixaTextoParceria= criarCaixaTexto(280, 20, 130, 30);
		
		this.desconto = criarLabel("Desconto (R$)*:", 440, 30);
		this.caixaTextoDesconto = criarCaixaTexto(40, 20, 535, 30);

		this.endereco = criarLabel("Endereo", 30, 80);

		this.rua = criarLabel("Rua:", 30, 110);
		this.caixaTextoRua = criarCaixaTexto(300, 20, 80, 110);

		this.numero = criarLabel("Nmero:", 420, 110);
		this.caixaTextoNumero = criarCaixaTexto(100, 20, 475, 110);

		this.bairro = criarLabel("Bairro:", 30, 140);
		this.caixaTextoBairro = criarCaixaTexto(200, 20, 80, 140);

		this.cidade = criarLabel("Cidade:", 310, 140);
		this.caixaTextoCidade = criarCaixaTexto(215, 20, 360, 140);

		this.cep = criarLabel("CEP:", 30, 170);
		this.caixaTextoCEP = criarCaixaTexto(55, 20, 80, 170);

		this.complemento = criarLabel("Complemento:", 150, 170);
		this.caixaTextoCompleto = criarCaixaTexto(335, 20, 240, 170);

		this.telefone = criarLabel("Telefone:", 415, 220);
		this.caixaTextoTelefone = criarCaixaTexto(100, 20, 475, 220);

		this.responsavel = criarLabel("Responsvel:", 30, 220);
		this.caixaTextoResponsavel = criarCaixaTexto(260, 20, 130, 220);

		this.cadastrar = criarLabel("Cadastrar",440, 275);
		this.cadastrar.setFont(new Font("Verdana",Font.BOLD,13));

		this.cancelar = criarLabel("Cancelar", 80, 275);
		this.cancelar.setFont(new Font("Verdana",Font.BOLD,13));

		
		this.criarImagem();
		this.limitarTexto();

		this.setVisible(true);
	}

	private void criarImagem() {


		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");

		botaoOk = criarLabel("", 520, 260);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		botaoCancelar = criarLabel("", 10, 260);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);
		imagem = new ImageIcon("Teste3.jpg");

		criarLabelImagem2(imagemFundo, imagem,0,0, 620, 840);
		//		criarLabelImagem2(labelImagem, imagem, 0, 0, 620, 800);
	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao) {
		JLabel label = new JLabel(nome);
		Font fonte = new Font("Verdana", 11, 11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		this.add(label);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao,
			int yPosicao) {
		JTextField caixaTexto = new JTextField();
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		this.add(caixaTexto);
		return caixaTexto;
	}

	private void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void actionPerformed(ActionEvent e) {


	}

	public boolean checarCampos(){
		
		if(caixaTextoParceria.getText().equals("")
				|| caixaTextoDesconto.getText().equals("")){
			
			return false;
		} else {
			return true;
		}
		
		
	}
	
	public EscolaParceira getInformacao(){
		
		String nome = caixaTextoParceria.getText();
		String endereco = caixaTextoRua.getText() + "#" + caixaTextoNumero.getText()+ "#" + caixaTextoCompleto.getText() + "#" + caixaTextoBairro.getText() + "#" + caixaTextoCidade.getText() + "#" + caixaTextoCEP.getText();
		int desconto = Integer.parseInt(caixaTextoDesconto.getText());
		String telefone = caixaTextoTelefone.getText();
		String responsavel = caixaTextoResponsavel.getText();
		EscolaParceira escola = new EscolaParceira(null, nome, telefone,responsavel, endereco );
		return escola;
	}
	@Override
	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			boolean b = checarCampos();
			
			if(b){
				
				EscolaParceira escola = this.getInformacao();				
				try {
					janelaPrincipal.getFachada().inserirEscolaParceira(escola);
					JanelaAviso janelaAviso = new JanelaAviso("Escola Parceira cadastrada com sucesso", 1);
					this.dispose();
					
				} catch (EscolaExistenteException e) {
					JanelaErro janelaAviso = new JanelaErro("Escola Parceira j existe", 1);
				}				
			} else {				
				JanelaErro janelaAviso = new JanelaErro("Preecha todos os campos obrigatrios", 1);
			}
			

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 
		}
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		} 
	}

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
	public void ValidaNumero(JTextField Numero) throws NumberFormatException { 
		long valor; 
		if (Numero.getText().length() != 0){ 
			//try { 
			valor = Long.parseLong(Numero.getText()); 
			/*}catch(NumberFormatException ex){ 
				JOptionPane.showMessageDialog(null, "Esse Campo s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
				Numero.grabFocus(); 
			} */
		} 
	} 
	
	public boolean validarCampos() {

		boolean validar = true;
			
		try { 
			ValidaNumero(caixaTextoNumero);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Nmero s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoNumero.grabFocus(); 
		} 
		
		try { 
			ValidaNumero(caixaTextoCEP);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo CEP s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoCEP.grabFocus(); 
		} 
		
		
		try { 
			ValidaNumero(caixaTextoTelefone);
		}catch(NumberFormatException ex){ 
			validar = false;
			JOptionPane.showMessageDialog(null, "Ateno, o campo Telefone s aceita nmeros" ,"Informao",JOptionPane.INFORMATION_MESSAGE); 
			caixaTextoTelefone.grabFocus(); 
		} 
		
		return validar;


	}
	
	
	public void limitarTexto(){

		
		caixaTextoTelefone.setDocument(new MeuDocument(10));
		caixaTextoParceria.setDocument(new MeuDocument(80));
		caixaTextoResponsavel.setDocument(new MeuDocument(80));
		caixaTextoDesconto.setDocument(new MeuDocument(4));

	}

	// classe personalizada que amplia PlainDocument
	class MeuDocument extends PlainDocument{
		int maximo;

		public MeuDocument(int max){
			maximo = max;
		}

		public void insertString(int offs, String str, 
				AttributeSet a) throws BadLocationException{
			if((getLength() + str.length()) <= maximo)
				super.insertString(offs, str, a);
		}
	}
	
}
