package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import basicas.Aluno;
import basicas.Atendente;
import basicas.Danca;
import basicas.Despesa;
import basicas.Dias;
import basicas.EscolaParceira;
import basicas.Funcionario;
import basicas.Modalidade;
import basicas.Professor;
import basicas.Turma;

public class JanelaConsulta extends JFrame implements ActionListener,
ItemListener, MouseListener {

	private JLabel texto;
	private JLabel texto2;
	private JLabel nomeCampo;
	private JTextField caixaTexto;
//	private JTextField caixaTexto2;
	private JComboBox comboBox;
	private ButtonGroup grupo;
	private JRadioButton radio1;
	private JRadioButton radio2;
	private JButton ok;
	private int tipoConsulta;

	private Vector<Danca> dancas;
	private Vector<Turma> turmas;
	private Vector<Modalidade> modalidades;
	private Vector<EscolaParceira> escolasParceiras;

	public Vector<Aluno> teste;

	private String consulta;

	private JanelaPrincipal janelaPrincipal;

	public JanelaConsulta(JanelaPrincipal janelaPrincipal, String texto2, int tipoConsulta) {
		this.janelaPrincipal = janelaPrincipal;
		this.tipoConsulta = tipoConsulta;
		this.consulta = texto2;
		this.criarJanela(texto2);
	}

	public void criarJanela(String texto2) {
		this.setTitle("Consulta");
		this.setSize(420, 180);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();
		this.turmas = new Vector<Turma>();


		if(this.tipoConsulta == 1){
			//consulta por textfield
			this.texto = this.criarLabel("Preencha o campo de consulta abaixo", 100, 30);

			if(texto2.equalsIgnoreCase("Nome") || texto2.equalsIgnoreCase("Nome do Funcionrio")
					|| texto2.equalsIgnoreCase("Nome do Aluno")){
				this.nomeCampo = this.criarLabel("Nome:", 30, 65);
				this.caixaTexto = this.criarCaixaTexto(300, 20, 80, 65);
			}else if(texto2.equalsIgnoreCase("Idade")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 170, 65);
				this.caixaTexto = this.criarCaixaTexto(20, 20, 220, 65);
			}else if(texto2.equalsIgnoreCase("Nome da me")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 30, 65);
				this.caixaTexto = this.criarCaixaTexto(250, 20, 130, 65);
			}else if(texto2.equalsIgnoreCase("Cdigo")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 140, 65);
				this.caixaTexto = this.criarCaixaTexto(90, 20, 190, 65);
			}else if(texto2.equalsIgnoreCase("CPF do Professor") || texto2.equalsIgnoreCase("CPF")){
				this.nomeCampo = this.criarLabel("CPF:", 150, 65);
				this.caixaTexto = this.criarCaixaTexto(75, 20, 190, 65);
			}else if(texto2.equalsIgnoreCase("Faixa Etria")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 120, 65);
				this.caixaTexto = this.criarCaixaTexto(20, 20, 200, 65);
				this.nomeCampo = this.criarLabel("a", 230, 65);
			//	this.caixaTexto2 = this.criarCaixaTexto(20, 20, 250, 65);
			}else if(texto2.equalsIgnoreCase("Funo")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 140, 65);
				this.caixaTexto = this.criarCaixaTexto(90, 20, 190, 65);
			}else if(texto2.equalsIgnoreCase("Data de Vencimento")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 110, 65);
				this.caixaTexto = this.criarCaixaTexto(63, 20, 240, 65);
			}else if(texto2.equalsIgnoreCase("Empresa")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 30, 65);
				this.caixaTexto = this.criarCaixaTexto(290, 20, 90, 65);
			}else if(texto2.equalsIgnoreCase("Login Atendente")){
				this.nomeCampo = this.criarLabel(texto2 + ":", 80, 65);
				this.caixaTexto = this.criarCaixaTexto(150, 20, 190, 65);	
			}

		}else if(this.tipoConsulta == 2){
			//consulta por combobox
			String[] textos;
			this.texto = this.criarLabel("Selecione a opo de consulta abaixo", 100, 30);

			if(texto2.equalsIgnoreCase("Danca")){

				this.dancas = this.janelaPrincipal.getFachada().gerarRelatorioDanca();
				int tamanho = dancas.size();
				textos = new String[tamanho];
				for(int i = 0; i < tamanho; i++){
					textos[i] = dancas.get(i).getNome();
				}

				this.nomeCampo = this.criarLabel(texto2 + ":", 80, 65);
				this.comboBox = criarComboBox(textos, 200, 20, 130, 65);	

			}else if(texto2.equalsIgnoreCase("Turma") || texto2.equalsIgnoreCase("Nome da Turma")){

				this.turmas = this.janelaPrincipal.getFachada().gerarRelatorioTurma();
				int tamanho = turmas.size();
				textos = new String[tamanho];
				for(int i = 0; i < tamanho; i++){
					textos[i] = turmas.get(i).getNome();
				}

				this.nomeCampo = this.criarLabel("Turma:", 90, 65);
				this.comboBox = criarComboBox(textos, 190, 20, 140, 65);	
			}else if(texto2.equalsIgnoreCase("Modalidade") || texto2.equalsIgnoreCase("Modalidade (Turma)")){
				this.modalidades = this.janelaPrincipal.getFachada().gerarRelatorioModalidade();
				int tamanho = modalidades.size();
				textos = new String[tamanho];
				for(int i = 0; i < tamanho; i++){
					textos[i] = modalidades.get(i).getNome();
				}
				this.nomeCampo = this.criarLabel("Modalidade:", 80, 65);
				this.comboBox = criarComboBox(textos, 170, 20, 160, 65);	
			}else if(texto2.equalsIgnoreCase("Sala")){
				textos = new String[2];
				textos[0] = "1";
				textos[1] = "2";
				this.nomeCampo = this.criarLabel(texto2 + ":", 140, 65);
				this.comboBox = criarComboBox(textos, 100, 20, 180, 65);	
			}else if(texto2.equalsIgnoreCase("Escola Parceira")){
				this.escolasParceiras = this.janelaPrincipal.getFachada().gerarRelatorioEscola();
				int tamanho = escolasParceiras.size();
				textos = new String[tamanho];
				for(int i = 0; i < tamanho; i++){
					textos[i] = escolasParceiras.get(i).getNome();
				}
				this.nomeCampo = this.criarLabel("Nome:", 80, 65);
				this.comboBox = criarComboBox(textos, 200, 20, 130, 65);	
			}

		}else if(this.tipoConsulta == 3){
			//consulta por radio
			this.texto = this.criarLabel("Selecione a opo de consulta abaixo", 100, 30);
			this.grupo = new ButtonGroup();

			if(texto2.equalsIgnoreCase("Sexo")){
				this.radio1 = criarRadioButton("M", 140, 65);
				this.radio2 = criarRadioButton("F", 240, 65);
			}else if(texto2.equalsIgnoreCase("Mensalidade") || texto2.equalsIgnoreCase("Status")){
				this.radio1 = criarRadioButton("Pagas", 120, 65);
				this.radio2 = criarRadioButton("No Pagas", 220, 65);
			}

			this.grupo.add(radio1);
			this.grupo.add(radio2);

		}
		if(tipoConsulta != 4){
			this.ok = new JButton("Ok");
			this.ok.setSize(80, 20);
			this.ok.setLocation(175, 110);
			this.ok.addActionListener(this);
			this.add(ok);
			this.setVisible(true);

		}	else if(this.tipoConsulta == 4){
			//consulta por Tabela

			teste = this.janelaPrincipal.getFachada().gerarRelatorioAluno();
			int n = teste.size();
			String[][] aluno = new String[n][3];

			for(int i = 0; i < n; i++){
				aluno[i][0] = teste.get(i).getNome();
				aluno[i][1] = teste.get(i).getNomeMae();
				aluno[i][2] = String.valueOf(teste.get(i).getCodigoAluno());				
			}

			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(this, this.janelaPrincipal, "Escolha o aluno:", aluno);

		}


	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao) {
		JLabel label = new JLabel(nome);
		Font fonte = new Font("Verdana", 11, 11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(230, 20);
		label.setLocation(xPosicao, yPosicao);
		this.add(label);
		return label;
	}

	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.add(radio);
		radio.setSize(100, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public JComboBox criarComboBox(String[] texto, int xTamanho, int yTamanho, int xPosicao, int yPosicao) {
		JComboBox box = new JComboBox(texto);
		this.add(box);
		box.setSize(xTamanho, yTamanho);
		box.setLocation(xPosicao, yPosicao);
		box.addActionListener(this);

		return box;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao,
			int yPosicao) {
		JTextField caixaTexto = new JTextField();
		caixaTexto.setText("");
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		this.add(caixaTexto);
		return caixaTexto;
	}

	public void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	public void mouseClicked(MouseEvent arg0) {

	}

	public void actionPerformed(ActionEvent e) {

		if(e.getActionCommand().equalsIgnoreCase("Ok")){

			if(this.tipoConsulta == 1){
				String textoUm = this.caixaTexto.getText();

				if(this.consulta.equalsIgnoreCase("Nome da me")){
					this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorMae(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Idade")){
					this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorIdade(Integer.parseInt(textoUm), Integer.parseInt(textoUm)));
				}else if(this.consulta.equalsIgnoreCase("Nome")){
					this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorNome(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Cdigo")){
					this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarPeloCodigo(Integer.parseInt(textoUm)));
				}else if(this.consulta.equalsIgnoreCase("Faixa Etria")){

					/*String textoDois = this.caixaTexto2.getText();
					if(textoDois.equals("")){
						textoDois = textoUm;
					}*/
					this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarTurmaPorIdade(Integer.parseInt(textoUm)));
				}else if(this.consulta.equalsIgnoreCase("Nome do Funcionrio")){
					this.mostrarJanelaRelatorioFuncionario(this.janelaPrincipal.getFachada().consultarFuncionarioPorNome(textoUm));
				}else if(this.consulta.equalsIgnoreCase("CPF")){
					this.mostrarJanelaRelatorioFuncionario(this.janelaPrincipal.getFachada().consultarFuncionarioPorCPF(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Funo")){
					this.mostrarJanelaRelatorioFuncionario(this.janelaPrincipal.getFachada().consultarFuncionarioPorFuncao(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Data de Vencimento")){
					this.mostrarJanelaRelatorioDespesa(this.janelaPrincipal.getFachada().consultarDespesaPorDataVencimento(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Empresa")){
					this.mostrarJanelaRelatorioDespesa(this.janelaPrincipal.getFachada().consultarDespesaPorEmpresa(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Login Atendente")){
					this.mostrarJanelaRelatorioFuncionario(this.janelaPrincipal.getFachada().consultarAtendentePorLogin(textoUm));
				}else if(this.consulta.equalsIgnoreCase("Nome do Funcionrio")){
					this.mostrarJanelaRelatorioFuncionario(this.janelaPrincipal.getFachada().consultarFuncionarioPorNome(textoUm));
				}else if(this.consulta.equalsIgnoreCase("CPF do Professor")){
					this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarTurmaPorCpfProfessor(textoUm));

				} 

			}else if(this.tipoConsulta == 2){

				int indice = this.comboBox.getSelectedIndex();
				if(this.consulta.equalsIgnoreCase("Danca")){
					this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorDanca(this.dancas.get(indice).getCod_danca(), this.dancas.get(indice).getCodigoFestival()));
				}else if(this.consulta.equalsIgnoreCase("Turma")){
					this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorTurma(this.turmas.get(indice).getCodigoTurma()));
				}else if(this.consulta.equalsIgnoreCase("Nome da Turma")){
					this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarTurmaPorNome(this.turmas.get(indice).getNome()));
				}else if(this.consulta.equalsIgnoreCase("Modalidade")){
					this.mostrarJanelaRelatorioModalidade(this.janelaPrincipal.getFachada().consultarModalidadePorNome(this.modalidades.get(indice).getNome()));
				}else if(this.consulta.equalsIgnoreCase("Modalidade da Turma")){
					this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarTurmaPorNomeModalidade(this.modalidades.get(indice).getNome()));
				}else if(this.consulta.equalsIgnoreCase("Sala")){
					if(indice == 0){
						this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarTurmaPorSala("1"));
					}else{
						this.mostrarJanelaRelatorioTurma(this.janelaPrincipal.getFachada().consultarTurmaPorSala("2"));
					}
				}else if(this.consulta.equalsIgnoreCase("Escola Parceira")){
					this.mostrarJanelaRelatorioEscolasParceiras(this.janelaPrincipal.getFachada().consultarEscola(this.escolasParceiras.get(indice).getNome()));
				}

			}else if(this.tipoConsulta == 3){
				if(this.consulta.equalsIgnoreCase("Sexo")){
					if(radio1.isSelected()){
						this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorSexo("M"));
					}else{
						this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunoPorSexo("F"));
					}
				}else if(this.consulta.equalsIgnoreCase("Mensalidade")){
					if(radio1.isSelected()){
						
//						teste = this.janelaPrincipal.getFachada().gerarRelatorioAluno();
//						String[][] data = new String[teste.size()][1];
//						for (int i = 0; i < teste.size(); i++) {
//							String data = this.janelaPrincipal.getFachada().consultarProximaMensalidade(teste.get(i), teste.get(i).getCodigoEscola());
//						}
						//this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarProximaMensalidade(aluno, codAluno)());
					}else{
						this.mostrarJanelaRelatorioAluno(this.janelaPrincipal.getFachada().consultarAlunosDevedores());
					}
				}else if(this.consulta.equalsIgnoreCase("Status")){
					if(radio1.isSelected()){
						this.mostrarJanelaRelatorioDespesa(this.janelaPrincipal.getFachada().consultarDespesaPorStatus("sim"));
					}else{
						this.mostrarJanelaRelatorioDespesa(this.janelaPrincipal.getFachada().consultarDespesaPorStatus("no"));
					}
				}
			}
		}
	}



	public void mostrarJanelaRelatorioAluno(Vector<Aluno> alunos){
		String[][] conteudo;
		int tamanho = 0;
		tamanho = alunos.size();
		conteudo = new String[tamanho][9];
		//System.out.println(alunos.get(0).getTelefones().get(0));
		for(int i = 0; i < tamanho; i++){

			conteudo[i][0] = alunos.get(i).getNome();
			conteudo[i][1] = String.valueOf(alunos.get(i).getIdade());
			conteudo[i][2] = alunos.get(i).getCpf();
			conteudo[i][3] = alunos.get(i).getTelefones().get(0);
			conteudo[i][4] = alunos.get(i).getEndereco();
			conteudo[i][5] = alunos.get(i).getNascimento();
			conteudo[i][6] = alunos.get(i).getNomeEscola();
			conteudo[i][7] = alunos.get(i).getNomeMae();
			conteudo[i][8] = alunos.get(i).getNomePai();
		}

		this.dispose();
		new JanelaRelatorio(this.janelaPrincipal, conteudo, 4);	
	}

	public void mostrarJanelaRelatorioTurma(Vector<Turma> turmas){
		String[][] conteudo;
		int tamanho = 0;
		tamanho = turmas.size();
		conteudo = new String[tamanho][7];

		for(int i = 0; i < tamanho; i++){

			Vector<Dias> dias = this.janelaPrincipal.getFachada().consultarDiasPorCodigoTurma(turmas.get(i).getCodigoTurma());
			int quantDias = dias.size();
			int m = quantDias - 1;

			if(quantDias == 0){

				conteudo[i][3] = " ";

			} else {

				conteudo[i][3] = dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));
				m--;
				while(m >= 0){

					conteudo[i][3] = conteudo[i][3] + " / " + dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));

					m--;

				}			


			}
			conteudo[i][0] = String.valueOf(turmas.get(i).getCodigoTurma());
			conteudo[i][1] = turmas.get(i).getNome();
			if(turmas.get(i).getIdadeMaxima() == 0){
				conteudo[i][2] = "A partir de " + turmas.get(i).getIdadeMinima();

			} else {
				conteudo[i][2] = turmas.get(i).getIdadeMinima() + " a " + turmas.get(i).getIdadeMaxima();

			}
			conteudo[i][4] = String.valueOf(turmas.get(i).getSala());
			conteudo[i][5] = turmas.get(i).getNomeModalidade();
			conteudo[i][6] = this.janelaPrincipal.getFachada().consultarFuncionarioPorCPF(turmas.get(i).getCpfProfessor()).get(0).getNome();

		}
		this.dispose();
		new JanelaRelatorio(this.janelaPrincipal, conteudo, 5);	
	}

	public void mostrarJanelaRelatorioFuncionario(Vector<Funcionario> funcionarios){
		String[][] conteudo;
		int tamanho = 0;
		tamanho = funcionarios.size();
		conteudo = new String[tamanho][10];
		for(int i = 0; i < tamanho; i++){	
			if(funcionarios.get(i) instanceof Atendente){

				conteudo[i][0] = funcionarios.get(i).getNome();
				conteudo[i][1] = funcionarios.get(i).getCpf();
				conteudo[i][2] = funcionarios.get(i).getRg();
				conteudo[i][3] = funcionarios.get(i).getSexo() + "";
				conteudo[i][4] = funcionarios.get(i).getNascimento();
				conteudo[i][5] = funcionarios.get(i).getTelefone();
				conteudo[i][6] = funcionarios.get(i).getEndereco();
				conteudo[i][7] = funcionarios.get(i).getEmail();
				conteudo[i][8] = funcionarios.get(i).getFuncao();
				conteudo[i][9] = String.valueOf(funcionarios.get(i).getSalario());

			} else if(funcionarios.get(i) instanceof Professor){

				conteudo[i][0] = funcionarios.get(i).getNome();
				conteudo[i][1] = funcionarios.get(i).getCpf();
				conteudo[i][2] = funcionarios.get(i).getRg();
				conteudo[i][3] = funcionarios.get(i).getSexo() + "";
				conteudo[i][4] = funcionarios.get(i).getNascimento();
				conteudo[i][5] = funcionarios.get(i).getTelefone();
				conteudo[i][6] = funcionarios.get(i).getEndereco();
				conteudo[i][7] = funcionarios.get(i).getEmail();
				conteudo[i][8] = funcionarios.get(i).getFuncao();
				conteudo[i][9] = String.valueOf(funcionarios.get(i).getSalario());

			} else {

				conteudo[i][0] = funcionarios.get(i).getNome();
				conteudo[i][1] = funcionarios.get(i).getCpf();
				conteudo[i][2] = funcionarios.get(i).getRg();
				conteudo[i][3] = funcionarios.get(i).getSexo() + "";
				conteudo[i][4] = funcionarios.get(i).getNascimento();
				conteudo[i][5] = funcionarios.get(i).getTelefone();
				conteudo[i][6] = funcionarios.get(i).getEndereco();
				conteudo[i][7] = funcionarios.get(i).getEmail();
				conteudo[i][8] = funcionarios.get(i).getFuncao();
				conteudo[i][9] = String.valueOf(funcionarios.get(i).getSalario());
			} 
		}

		this.dispose();
		new JanelaRelatorio(this.janelaPrincipal, conteudo, 6);	
	}

	public void mostrarJanelaRelatorioModalidade(Vector<Modalidade> modalidades){
		String[][] conteudo;
		int tamanho = 0;
		tamanho = modalidades.size();
		conteudo = new String[tamanho][2];
		for(int i = 0; i < tamanho; i++){	
			conteudo[i][0] = modalidades.get(i).getNome();
			conteudo[i][1] = String.valueOf(modalidades.get(i).getValor());
		}

		this.dispose();
		new JanelaRelatorio(this.janelaPrincipal, conteudo, 7);	
	}

	public void mostrarJanelaRelatorioDespesa(Vector<Despesa> despesas){
		String[][] conteudo;
		int tamanho = 0;
		tamanho = despesas.size();
		conteudo = new String[tamanho][5];
		for(int i = 0; i < tamanho; i++){	
			conteudo[i][0] = despesas.get(i).getCodigoDespesa();
			conteudo[i][1] = String.valueOf(despesas.get(i).getValor());
			conteudo[i][2] = despesas.get(i).getDataVencimento();
			conteudo[i][3] = despesas.get(i).getDataPagamento();
			conteudo[i][4] = despesas.get(i).getEmpresaBeneficiada();
		}

		this.dispose();
		new JanelaRelatorio(this.janelaPrincipal, conteudo, 8);	
	}

	public void mostrarJanelaRelatorioEscolasParceiras(Vector<EscolaParceira> escolas){
		String[][] conteudo;
		int tamanho = 0;
		tamanho = escolas.size();
		conteudo = new String[tamanho][5];

		for(int i = 0; i < tamanho; i++){	
			conteudo[i][0] = escolas.get(i).getCod_escola();
			conteudo[i][1] = escolas.get(i).getNome();
			conteudo[i][2] = escolas.get(i).getTelefone();
			conteudo[i][3] = escolas.get(i).getResponsavel();
			conteudo[i][4] = escolas.get(i).getEndereco();
		}

		this.dispose();
		new JanelaRelatorio(this.janelaPrincipal, conteudo, 9);	
	}	


	@Override
	public void mouseEntered(MouseEvent arg0) {

	}

	@Override
	public void mouseExited(MouseEvent arg0) {
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void itemStateChanged(ItemEvent arg0) {
		// TODO Auto-generated method stub

	}
}
