package gui;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import repositorios.RepositorioFuncionario;
import repositorios.RepositorioLogin;
import fachada.Fachada;

public class JanelaLogin extends JFrame implements ActionListener {



	private JLabel nome;
	private JLabel  senha;
	private JTextField textoNome;
	private JPasswordField  textoSenha;
	private JButton botaoOk;
	private RepositorioFuncionario repFun;
	private boolean permissao;

	public JanelaLogin() {

		this.repFun = new RepositorioFuncionario();
		this.setLayout(null);		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setTitle("Atena");
		this.nome = criarLabel("Login", 40, 30);
		this.senha = criarLabel("Senha", 38, 80);
		this.permissao = false;

		this.textoNome = criarCaixaTexto(130, 20, 90, 30);		
		textoSenha = new JPasswordField();
		textoSenha.setLayout(null);
		this.textoSenha.setLocation(90, 80);
		this.textoSenha.setSize(130, 20);
		this.botaoOk = new JButton("Ok");
		this.botaoOk.setSize(80, 15);
		this.botaoOk.setLocation(100, 130);
		this.botaoOk.addActionListener(this);

		this.add(botaoOk);
		this.add(textoSenha);
		this.setSize(280, 200);
		centralizarJanela();	
		setVisible(true);


	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",Font.BOLD,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public void centralizarJanela(){

		Dimension dim = this.getToolkit().getScreenSize();      
		int x = (int) (dim.getWidth()  - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x,y);

	}

	public void actionPerformed(ActionEvent e) {

		if(e.getActionCommand().equals("Ok")){

			String login = textoNome.getText();
			String senha = textoSenha.getText();

			try {


				int p = repFun.validarLogin(login, senha);

				if(login.equals("Alice") && senha.equals("123")){
					permissao = true;
					Fachada fachada = new Fachada();
					new JanelaPrincipal(fachada,login,permissao);
					this.dispose();
				} else	if(p == 1){
					permissao = false;
					Fachada fachada = new Fachada();
					new JanelaPrincipal(fachada,login,permissao);
					this.dispose();

				} else if(p ==0){
					new JanelaAviso("Senha incorreta", 1);

				} else if(p == 3){
					new JanelaAviso("Login invlido", 1);

				} else if(p == 2) {
					permissao = true;
					Fachada fachada = new Fachada();
					new JanelaPrincipal(fachada,login,permissao);
					this.dispose();
				}
			

			} catch (SQLException e1) {

				e1.printStackTrace();
			}

		}

	}
	public static void main(String args[]) {

		JanelaLogin a = new JanelaLogin();
	}
} 
