package gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

import util.ManipulacaoData;
import basicas.Aluno;

public class JanelaMensalidade extends JFrame implements ActionListener{

	private JLabel nomeAluno;
	private JLabel mesAno;
	private JLabel valorMensalidade;
	private JButton pagar;    
	private JanelaPrincipal janela;
	private Aluno aluno;

	public JanelaMensalidade(JanelaPrincipal janela, Aluno aluno) {

		this.aluno = aluno;
		this.janela = janela;
		this.setLayout(null);
		this.setTitle("Pagamento de Mensalidade");
		this.setSize(300, 200);
		this.setResizable(false);
		this.centralizarJanela();
		try {
			String data = this.janela.getFachada().consultarProximaMensalidade(aluno, Integer.parseInt(aluno.getCodigoAluno()));
			this.nomeAluno = criarLabel("Nome do aluno: " + aluno.getNome(), 30, 30);
			this.mesAno = criarLabel("Ms/Ano: " + data , 30, 60);
			this.valorMensalidade = criarLabel("Valor (R$): " + String.valueOf(aluno.getMensalidade()), 30, 90);

		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


		this.pagar = new JButton("Pagar");
		this.pagar.setSize(100, 20);
		this.pagar.setLocation(100, 130);
		this.pagar.addActionListener(this);
		this.add(pagar);

		this.setVisible(true);
	}

	public void centralizarJanela(){

		Dimension dim = this.getToolkit().getScreenSize();      
		int x = (int) (dim.getWidth()  - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x,y);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		label.setLayout(null);
		label.setSize(290, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}


	public void actionPerformed(ActionEvent e) {

		if(e.getActionCommand().equalsIgnoreCase("Pagar")){
			String data = "";
			try {
				data = this.janela.getFachada().consultarProximaMensalidade(aluno, Integer.parseInt(aluno.getCodigoAluno()));
			} catch (NumberFormatException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

			this.janela.getFachada().pagarMensalidade(data, Integer.parseInt(aluno.getCodigoAluno()),ManipulacaoData.getData(),aluno.getMensalidade());
			new JanelaAviso("Pagamento efetuado com sucesso", 2);
			this.dispose();
		}
	}
}