package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;


public class JanelaPagamentoMensalidade extends JFrame implements ActionListener{

	private JLabel aluno;
	private JComboBox alunosBox;
	private JLabel modalidade;
	private JComboBox modalidadesBox;
	
	private JanelaPrincipal janelaPrincipal;

		
	public JanelaPagamentoMensalidade(JanelaPrincipal janela) {
		this.janelaPrincipal = janela;
		this.criarJanela();
	}
	
	public void criarJanela() {
		
		this.setTitle("Pagamento de Mensalidade");
		this.setSize(360, 230);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();
		
		this.aluno = criarLabel("Aluno:", 30, 30);
		String[] alunos = {"Selecione o aluno", "Alice"};
		this.alunosBox = criarComboBox(alunos, 200, 20, 110, 30);

		this.modalidade = criarLabel("Modalidade:", 30, 80);
		String[] modalidades = {"...", "oi"};
		this.modalidadesBox = criarComboBox(modalidades, 200, 20, 110, 80);

	   
		this.setVisible(true);
		
	}
	
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}
	
	public JComboBox criarComboBox(String[] texto, int xTamanho, int yTamanho, int xPosicao, int yPosicao) {
		JComboBox box = new JComboBox(texto);
		this.add(box);
		box.setSize(xTamanho, yTamanho);
		box.setLocation(xPosicao, yPosicao);
		return box;
	}
	
	private void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}
	
	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	

	
}
