package gui;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import basicas.Aluno;
import basicas.Atendente;
import basicas.Despesa;
import basicas.Dias;
import basicas.EscolaParceira;
import basicas.Festival;
import basicas.Funcionario;
import basicas.Modalidade;
import basicas.Professor;
import basicas.Turma;
import fachada.Fachada;


public class JanelaPrincipal extends JFrame implements ActionListener {

	private static final long serialVersionUID = 1L;
	private JMenuBar barra;
	private JMenu menuArquivo;
	private JMenu menuCadastrar;
	private JMenu menuRemover;
	private JMenu menuConsultar;
	private JMenu menuAtualizar;
	private JMenu menuFestival;
	private JMenu menuDanca;
	private JMenu menuRelatorio;
	private JMenu menuMensalidade;
	private JMenu menuAjuda;

	private JMenuItem efetuarLogoff;

	private JMenuItem consultarAluno;
	private JMenuItem consultarTurma;
	private JMenuItem consultarFuncionario;
	private JMenuItem consultarDespesa;
	private JMenuItem consultarParceria;
	private JMenuItem consultarModalidade;

	private JMenuItem cadastrarAluno;
	private JMenuItem cadastrarTurma;
	private JMenu cadastrarFuncionario;
	private JMenuItem cadastrarDespesa;
	private JMenuItem cadastrarParceria;
	private JMenuItem cadastrarModalidade;

	private JMenuItem atualizarAluno;
	private JMenuItem atualizarTurma;
	private JMenuItem atualizarFuncionario;
	private JMenuItem atualizarDespesa;
	private JMenuItem atualizarParceria;
	private JMenuItem atualizarModalidade;

	private JMenuItem removerAluno;
	private JMenuItem removerTurma;
	private JMenuItem removerFuncionario;
	private JMenuItem removerDespesa;
	private JMenuItem removerParceria;
	private JMenuItem removerModalidade;

	private JMenuItem cadastrarFestival;
	private JMenuItem removerFestival;
	private JMenuItem atualizarFestival;
	private JMenuItem consultarFestival;

	private JMenuItem cadastrarDanca;
	private JMenuItem removerDanca;
	private JMenuItem atualizarDanca;
	private JMenuItem consultarDanca;

	private JMenuItem cadastrarProf;
	private JMenuItem cadastrarAtendente;
	private JMenuItem cadastrarOutros;

	private JMenuItem alunos;
	private JMenuItem turma;
	private JMenuItem funcionario;
	private JMenuItem despesa;
	private JMenuItem parceria;
	private JMenuItem modalidade;
	private JMenuItem livroCaixa;

	private JMenuItem pagarMensalidade;
	private JMenuItem devedores;


	private JMenuItem ajuda;
	private JMenuItem sair;
	private JMenuItem sobre;

	private JCheckBoxMenuItem mostrarLinha;
	private JCheckBoxMenuItem mostrarPontosCurva;
	private JCheckBoxMenuItem mostrarPontoControle;

	private JLabel labelPrincipal;
	private JLabel labelCadastrarAluno;

	private JLabel arrojados;

	private ImageIcon imagemPaginaInicial;
	//	private ImageIcon imagemCadastrarAluno;
	private ImageIcon iconeCadastrar;
	private ImageIcon iconeConsultar;
	private ImageIcon iconeAtualizar;
	private ImageIcon iconeFestival;
	private ImageIcon iconeRemover;
	private ImageIcon iconeLogoff;
	private ImageIcon iconeSair;
	private ImageIcon iconeAjuda;
	private ImageIcon iconeSobre;
	private ImageIcon iconeRelatorio;
	private Fachada fachada;

	private Vector<Aluno> listaAlunosAtualizar;
	private Vector<EscolaParceira> listaEscolasAtualizar;
	private Vector<Funcionario> listaFuncionariosAtualizar;
	private Vector<Despesa> listaDespesasAtualizar;
	private Vector<Modalidade> listaModalidadeAtualizar;
	private Vector<Festival> listaFestivalAtualizar;

	private boolean permissao;
	private String login;
	private Vector<Turma> listaTurmaAtualizar;



	public JanelaPrincipal(Fachada fachada, String login, boolean permissao){

		this.login = login;
		this.permissao = permissao;
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedLookAndFeelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		this.fachada = fachada;

		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.criarJanela(login);
	}

	/*public static void main(String[] args) {
		Fachada fachada = new Fachada();
		new JanelaPrincipal(fachada);
	}*/
	
	

	public void criarJanela(String login){

		configurarJanela();

		arrojados = criarLabel("Arrojados. Todos os Direitos Reservados - @Copyright 2010.", 600, 530);
		/*	JLabel apresentacao = criarLabel("Seja Bem vindo(a) " + login, 600, 60);
		Font fonte = new Font("Verdana",Font.BOLD,16);
		apresentacao.setFont(fonte);*/

		instanciarImagem();

		criarImagem();

		criarBarraMenu();

		criarJMenu();

		criarJMenuItem();

		this.setVisible(true);

	}

	

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",Font.BOLD,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(530, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JMenu criarJMenuGambiarra(String s, JMenu menu, ImageIcon icone) {
		JMenu temp = new JMenu(s);
		menu.add(temp);
		temp.setIcon(icone);
		temp.setActionCommand(s);
		temp.addActionListener(this);
		return temp;
	}

	private void criarJMenuItem() {

		this.efetuarLogoff = this.criarMenuItem("Efetuar Logoff", this.menuArquivo, iconeLogoff);
		this.sobre = this.criarMenuItem("Sobre", this.menuAjuda, iconeSobre);

		this.consultarAluno = this.criarMenuItem("Consultar Aluno", this.menuConsultar, iconeConsultar);
		this.consultarTurma = this.criarMenuItem("Consultar Turma", this.menuConsultar, iconeConsultar);
		this.consultarFuncionario = this.criarMenuItem("Consultar Funcionrio", this.menuConsultar, iconeConsultar);
		this.consultarDespesa = this.criarMenuItem("Consultar Despesa", this.menuConsultar, iconeConsultar);
		this.consultarParceria = this.criarMenuItem("Consultar Escola Parceira", this.menuConsultar, iconeConsultar);
		this.consultarModalidade = this.criarMenuItem("Consultar Modalidade", this.menuConsultar, iconeConsultar);

		this.cadastrarAluno = this.criarMenuItem("Cadastrar Aluno", this.menuCadastrar, iconeCadastrar);
		this.cadastrarTurma = this.criarMenuItem("Cadastrar Turma", this.menuCadastrar, iconeCadastrar);
		this.cadastrarFuncionario = this.criarJMenuGambiarra("Cadastrar Funcionrio", this.menuCadastrar, iconeCadastrar);
		this.cadastrarDespesa = this.criarMenuItem("Cadastrar Despesa", this.menuCadastrar, iconeCadastrar);
		this.cadastrarParceria = this.criarMenuItem("Cadastrar Parceria", this.menuCadastrar, iconeCadastrar);
		this.cadastrarModalidade = this.criarMenuItem("Cadastrar Modalidade", this.menuCadastrar, iconeCadastrar);

		this.atualizarAluno = this.criarMenuItem("Atualizar Aluno", this.menuAtualizar, iconeAtualizar);
		this.atualizarTurma = this.criarMenuItem("Atualizar Turma", this.menuAtualizar, iconeAtualizar);
		this.atualizarFuncionario = this.criarMenuItem("Atualizar Funcionario", this.menuAtualizar, iconeAtualizar);
		this.atualizarDespesa = this.criarMenuItem("Atualizar Despesa", this.menuAtualizar, iconeAtualizar);
		this.atualizarParceria = this.criarMenuItem("Atualizar Parceria", this.menuAtualizar, iconeAtualizar);
		this.atualizarModalidade = this.criarMenuItem("Atualizar Modalidade", this.menuAtualizar, iconeAtualizar);

		this.removerAluno = this.criarMenuItem("Remover Aluno", this.menuRemover, iconeRemover);
		this.removerTurma = this.criarMenuItem("Remover Turma", this.menuRemover, iconeRemover);
		this.removerFuncionario = this.criarMenuItem("Remover Funcionrio", this.menuRemover, iconeRemover);
		this.removerDespesa = this.criarMenuItem("Remover Despesa", this.menuRemover, iconeRemover);
		this.removerParceria = this.criarMenuItem("Remover Parceria", this.menuRemover, iconeRemover);
		this.removerModalidade = this.criarMenuItem("Remover Modalidade", this.menuRemover, iconeRemover);

		this.cadastrarFestival = this.criarMenuItem("Cadastrar Festival", this.menuFestival, iconeFestival);
		this.cadastrarDanca  = this.criarMenuItem("Cadastrar Dana", this.menuDanca, iconeFestival);;
		this.consultarFestival = this.criarMenuItem("Consultar Festival", this.menuFestival, iconeFestival);
		this.consultarDanca = this.criarMenuItem("Consultar Dana", this.menuDanca, iconeFestival);;
		this.atualizarFestival = this.criarMenuItem("Atualizar Festival", this.menuFestival, iconeFestival);
		this.atualizarDanca = this.criarMenuItem("Atualizar Dana", this.menuDanca, iconeFestival);;
		this.removerFestival = this.criarMenuItem("Remover Festival", this.menuFestival, iconeFestival);
		this.removerDanca  = this.criarMenuItem("Remover Dana", this.menuDanca, iconeFestival);;

		this.cadastrarProf = this.criarMenuItemGambiarra("Cadastrar Professor", this.cadastrarFuncionario, iconeCadastrar);;
		this.cadastrarAtendente = this.criarMenuItemGambiarra("Cadastrar Atendente", this.cadastrarFuncionario, iconeCadastrar);
		this.cadastrarOutros = this.criarMenuItemGambiarra("Cadastrar Outros", this.cadastrarFuncionario, iconeCadastrar);

		alunos = this.criarMenuItem("Alunos", this.menuRelatorio, iconeRelatorio);
		turma= this.criarMenuItem("Turma", this.menuRelatorio, iconeRelatorio);;
		funcionario= this.criarMenuItem("Funcionrio", this.menuRelatorio, iconeRelatorio);;
		despesa= this.criarMenuItem("Despesa", this.menuRelatorio, iconeRelatorio);;
		parceria= this.criarMenuItem("Escola Parceira", this.menuRelatorio, iconeRelatorio);;
		modalidade= this.criarMenuItem("Modalidade", this.menuRelatorio, iconeRelatorio);;
		livroCaixa= this.criarMenuItem("Livro Caixa", this.menuRelatorio, iconeRelatorio);;

		this.sair = this.criarMenuItem("Sair", this.menuArquivo, iconeSair);
		this.ajuda = this.criarMenuItem("Ajuda", this.menuAjuda, iconeAjuda);

		this.pagarMensalidade = this.criarMenuItem("Pagar Mensalidade", this.menuMensalidade, null);
		//this.devedores = this.criarMenuItem("", this.menuMensalidade, null);

	}


	private void criarJMenu() {

		this.menuArquivo = criarJMenu("Arquivo");
		this.menuCadastrar = criarJMenu("Cadastrar");
		this.menuAtualizar = criarJMenu("Atualizar");
		this.menuRemover = criarJMenu("Remover");
		this.menuConsultar = criarJMenu("Consultar");
		this.menuFestival = criarJMenu("Festival");
		this.menuDanca = criarJMenu("Dana");
		this.menuRelatorio = criarJMenu("Relatro");
		this.menuMensalidade = criarJMenu("Mensalidade");
		this.menuAjuda = criarJMenu("Ajuda");


	}

	private void criarBarraMenu() {
		this.barra =  new JMenuBar();
		this.add(this.barra);
		this.setJMenuBar(this.barra);
	}

	private void instanciarImagem() {

		imagemPaginaInicial = new ImageIcon("ImagemFundo.jpg");
		//	imagemCadastrarAluno = new ImageIcon("Imagem2.png");
		iconeCadastrar = new ImageIcon("cadastrar.png");
		iconeConsultar = new ImageIcon("consultar.png");
		iconeAtualizar = new ImageIcon("atualizar.png");
		iconeFestival = new ImageIcon("festival.png");
		iconeRemover = new ImageIcon("remover.png");
		iconeLogoff = new ImageIcon("logoff.png");
		iconeSair = new ImageIcon("sair.png");
		iconeSobre = new ImageIcon("sobre.png");
		iconeAjuda = new ImageIcon("ajuda.png");
		iconeRelatorio = new ImageIcon("relatorio.png");

	}

	private void criarImagem() {

		//		criarLabelImagem2(labelCadastrarAluno, imagemCadastrarAluno, 200, 20, 150, 80);
		criarLabelImagem2(labelPrincipal, imagemPaginaInicial,0,0, 1000, 600);

	}

	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}


	private void configurarJanela() {

		this.setLayout(null);
		//this.getContentPane().setBackground(Color.PINK);
		this.setTitle("Atena");
		this.setSize(1000, 600);
		this.setResizable(false);
		this.centralizarJanela();


	}

	public JMenuItem criarMenuItem(String s, JMenu menu, ImageIcon imagem) {
		JMenuItem temp = new JMenuItem(s);
		temp.setIcon(imagem);
		menu.add(temp);
		temp.setActionCommand(s);
		temp.addActionListener(this);
		return temp;
	}

	public JMenuItem criarMenuItemGambiarra(String s, JMenuItem menu, ImageIcon imagem) {
		JMenuItem temp = new JMenuItem(s);
		temp.setIcon(imagem);
		menu.add(temp);
		temp.setActionCommand(s);
		temp.addActionListener(this);
		return temp;
	}

	public JMenu criarJMenu(String s) {
		JMenu temp = new JMenu(s);
		this.barra.add(temp);
		temp.setActionCommand(s);
		temp.addActionListener(this);
		return temp;
	}


	public void actionPerformed(ActionEvent arg0) {

		if(arg0.getActionCommand().equalsIgnoreCase("Sair")) {
			System.exit(0);


			//CADASTRAR

		}else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Aluno")) {

			JanelaCadastroAluno janelaCadastroAluno = new JanelaCadastroAluno(this);


		} else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Turma")) {

			JanelaCadastroTurma janelaCadastroTurma = new JanelaCadastroTurma(this);


		} else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Professor")) {

			if(permissao){
				JanelaCadastroProfessor janelaCadastroProfessor = new JanelaCadastroProfessor(this);
			} else {
				new JanelaAviso("Voc no tem permisso para este comando", 1);
			}


		}  else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Atendente")) {

			if(permissao){
				JanelaCadastroAtendente janelaCadastroAtendente = new JanelaCadastroAtendente(this);
			}else {
				new JanelaAviso("Voc no tem permisso para este comando", 1);
			}

		} else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Outros")) {
			if(permissao){
				JanelaCadastroFuncionario janelaCadastroFuncionario = new JanelaCadastroFuncionario(this);
			}else {
				new JanelaAviso("Voc no tem permisso para este comando", 1);
			}
		}else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Despesa")) {

			JanelaCadastrarDespesa janelaCadastroDespesa = new JanelaCadastrarDespesa(this);

		}  else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Parceria")) {

			JanelaCadastroParceria janelaCadastroParceria = new JanelaCadastroParceria(this);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Modalidade")) {

			JanelaCadastroModalidade janelaCadastroModalidade = new JanelaCadastroModalidade(this);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Festival")) {

			JanelaCadastrarFestival janelaCadastroFestival = new JanelaCadastrarFestival(this);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Cadastrar Dana")) {

			JanelaCadastroDanca janelaCadastroDanca = new JanelaCadastroDanca(this);




			//REMOVER



		}else if(arg0.getActionCommand().equalsIgnoreCase("Remover Aluno")) {

			Vector<Aluno> alunos = this.getFachada().gerarRelatorioAluno();
			int n = alunos.size();
			String[][] aluno = new String[n][3];

			for(int i = 0; i < n; i++){
				aluno[i][0] = alunos.get(i).getNome();
				aluno[i][1] = alunos.get(i).getNomeMae();
				aluno[i][2] = String.valueOf(alunos.get(i).getCodigoAluno());				
			}

			JanelaRemocao janelaRemocaoAluno = new JanelaRemocao(this, "Selecione o aluno a ser removido", aluno);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Remover Turma")) {

			Vector<Turma> turmas = this.getFachada().gerarRelatorioTurma();
			int n = turmas.size();
			String[][] aluno = new String[n][3];

			for(int i = 0; i < n; i++){
				Vector<Dias> dias = this.getFachada().consultarDiasPorCodigoTurma(turmas.get(i).getCodigoTurma());
				aluno[i][0] = turmas.get(i).getNome();
				for (int m = 0; m < dias.size(); m++) {
					if(aluno[i][1] == null){
						aluno[i][1] = "";
					}
					aluno[i][1] = aluno[i][1] + dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));
					
				}

				aluno[i][2] = String.valueOf(turmas.get(i).getCodigoTurma());				
			}

			JanelaRemocao janelaRemocaoTurma = new JanelaRemocao(this, "Selecione a turma a ser removida", aluno);


		}else if(arg0.getActionCommand().equalsIgnoreCase("Remover Funcionrio")) {

			if(permissao){
				Vector<Funcionario> funcionario = this.getFachada().gerarRelatorioFuncionario();
				int n = funcionario.size();
				String[][] funcionario2 = new String[n][3];

				for(int i = 0; i < n; i++){
					funcionario2[i][0] = funcionario.get(i).getNome();
					funcionario2[i][1] = funcionario.get(i).getFuncao();
					funcionario2[i][2] = String.valueOf(funcionario.get(i).getCpf());				
				}

				JanelaRemocao janelaRemocaoFuncionario = new JanelaRemocao(this, "Selecione o funcionrio a ser removido", funcionario2);
			}else {
				new JanelaAviso("Voc no tem permisso para este comando", 1);
			}

		} else if(arg0.getActionCommand().equalsIgnoreCase("Remover Despesa")) {

			Vector<Despesa> despesa = this.getFachada().gerarRelatorioDespesa();
			int n = despesa.size();
			String[][] despesa2 = new String[n][3];

			for(int i = 0; i < n; i++){
				despesa2[i][0] = despesa.get(i).getEmpresaBeneficiada();
				despesa2[i][1] = String.valueOf(despesa.get(i).getValor());
				despesa2[i][2] = String.valueOf(despesa.get(i).getCodigoDespesa());				
			}

			JanelaRemocao janelaRemocaoDespesa = new JanelaRemocao(this, "Selecione a despesa a ser removida", despesa2);


		} else if(arg0.getActionCommand().equalsIgnoreCase("Remover Parceria")) {

			Vector<EscolaParceira> escolas = this.getFachada().gerarRelatorioEscola();
			int n = escolas.size();
			String[][] escola = new String[n][3];

			for(int i = 0; i < n; i++){
				escola[i][0] = escolas.get(i).getNome();
				escola[i][1] = escolas.get(i).getTelefone();
				escola[i][2] = String.valueOf(escolas.get(i).getCod_escola());				
			}

			JanelaRemocao janelaRemocaoParceria = new JanelaRemocao(this, "Selecione a escola parceira a ser removida", escola);


		} else if(arg0.getActionCommand().equalsIgnoreCase("Remover Modalidade")) {


			Vector<Modalidade> modalidades = this.getFachada().gerarRelatorioModalidade();
			int n = modalidades.size();
			String[][] modalidade = new String[n][3];

			for(int i = 0; i < n; i++){
				modalidade[i][0] = modalidades.get(i).getNome();
				modalidade[i][1] = String.valueOf(modalidades.get(i).getValor());
				modalidade[i][2] = String.valueOf(modalidades.get(i).getNome());				
			}

			JanelaRemocao janelaRemocaoModalidade = new JanelaRemocao(this, "Selecione a modalidade a ser removida", modalidade);

		}  else if(arg0.getActionCommand().equalsIgnoreCase("Remover Festival")) {

			JanelaRemocao janelaRemocaoFestival = new JanelaRemocao(this, "Selecione o festival a ser removido", null);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Remover Dana")) {

			JanelaRemocao janelaRemocaoDanca = new JanelaRemocao(this, "Selecione a dana a ser removida", null);



			//CONSULTAR




		} else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Aluno")) {

			String [] nomes = {"Consulta Aluno" , "Nome", "Turma", "Nome da me", "Idade", "Sexo", "Danca", "Mensalidade" };
			JanelaSelecaoConsulta janelaSelecao = new JanelaSelecaoConsulta(this, nomes);

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Funcionrio")) {

			String [] nomes = {"Consulta Funcionrio" , "Nome do Funcionrio", "CPF", "Funo", "Login Atendente" };
			JanelaSelecaoConsulta janelaSelecao = new JanelaSelecaoConsulta(this, nomes);

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Turma")) {

			String [] nomes = {"Consulta Turma" , "CPF do Professor", "Sala", "Cdigo", "Nome da Turma", "Modalidade da Turma", "Faixa Etria", "Nome do Aluno" };
			JanelaSelecaoConsulta janelaSelecao = new JanelaSelecaoConsulta(this, nomes);

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Modalidade")) {

			new JanelaConsulta(this, "Modalidade", 2);			

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Escola Parceira")) {

			new JanelaConsulta(this, "Escola Parceira", 2);			

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Despesa")) {

			String [] nomes = {"Consulta Despesa" , "Data de Vencimento", "Empresa", "Status" };
			JanelaSelecaoConsulta janelaSelecao = new JanelaSelecaoConsulta(this, nomes);

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Festival")) {

			String [] nomes = {"Consulta Aluno" , "Nome do aluno", "Turma", "Nome da me", "Idade", "Sexo", "Danca" };
			JanelaSelecaoConsulta janelaSelecao = new JanelaSelecaoConsulta(this, nomes);

		}else if(arg0.getActionCommand().equalsIgnoreCase("Consultar Danca")) {

			String [] nomes = {"Consulta Aluno" , "Nome do aluno", "Turma", "Nome da me", "Idade", "Sexo", "Danca" };
			JanelaSelecaoConsulta janelaSelecao = new JanelaSelecaoConsulta(this, nomes);


			//ATUALIZAR


		} else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Aluno")) {

			listaAlunosAtualizar = this.getFachada().gerarRelatorioAluno();
			int n = listaAlunosAtualizar.size();
			String[][] aluno = new String[n][3];

			for(int i = 0; i < n; i++){
				aluno[i][0] = listaAlunosAtualizar.get(i).getNome();
				aluno[i][1] = listaAlunosAtualizar.get(i).getNomeMae();
				aluno[i][2] = String.valueOf(listaAlunosAtualizar.get(i).getCodigoAluno());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione o aluno a ser atualizado", aluno);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Parceria")) {

			listaEscolasAtualizar = this.getFachada().gerarRelatorioEscola();
			int n = listaEscolasAtualizar.size();
			String[][] escola = new String[n][3];

			for(int i = 0; i < n; i++){
				escola[i][0] = listaEscolasAtualizar.get(i).getNome();
				escola[i][1] = listaEscolasAtualizar.get(i).getTelefone();
				escola[i][2] = String.valueOf(listaEscolasAtualizar.get(i).getCod_escola());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione a escola parceira a ser atualizada", escola);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Funcionario")) {

			if(permissao){
				listaFuncionariosAtualizar = this.getFachada().gerarRelatorioFuncionario();
				int n = listaFuncionariosAtualizar.size();
				String[][] f = new String[n][3];

				for(int i = 0; i < n; i++){
					f[i][0] = listaFuncionariosAtualizar.get(i).getNome();
					f[i][1] = listaFuncionariosAtualizar.get(i).getFuncao();
					f[i][2] = String.valueOf(listaFuncionariosAtualizar.get(i).getCpf());				
				}
				JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione o funcionario a ser atualizado", f);
			} else {
				new JanelaAviso("Voc no tem permisso para este comando", 1);
			}


		} else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Despesa")) {

			listaDespesasAtualizar = this.getFachada().gerarRelatorioDespesa();
			int n = listaDespesasAtualizar.size();
			String[][] f = new String[n][3];

			for(int i = 0; i < n; i++){
				f[i][0] = listaDespesasAtualizar.get(i).getEmpresaBeneficiada();
				f[i][1] = String.valueOf(listaDespesasAtualizar.get(i).getValor());
				f[i][2] = String.valueOf(listaDespesasAtualizar.get(i).getCodigoDespesa());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione a despesa a ser atualizada", f);


		}  else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Modalidade")) {

			listaModalidadeAtualizar = this.getFachada().gerarRelatorioModalidade();

			int n = listaModalidadeAtualizar.size(); 
			String[][] f = new String[n][3];

			for(int i = 0; i < n; i++){
				f[i][0] = listaModalidadeAtualizar.get(i).getNome();
				f[i][1] = String.valueOf(listaModalidadeAtualizar.get(i).getValor());
				f[i][2] = String.valueOf(listaModalidadeAtualizar.get(i).getNome());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione a modalidade a ser atualizada", f);



		} else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Festival")) {

			listaFestivalAtualizar = this.getFachada().gerarRelatorioFestival();

			int n = listaFestivalAtualizar.size(); 
			String[][] f = new String[n][3];

			for(int i = 0; i < n; i++){
				f[i][0] = listaFestivalAtualizar.get(i).getNome();
				f[i][1] = String.valueOf(listaFestivalAtualizar.get(i).getData());
				f[i][2] = String.valueOf(listaFestivalAtualizar.get(i).getCod_Festival());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione o festival a ser atualizado", f);

		} else if(arg0.getActionCommand().equalsIgnoreCase("Atualizar Turma")) {

			listaTurmaAtualizar = this.getFachada().gerarRelatorioTurma();

			int n = listaTurmaAtualizar.size(); 
			String[][] f = new String[n][3];

			for(int i = 0; i < n; i++){
				f[i][0] = listaTurmaAtualizar.get(i).getNome();
				f[i][1] = String.valueOf(listaTurmaAtualizar.get(i).getNomeModalidade());
				f[i][2] = String.valueOf(listaTurmaAtualizar.get(i).getCodigoTurma());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione a turma a ser atualizada", f);

		}  
		else if(arg0.getActionCommand().equalsIgnoreCase("Pagar Mensalidade")) {

			listaAlunosAtualizar = this.getFachada().gerarRelatorioAluno();
			int n = listaAlunosAtualizar.size();
			String[][] aluno = new String[n][3];

			for(int i = 0; i < n; i++){
				aluno[i][0] = listaAlunosAtualizar.get(i).getNome();
				aluno[i][1] = listaAlunosAtualizar.get(i).getNomeMae();
				aluno[i][2] = String.valueOf(listaAlunosAtualizar.get(i).getCodigoAluno());				
			}
			JanelaEscolhaAtualizar janelaEscolha = new JanelaEscolhaAtualizar(null,this, "Selecione o aluno:", aluno);


		} else if(arg0.getActionCommand().equalsIgnoreCase("Efetuar Logoff")) {

			this.dispose();
			new JanelaLogin();


		}   else if(arg0.getActionCommand().equalsIgnoreCase("Alunos")) {
			String[][] conteudo;
			int tamanho = 0;
			Vector<Aluno> alunosVector = this.getFachada().gerarRelatorioAluno();
			tamanho = alunosVector.size();
			conteudo = new String[tamanho][9];
			for(int i = 0; i < tamanho; i++){
				conteudo[i][0] = alunosVector.get(i).getNome();
				conteudo[i][1] = String.valueOf(alunosVector.get(i).getIdade());
				conteudo[i][2] = alunosVector.get(i).getCpf();
				conteudo[i][3] = alunosVector.get(i).getTelefones().get(0);
				conteudo[i][4] = alunosVector.get(i).getEndereco();
				conteudo[i][5] = alunosVector.get(i).getNascimento();
				conteudo[i][6] = alunosVector.get(i).getNomeEscola();
				conteudo[i][7] = alunosVector.get(i).getNomeMae();
				conteudo[i][8] = alunosVector.get(i).getNomePai();

			}

			new JanelaRelatorio(this, conteudo, 4);    


		}else if(arg0.getActionCommand().equalsIgnoreCase("Turma")) {

			String[][] conteudo;
			int tamanho = 0;
			Vector<Turma> turmasVector = this.getFachada().gerarRelatorioTurma();
			tamanho = turmasVector.size();
			conteudo = new String[tamanho][7];
			for(int i = 0; i < tamanho; i++){
				Vector<Dias> dias = this.getFachada().consultarDiasPorCodigoTurma(turmasVector.get(i).getCodigoTurma());
				int quantDias = dias.size();
				int m = quantDias - 1;

				if(quantDias == 0){

					conteudo[i][3] = " ";

				} else {

					conteudo[i][3] = dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));
					m--;
					while(m >= 0){

						conteudo[i][3] = conteudo[i][3] + " / " + dias.get(m).getDia() + " " + String.valueOf(dias.get(m).getHoraInicio()) + ":" + String.valueOf((dias.get(m).getMinutoInicio()) + " as " + String.valueOf(dias.get(m).getHoraFinal()) + ":" + String.valueOf((dias.get(m).getMinutoFinal())));

						m--;

					}			


				}
				conteudo[i][0] = String.valueOf(turmasVector.get(i).getCodigoTurma());
				conteudo[i][1] = turmasVector.get(i).getNome();
				if(turmasVector.get(i).getIdadeMaxima() == 0){
					conteudo[i][2] = "A partir de " + turmasVector.get(i).getIdadeMinima();

				} else {
					conteudo[i][2] = turmasVector.get(i).getIdadeMinima() + " a " + turmasVector.get(i).getIdadeMaxima();

				}
				conteudo[i][4] = String.valueOf(turmasVector.get(i).getSala());
				conteudo[i][5] = turmasVector.get(i).getNomeModalidade();
				conteudo[i][6] = this.getFachada().consultarFuncionarioPorCPF(turmasVector.get(i).getCpfProfessor()).get(0).getNome();

			}

			new JanelaRelatorio(this, conteudo, 5);    


		}else if(arg0.getActionCommand().equalsIgnoreCase("Funcionrio")) {
			String[][] conteudo;
			int tamanho = 0;
			Vector<Funcionario> funcionariosVector = this.getFachada().gerarRelatorioFuncionario();
			tamanho = funcionariosVector.size();
			conteudo = new String[tamanho][10];
			for(int i = 0; i < tamanho; i++){    

				if(funcionariosVector.get(i) instanceof Atendente){

					conteudo[i][0] = funcionariosVector.get(i).getNome();
					conteudo[i][1] = funcionariosVector.get(i).getCpf();
					conteudo[i][2] = funcionariosVector.get(i).getRg();
					conteudo[i][3] = funcionariosVector.get(i).getSexo() + "";
					conteudo[i][4] = funcionariosVector.get(i).getNascimento();
					conteudo[i][5] = funcionariosVector.get(i).getTelefone();
					conteudo[i][6] = funcionariosVector.get(i).getEndereco();
					conteudo[i][7] = funcionariosVector.get(i).getEmail();
					conteudo[i][8] = funcionariosVector.get(i).getFuncao();
					conteudo[i][9] = String.valueOf(funcionariosVector.get(i).getSalario());

				} else if(funcionariosVector.get(i) instanceof Professor){

					conteudo[i][0] = funcionariosVector.get(i).getNome();
					conteudo[i][1] = funcionariosVector.get(i).getCpf();
					conteudo[i][2] = funcionariosVector.get(i).getRg();
					conteudo[i][3] = funcionariosVector.get(i).getSexo() + "";
					conteudo[i][4] = funcionariosVector.get(i).getNascimento();
					conteudo[i][5] = funcionariosVector.get(i).getTelefone();
					conteudo[i][6] = funcionariosVector.get(i).getEndereco();
					conteudo[i][7] = funcionariosVector.get(i).getEmail();
					conteudo[i][8] = funcionariosVector.get(i).getFuncao();
					conteudo[i][9] = String.valueOf(funcionariosVector.get(i).getSalario());

				} else {

					conteudo[i][0] = funcionariosVector.get(i).getNome();
					conteudo[i][1] = funcionariosVector.get(i).getCpf();
					conteudo[i][2] = funcionariosVector.get(i).getRg();
					conteudo[i][3] = funcionariosVector.get(i).getSexo() + "";
					conteudo[i][4] = funcionariosVector.get(i).getNascimento();
					conteudo[i][5] = funcionariosVector.get(i).getTelefone();
					conteudo[i][6] = funcionariosVector.get(i).getEndereco();
					conteudo[i][7] = funcionariosVector.get(i).getEmail();
					conteudo[i][8] = funcionariosVector.get(i).getFuncao();
					conteudo[i][9] = String.valueOf(funcionariosVector.get(i).getSalario());
				} 
			}

			new JanelaRelatorio(this, conteudo, 6);    


		}else if(arg0.getActionCommand().equalsIgnoreCase("Escola Parceira")) {
			String[][] conteudo;
			int tamanho = 0;
			Vector<EscolaParceira> escolasVector = this.getFachada().gerarRelatorioEscola();
			tamanho = escolasVector.size();
			conteudo = new String[tamanho][5];
			for(int i = 0; i < tamanho; i++){    
				conteudo[i][0] = escolasVector.get(i).getCod_escola();
				conteudo[i][1] = escolasVector.get(i).getNome();
				conteudo[i][2] = escolasVector.get(i).getTelefone();
				conteudo[i][3] = escolasVector.get(i).getResponsavel();
				conteudo[i][4] = escolasVector.get(i).getEndereco();
			}

			new JanelaRelatorio(this, conteudo, 9);


		}else if(arg0.getActionCommand().equalsIgnoreCase("Modalidade")) {
			String[][] conteudo;
			int tamanho = 0;
			Vector<Modalidade> modalidadesVector = this.getFachada().gerarRelatorioModalidade();
			tamanho = modalidadesVector.size();
			conteudo = new String[tamanho][2];
			for(int i = 0; i < tamanho; i++){    
				conteudo[i][0] = modalidadesVector.get(i).getNome();
				conteudo[i][1] = String.valueOf(modalidadesVector.get(i).getValor());
			}


			new JanelaRelatorio(this, conteudo, 7);    


		}else if(arg0.getActionCommand().equalsIgnoreCase("Livro Caixa")) {


		}else if(arg0.getActionCommand().equalsIgnoreCase("Despesas")){
			String[][] conteudo;
			int tamanho = 0;
			Vector<Despesa> despesasVector = this.getFachada().gerarRelatorioDespesa();
			tamanho = despesasVector.size();
			conteudo = new String[tamanho][5];
			for(int i = 0; i < tamanho; i++){    
				conteudo[i][0] = despesasVector.get(i).getCodigoDespesa();
				conteudo[i][1] = String.valueOf(despesasVector.get(i).getValor());
				conteudo[i][2] = despesasVector.get(i).getDataVencimento();
				conteudo[i][3] = despesasVector.get(i).getDataPagamento();
				conteudo[i][4] = despesasVector.get(i).getEmpresaBeneficiada();
			}
			new JanelaRelatorio(this, conteudo, 8);    
		}
	}





	public Vector<Modalidade> getListaModalidadeAtualizar() {
		return listaModalidadeAtualizar;
	}

	public void setListaModalidadeAtualizar(Vector<Modalidade> listaModalidadeAtualizar) {
		this.listaModalidadeAtualizar = listaModalidadeAtualizar;
	}

	public Vector<Aluno> getListaAlunosAtualizar() {
		return listaAlunosAtualizar;
	}

	public void setListaAlunosAtualizar(Vector<Aluno> listaAlunosAtualizar) {
		this.listaAlunosAtualizar = listaAlunosAtualizar;
	}

	public Vector<EscolaParceira> getListaEscolasAtualizar() {
		return listaEscolasAtualizar;
	}

	public void setListaEscolasAtualizar(
			Vector<EscolaParceira> listaEscolasAtualizar) {
		this.listaEscolasAtualizar = listaEscolasAtualizar;
	}


	public Vector<Funcionario> getListaFuncionariosAtualizar() {
		return listaFuncionariosAtualizar;
	}

	public void setListaFuncionariosAtualizar(
			Vector<Funcionario> listaFuncionariosAtualizar) {
		this.listaFuncionariosAtualizar = listaFuncionariosAtualizar;
	}

	public void keyPressed(KeyEvent e) {


	}

	public void keyReleased(KeyEvent e) {

	}

	public void keyTyped(KeyEvent e) {

	}



	public void centralizarJanela(){

		Dimension dim = this.getToolkit().getScreenSize();      
		int x = (int) (dim.getWidth()  - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x,y);

	}

	public Fachada getFachada() {
		return fachada;
	}

	public void setFachada(Fachada fachada) {
		this.fachada = fachada;
	}

	public Vector<Despesa> getListaDespesasAtualizar() {
		return listaDespesasAtualizar;
	}

	public void setListaDespesasAtualizar(Vector<Despesa> listaDespesasAtualizar) {
		this.listaDespesasAtualizar = listaDespesasAtualizar;
	}

	public Vector<Festival> getListaFestivalAtualizar() {
		return listaFestivalAtualizar;
	}

	public void setListaFestivalAtualizar(Vector<Festival> listaFestivalAtualizar) {
		this.listaFestivalAtualizar = listaFestivalAtualizar;
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}
	public Vector<Turma> getListaTurmaAtualizar() {
		return listaTurmaAtualizar;
	}

	public void setListaTurmaAtualizar(Vector<Turma> listaTurmaAtualizar) {
		this.listaTurmaAtualizar = listaTurmaAtualizar;
	}
	




} 


