package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class JanelaRelatorio extends JFrame implements MouseListener{
	
	private Tabela tabela;
	private int tipoRelatorio;
	private String[][] conteudo;
	
	private JanelaPrincipal janelaPrincipal;

	
	public JanelaRelatorio(JanelaPrincipal janela, String[][] conteudo, int tipoRelatorio){
		this.janelaPrincipal = janela;
		this.tipoRelatorio = tipoRelatorio;
		this.conteudo = conteudo;
		this.criarJanela();
	}

	private void criarJanela() {
		this.setTitle("Resultado da Consulta");
		
		this.setResizable(false);
		
		if(tipoRelatorio == 4){
			this.tabela = new Tabela("", 30, 60, 1050, 235, 4, conteudo, null);
			this.setSize(1120, 450);
		}else if(tipoRelatorio == 5){
			this.tabela = new Tabela("", 30, 60, 755, 235, 5, conteudo, null);
			this.setSize(825, 450);
		}else if(tipoRelatorio == 6){
			this.setSize(1120, 450);
			this.tabela = new Tabela("", 30, 60, 1050, 235, 6, conteudo, null);
		}else if(tipoRelatorio == 7){
			this.setSize(330, 450);
			this.tabela = new Tabela("", 30, 60, 260, 235, 7, conteudo, null);
		}else if(tipoRelatorio == 8){
			this.setSize(705, 450);
			this.tabela = new Tabela("", 30, 60, 635, 235, 8, conteudo, null);
		}else if(tipoRelatorio == 9){
			this.setSize(770, 450);
			this.tabela = new Tabela("", 30, 60, 700, 235, 9, conteudo, null);
		}
		
		this.tabela.setLayout(null);
		this.tabela.setOpaque(true);
		this.setContentPane(this.tabela);
		
		this.centralizarJanela();
		
		this.setVisible(true);
		
	}
	
	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}
	
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(90, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}
	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {



	}

	public void mouseEntered(MouseEvent arg0) {



	}

	@Override
	public void mouseExited(MouseEvent arg0) {

	


	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}	

}
