package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class JanelaSelecaoBailarinos extends JFrame implements MouseListener {
	
	private JLabel texto;
	private Tabela tabela;
	private JanelaPrincipal janela;
	
	private ImageIcon imagemBotaoOk;
	private ImageIcon imagemBotaoCancelar;
	private JLabel botaoOk;
	private JLabel botaoCancelar;
	
	private JLabel ok;
	private JLabel cancela;

	private JLabel imagemFundo;
	private ImageIcon imagem;
	
	
	
	public JanelaSelecaoBailarinos(JanelaPrincipal janela){
		this.janela = janela;
		this.criarJanela();
	}
	
	public void criarJanela(){
		this.setTitle("Seleo Bailarinos");
		this.setSize(620, 400);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();
		this.tabela = new Tabela("", 30, 60, 560, 235, 3, null,null);
		this.tabela.setLayout(null);
		this.tabela.setOpaque(true);
		this.setContentPane(this.tabela);
		
		this.texto = criarLabel("Selecione os bailarinos que participaro da dana:", 30, 20);
		texto.setFont(new Font("Verdana", Font.BOLD, 11));
		
		this.ok = criarLabel("Confirmar", 470, 325);
		this.ok.setFont(new Font("Verdana",Font.BOLD,13));

		this.cancela = criarLabel("Cancelar", 100, 325);
		this.cancela.setFont(new Font("Verdana",Font.BOLD,13));
		
		imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");	
		botaoOk = criarLabel("", 400, 310);
		botaoOk.setSize(70, 50);
		botaoOk.setIcon(imagemBotaoOk);
		botaoOk.addMouseListener(this);

		imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");	
		botaoCancelar = criarLabel("", 30 , 310);
		botaoCancelar.setSize(70, 50);
		botaoCancelar.setIcon(imagemBotaoCancelar);
		botaoCancelar.addMouseListener(this);
		
		imagem = new ImageIcon("Teste1.jpg");
		criarLabelImagem2(imagemFundo, imagem,0,0, 620, 700);

		
		
		this.setVisible(true);
	}
	
	private void criarLabelImagem2(JLabel label, ImageIcon imagem, int x, int y, int largura, int altura) {

		label = new JLabel();
		label.setLayout(null);
		label.setIcon(imagem);
		label.setSize(largura, altura);
		label.setLocation(x,y);
		this.add(label);

	}
	
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		label.setLayout(null);
		label.setSize(290, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}
	
	public void centralizarJanela(){
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth() ) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight() ) / 2;
		this.setLocation(x, y);
	}

	public void mouseClicked(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			JanelaAviso janelaAviso = new JanelaAviso("Remoo efetuada com sucesso", 1);
			this.dispose();

		} else if(arg0.getComponent() == botaoCancelar){

			JanelaTemCerteza janelaTemCerteza = new JanelaTemCerteza("Tem certeza que deseja cancelar?");
			int a = janelaTemCerteza.responder();

			if(a == 0){ // yes
				this.dispose();				
			} 

		}
	} 

	@Override
	public void mouseEntered(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkFrescura.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaFrescura.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}

	}

	public void mouseExited(MouseEvent arg0) {

		if(arg0.getComponent() == botaoOk){

			imagemBotaoOk = new ImageIcon("BotaoOkNormal.png");
			botaoOk.setIcon(imagemBotaoOk);

		} else if(arg0.getComponent() == botaoCancelar){

			imagemBotaoCancelar = new ImageIcon("BotaoCancelaNormal.png");
			botaoCancelar.setIcon(imagemBotaoCancelar);

		}


	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	
	
}
