package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.*;

public class JanelaSelecaoConsulta extends JFrame implements ActionListener,
ItemListener, MouseListener {

	private JLabel texto;
	private ButtonGroup grupo;
	private JButton ok;
	private JanelaPrincipal janelaPrincipal;
	private Vector <JRadioButton> radios;

	public JanelaSelecaoConsulta(JanelaPrincipal janelaPrincipal, String[] textos) {
		this.janelaPrincipal = janelaPrincipal;
		this.criarJanela(textos);
	}

	public void criarJanela(String[] textos) {
		this.setTitle(textos[0]);
		this.setLayout(null);
		this.setResizable(false);
		
		this.radios = new Vector<JRadioButton>();
		this.texto = this.criarLabel("Escolha o modo de busca:", 30, 30);
		this.grupo = new ButtonGroup();
		JRadioButton radio = this.criarRadioButton(textos[1], 50, 60);
		radio.setSelected(true);
		this.radios.add(radio);
		this.grupo.add(radio);
		int y = 90;
		
		for(int i = 2; i < textos.length; i++){
			radio = this.criarRadioButton(textos[i], 50, y);
			this.radios.add(radio);
			this.grupo.add(radio);
			y = y + 30;
		}

		this.ok = new JButton("Ok");
		this.ok.setSize(80, 20);
		this.ok.addActionListener(this);
		this.add(ok);
		
		if(textos[0].equalsIgnoreCase("Consulta Despesa")){		
			this.setSize(310, 220);
			this.ok.setLocation(115, 160);
		}else if(textos[0].equalsIgnoreCase("Consulta Turma")){		
			this.setSize(310, 350);
			this.ok.setLocation(115, 270);
		}else if(textos[0].equalsIgnoreCase("Consulta Funcionrio")){		
			this.setSize(310, 260);
			this.ok.setLocation(115, 200);
		}else{
			this.setSize(310, 340);
			this.ok.setLocation(115, 280);
		}
		
		this.centralizarJanela();

		this.setVisible(true);

	}

	public JLabel criarLabel(String nome, int xPosicao, int yPosicao) {
		JLabel label = new JLabel(nome);
		Font fonte = new Font("Verdana", 11, 11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(220, 20);
		label.setLocation(xPosicao, yPosicao);
		this.add(label);
		return label;
	}


	public JRadioButton criarRadioButton(String nome, int xPosicao, int yPosicao) {
		JRadioButton radio = new JRadioButton(nome);
		this.add(radio);
		radio.setSize(150, 20);
		radio.setLocation(xPosicao, yPosicao);
		return radio;
	}

	public void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}

	public void mouseClicked(MouseEvent arg0) {

	}

	public void actionPerformed(ActionEvent e) {
		
		if(e.getActionCommand().equalsIgnoreCase("Ok")){
			
			int i = 0;
			while(i < radios.size()){				
				if(radios.get(i).isSelected()) {
					break;
				}
				i++;
			}

			String informacaoConsulta = radios.get(i).getActionCommand();
			this.dispose();
			
			if(informacaoConsulta.equalsIgnoreCase("Nome da me") || informacaoConsulta.equalsIgnoreCase("Idade")
					|| informacaoConsulta.equalsIgnoreCase("Nome") || informacaoConsulta.equalsIgnoreCase("Cdigo")
					|| informacaoConsulta.equalsIgnoreCase("CPF do Professor") || informacaoConsulta.equalsIgnoreCase("Faixa Etria")
					|| informacaoConsulta.equalsIgnoreCase("Nome do Funcionrio") || informacaoConsulta.equalsIgnoreCase("CPF")
					|| informacaoConsulta.equalsIgnoreCase("Funo") || informacaoConsulta.equalsIgnoreCase("Data de Vencimento")
					|| informacaoConsulta.equalsIgnoreCase("Empresa") || informacaoConsulta.equalsIgnoreCase("Login Atendente")){
			
				new JanelaConsulta(janelaPrincipal, informacaoConsulta, 1);		
				this.dispose();

			}else if(informacaoConsulta.equalsIgnoreCase("Danca") || informacaoConsulta.equalsIgnoreCase("Turma")
					|| informacaoConsulta.equalsIgnoreCase("Nome da Turma") || informacaoConsulta.equalsIgnoreCase("Modalidade")
					|| informacaoConsulta.equalsIgnoreCase("Sala") || informacaoConsulta.equalsIgnoreCase("Modalidade da Turma")){
				new JanelaConsulta(janelaPrincipal, informacaoConsulta, 2);		
				this.dispose();

			}else if(informacaoConsulta.equalsIgnoreCase("Sexo") || informacaoConsulta.equalsIgnoreCase("Mensalidade")
					|| informacaoConsulta.equalsIgnoreCase("Status")){
				new JanelaConsulta(janelaPrincipal, informacaoConsulta, 3);	
				this.dispose();

			} else if(informacaoConsulta.equalsIgnoreCase("Nome do Aluno")){
				new JanelaConsulta(janelaPrincipal, informacaoConsulta, 4);	
				this.dispose();
			}
			
		}

	}
	
	@Override
	public void mouseEntered(MouseEvent arg0) {

	}

	@Override
	public void mouseExited(MouseEvent arg0) {
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void itemStateChanged(ItemEvent arg0) {
		// TODO Auto-generated method stub

	}
}
