package gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;


public class JanelaVendaIngresso extends JFrame implements ActionListener{

	private JLabel numeracao;
	private JTextField caixaTextoNumeracao;
	private JLabel valor;
	private JTextField caixaTextoValor;
	private JButton escolherAlunos;
	private JanelaPrincipal janelaPrincipal;

		
	public JanelaVendaIngresso(JanelaPrincipal janela) {
		this.janelaPrincipal = janela;
		this.criarJanela();
	}
	
	public void criarJanela() {
		
		this.setTitle("Venda de ingressos");
		this.setSize(260, 200);
		this.setLayout(null);
		this.setResizable(false);
		this.centralizarJanela();
		
		this.numeracao = criarLabel("Numerao:", 30, 30);
		this.caixaTextoNumeracao = criarCaixaTexto(100, 20, 110, 30);
		
		this.valor = criarLabel("Valor (R$):", 30, 60);
		this.caixaTextoValor = criarCaixaTexto(40, 20, 110, 60);
	   
		this.setVisible(true);
		
	}
	
	public JLabel criarLabel(String nome, int xPosicao, int yPosicao){
		JLabel label = new JLabel(nome);
		this.add(label);
		Font fonte = new Font("Verdana",11,11);
		label.setFont(fonte);
		label.setLayout(null);
		label.setSize(130, 20);
		label.setLocation(xPosicao, yPosicao);
		return label;
	}

	public JTextField criarCaixaTexto(int xTamanho, int yTamanho, int xPosicao, int yPosicao){
		JTextField caixaTexto = new JTextField();
		this.add(caixaTexto);
		caixaTexto.setLayout(null);
		caixaTexto.setSize(xTamanho, yTamanho);
		caixaTexto.setLocation(xPosicao, yPosicao);
		return caixaTexto;
	}
	
	private void centralizarJanela() {
		Dimension dim = this.getToolkit().getScreenSize();
		int x = (int) (dim.getWidth() - this.getSize().getWidth()) / 2;
		int y = (int) (dim.getHeight() - this.getSize().getHeight()) / 2;
		this.setLocation(x, y);
	}
	
	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
	
	
}
