package negocio;

import java.util.Vector;
import repositorios.RepositorioDespesa;
import basicas.Despesa;

public class NegocioDespesa {

	RepositorioDespesa rd;

	public NegocioDespesa() {

		this.rd = new RepositorioDespesa();
	}

	public void inserirDespesa(Despesa despesa){

		
		this.rd.inserirDespesa(despesa);

	}

	public void atualizarDespesa(int codDespesa, Despesa despesaAtualizada){

		this.rd.atualizarDespesa(codDespesa, despesaAtualizada);
	}

	public boolean removerDespesa(int codDespesa){

		boolean retorno = false;

		retorno = this.rd.removerDespesa(codDespesa);

		return retorno;		
	}

	public Vector<Despesa> consultarDespesaPorDataVencimento(String dataVencimento){

		Vector<Despesa> retorno;

		retorno = this.rd.consultarDespesaPorDataVencimento(dataVencimento);

		return retorno;
	}

	public Vector<Despesa> consultarDespesaPorEmpresa(String empresaBeneficiada){

		Vector<Despesa> retorno;

		retorno = this.rd.consultarDespesaPorEmpresa(empresaBeneficiada);

		return retorno;
	}

	public Vector<Despesa> consultarDespesaPorStatus(String status){

		Vector<Despesa> retorno;

		retorno = this.rd.consultarDespesaPorStatus(status);

		return retorno;
	}
	
	public Vector<Despesa> gerarRelatorioDespesa(){
		
		return this.rd.gerarRelatorioDespesas();
	}

	/*public static void main(String[] args) {

		Despesa d = new Despesa(1,"07266998845", "10072010", "", (float) 5000.99, "TEATRO UFPE");
		Despesa d2 = new Despesa(2,"07266998845", "10072010", "", (float) 50.89, "CELPE");
		Despesa d3 = new Despesa(3,"07266998845", "11082010", "", (float) 88.89, "COMPESA");

		NegocioRepositorioDespesa nrd = new NegocioRepositorioDespesa();

		nrd.inserirDespesa(d);
		nrd.inserirDespesa(d2);
		nrd.inserirDespesa(d3);

		//nrd.atualizarDespesa(1, new Despesa(-1,"","11072010","11072010",(float)4900.99,"Centro de Convenes da UFPE"));
		//nrd.atualizarDespesa(2, new Despesa(2,"", "08072010", "07072010", (float) 50.89, "Conta de energia - CELPE"));
		//nrd.atualizarDespesa(3, new Despesa(3,"", "02082010", "01082010", (float) 88.89, "Conta de agua - COMPESA"));

		//nrd.removerDespesa(1);
		//nrd.removerDespesa(2);
		//nrd.removerDespesa(3);

		*//**Consultar despesas pela data de vencimento**//*

		Vector<Despesa> despesas = nrd.consultarDespesaPorDataVencimento("10072010");

		for(int i = 0; i < despesas.size(); i++){

			System.out.println("COD. :" + despesas.get(i).getCodigoDespesa() + '\n' + 
							   "CPF ATENDENTE :" + despesas.get(i).getCpf_atendente() + '\n' +
							   "DATA VENCIMENTO :" + despesas.get(i).getDataVencimento() + '\n' +
							   "DATA PAGAMENTO :" + despesas.get(i).getDataPagamento() + '\n' +
							   "VALOR :" + despesas.get(i).getValor() + '\n' + 
							   "EMPRESA BENEFICIADA. :" + despesas.get(i).getEmpresaBeneficiada());
			System.out.println();
		}

		*//**Consultar despesas por empresa beneficiada**//*

		Vector<Despesa> despesas = nrd.consultarDespesaPorEmpresa("CELPE");

		for(int i = 0; i < despesas.size(); i++){

			System.out.println("COD. :" + despesas.get(i).getCodigoDespesa() + '\n' + 
					"CPF ATENDENTE :" + despesas.get(i).getCpf_atendente() + '\n' +
					"DATA VENCIMENTO :" + despesas.get(i).getDataVencimento() + '\n' +
					"DATA PAGAMENTO :" + despesas.get(i).getDataPagamento() + '\n' +
					"VALOR :" + despesas.get(i).getValor() + '\n' + 
					"EMPRESA BENEFICIADA. :" + despesas.get(i).getEmpresaBeneficiada());
			System.out.println();
		}

		*//**Consultar despesas por Status**//*

		Vector<Despesa> desp = nrd.consultarDespesaPorStatus("sim");

		for(int i = 0; i < desp.size(); i++){

			System.out.println("COD. :" + desp.get(i).getCodigoDespesa() + '\n' + 
					"CPF ATENDENTE :" + desp.get(i).getCpf_atendente() + '\n' +
					"DATA VENCIMENTO :" + desp.get(i).getDataVencimento() + '\n' +
					"DATA PAGAMENTO :" + desp.get(i).getDataPagamento() + '\n' +
					"VALOR :" + desp.get(i).getValor() + '\n' + 
					"EMPRESA BENEFICIADA. :" + desp.get(i).getEmpresaBeneficiada());
			System.out.println();
		}

	}
*/
}
