package negocio;

import java.util.Vector;


import Excecao.AtendenteExistenteException;
import Excecao.FuncionarioExistenteException;
import Excecao.ProfessoreExistenteException;
import basicas.Atendente;
import basicas.Funcionario;
import basicas.Professor;
import repositorios.RepositorioFuncionario;

public class NegocioFuncionario {

	RepositorioFuncionario rf;

	public NegocioFuncionario() {

		this.rf = new RepositorioFuncionario();

	}

	public Vector<Funcionario> gerarRelatorioFuncionario(){

		return this.rf.gerarRelatorioFuncionarios();
	}

	public void inserirProfessor(Professor p) throws ProfessoreExistenteException{

		if(!this.rf.existe(p.getCpf())){

			this.rf.inserirProfessor(p);

		} else {			
			throw new ProfessoreExistenteException();
		}
	}

	public void inserirAtendente(Atendente a) throws AtendenteExistenteException {

		if(!this.rf.existe(a.getCpf())){

			this.rf.inserirAtendente(a);

		} else {

			throw new AtendenteExistenteException();

		}
	}
	public void inserirOutroFuncionario(Funcionario f) throws FuncionarioExistenteException {

		if(!this.rf.existe(f.getCpf())){

			this.rf.inserirOutroFuncionario(f);

		} else {

			throw new FuncionarioExistenteException();

		}

	}

	public void  atualizarProfessor(String cpf, Professor professorAtualizado){

		this.rf.atualizarProfessor(cpf, professorAtualizado);
	}

	public void  atualizarAtendente(String cpf, Atendente atendenteAtualizado){
		this.rf.atualizarAtendente(cpf, atendenteAtualizado);

	}

	public void atualizarOutroFuncionario(String cpf, Funcionario funcionarioAtualizado){

		this.rf.atualizarOutroFuncionario(cpf, funcionarioAtualizado);

	}

	public void removerProfessor(String cpf){

		this.rf.removerProfessor(cpf);

	}

	public void removerAtendente(String cpf){
		this.rf.removerAtendente(cpf);
	}

	public void removerOutroFuncionario(String cpf){
		this.rf.removerOutroFuncionario(cpf);
	}

	public Vector<Funcionario> consultarFuncionarioPorNome(String nome){

		Vector<Funcionario> retorno = new Vector<Funcionario>();

		retorno = this.rf.consultarFuncionarioPorNome(nome);

		return retorno;

	}

	public Vector<Funcionario> consultarFuncionarioPorCPF(String cpf){

		Vector<Funcionario> retorno = new Vector<Funcionario>();

		Funcionario f = this.rf.consultarFuncionarioPorCPF(cpf);
		if(f != null){
			retorno.add(this.rf.consultarFuncionarioPorCPF(cpf));

		} 

		return retorno;

	}

	public Vector<Funcionario> consultarFuncionarioPorFuncao(String funcao){

		Vector<Funcionario> retorno = new Vector<Funcionario>();

		retorno = this.rf.consultarFuncionarioPorFuncao(funcao);

		return retorno;

	}

	public Vector<Professor> gerarRelatorioProfessor() {

		return this.rf.gerarRelatorioProfessores();

	}

	public Vector<Funcionario> consultarAtendentePorLogin(String textoUm) {

		return consultarAtendentePorLogin(textoUm);
	}


}
