package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import util.ManipulacaoData;
import basicas.Aluno;
import conexao.Conexao;

public class RepositorioAluno {

	private PreparedStatement ps;
	private Conexao conexao;

	public RepositorioAluno() {
		conexao = new Conexao();
	}

	public boolean existeAluno(String nomeAluno, String nomeMae) {
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String SELECT_ALUNO = "SELECT count(*) from Aluno where nome = ? and nome_mae = ?";
		Long quantidade = new Long(-7);

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			ps.setString(1, nomeAluno);
			ps.setString(2, nomeMae);
			rs = ps.executeQuery();
			rs.next();
			quantidade = (Long) rs.getObject(1);
			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		if (quantidade == 0) {
			return false;
		} else {
			return true;
		}

	}

	// talvez de pau na foto!
	public void atualizarAluno(Aluno aluno) {
		Connection conn = conexao.conectarBD();

		final String UPDATE_ALUNO = "UPDATE Aluno SET nome = ?, cpf = ?, rg = ?, endereco = ?, "
				+ "alergias = ?, escola = ?, serie = ?, nome_mae = ?, prof_mae = ?, nome_pai = ?,"
				+ "prof_pai = ?, autorizacao = ?, dia_venc = ?, desconto = ?, foto = ?, irmao = ?,"
				+ "telefone1 = ?, telefone2 = ?, telefone3 = ?, cod_escola = ?, sexo = ?, data_nasc = ?,"
				+"email = ?, plano_saude = ?, data_matricula = ? WHERE cod_aluno = ?";

		try {
			ps = conn.prepareStatement(UPDATE_ALUNO);
			ps.setString(1, aluno.getNome());
			ps.setString(2, aluno.getCpf());
			ps.setString(3, aluno.getRg());
			ps.setString(4, aluno.getEndereco());
			ps.setString(5, aluno.getAlergias());
			ps.setString(6, aluno.getNomeEscola());
			ps.setString(7, aluno.getSerie());
			ps.setString(8, aluno.getNomeMae());
			ps.setString(9, aluno.getProfissaoMae());
			ps.setString(10, aluno.getNomePai());
			ps.setString(11, aluno.getProfissaoPai());

			if (aluno.isAutorizacao()) {
				ps.setString(12, "S");
			} else {
				ps.setString(12, "N");
			}

			ps.setInt(13, aluno.getDiaVencimento());
			ps.setDouble(14, aluno.getMensalidade());
			ps.setBytes(15, aluno.getFoto());

			if (aluno.isTemIrmao()) {
				ps.setString(16, "S");
			} else {
				ps.setString(16, "N");
			}

			ps.setString(17, aluno.getTelefones().get(0));
			ps.setString(18, aluno.getTelefones().get(1));
			ps.setString(19, aluno.getTelefones().get(2));

			ps.setInt(20, aluno.getCodigoEscola());
			ps.setString(21, aluno.getSexo() + "");
			ps.setString(22, aluno.getNascimento());
			
			ps.setString(23, aluno.getEmail());
			ps.setString(24, aluno.getPlanoSaude());
			ps.setString(25, aluno.getDataMatricula());

			ps.setString(26, aluno.getCodigoAluno());

			ps.executeUpdate();
			ps.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
	}

	public void inserirAluno(Aluno aluno) {
		Connection conn = conexao.conectarBD();
		final String INSERT_ALUNO = "INSERT INTO Aluno VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
		try {

			ps = conn.prepareStatement(INSERT_ALUNO);
			ps.setString(1, null);
			ps.setString(2, aluno.getNome());
			ps.setString(3, aluno.getCpf());
			ps.setString(4, aluno.getRg());
			ps.setString(5, aluno.getEndereco());
			ps.setString(6, (aluno.getSexo() + ""));
			ps.setString(7, aluno.getNascimento());
			ps.setString(8, aluno.getAlergias());
			ps.setString(9, aluno.getNomeEscola());
			ps.setString(10, aluno.getSerie());
			ps.setString(11, aluno.getNomeMae());
			ps.setString(12, aluno.getProfissaoMae());
			ps.setString(13, aluno.getNomePai());
			ps.setString(14, aluno.getProfissaoPai());

			if (aluno.isAutorizacao()) {
				ps.setString(15, "S");
			} else {
				ps.setString(15, "N");
			}

			ps.setInt(16, aluno.getDiaVencimento());
			ps.setDouble(17, aluno.getMensalidade());
			ps.setBytes(18, aluno.getFoto());

			if (aluno.isTemIrmao()) {
				ps.setString(19, "S");
			} else {
				ps.setString(19, "N");
			}
			ps.setString(20, aluno.getTelefones().get(0));
			ps.setString(21, aluno.getTelefones().get(1));
			ps.setString(22, aluno.getTelefones().get(2));

			ps.setInt(23, aluno.getCodigoEscola());

			ps.setString(24, aluno.getEmail());
			ps.setString(25, aluno.getPlanoSaude());
			ps.setString(26, aluno.getDataMatricula());

			ps.executeUpdate();
			ps.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		conexao.fecharConexao();
	}

	public void removerAluno(int codigoAluno) {
		Connection conn = conexao.conectarBD();
		final String DELETE_ALUNO = "DELETE FROM Aluno WHERE cod_aluno = ?;";

		try {
			ps = conn.prepareStatement(DELETE_ALUNO);
			ps.setInt(1, codigoAluno);
			ps.executeUpdate();
			ps.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
	}

	public Vector<Aluno> consultarAlunoPorSexo(String sexo) {
		Connection conn = conexao.conectarBD();
		final String SELECT_ALUNO = "SELECT *FROM Aluno where sexo = ? ORDER BY nome;";
		ResultSet rs = null;
		Aluno aluno;
		Vector<Aluno> alunos = new Vector<Aluno>();

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			ps.setString(1, sexo);
			rs = ps.executeQuery();

			while (rs.next()) {
				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);

				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
						.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

				aluno.setIdade(idade);
				alunos.add(aluno);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return alunos;
	}

	public Vector<Aluno> consultarAlunoPorTurma(int codTurma) {
		Connection conn = conexao.conectarBD();
		final String SELECT_ALUNO = "SELECT *FROM Aluno A, compoe C, Turma T WHERE C.cod_aluno = A.cod_aluno AND T.codigo_turma = ? AND T.codigo_turma = C.codigo_turma ORDER BY A.nome;";
		ResultSet rs = null;
		Aluno aluno;
		Vector<Aluno> alunos = new Vector<Aluno>();

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			ps.setInt(1, codTurma);
			rs = ps.executeQuery();

			while (rs.next()) {
				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);

				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
						.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

				aluno.setIdade(idade);
				alunos.add(aluno);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return alunos;
	}

	public Vector<Aluno> gerarRelatorioAluno() {
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String SELECT_ALUNO = "SELECT *FROM Aluno ORDER BY nome;";
		Vector<Aluno> alunos = new Vector<Aluno>();
		Aluno aluno;

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			rs = ps.executeQuery();

			while (rs.next()) {

				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);

				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), 
						String.valueOf(rs.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));


				aluno.setIdade(idade);
				alunos.add(aluno);

			}
			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}
		conexao.fecharConexao();
		return alunos;
	}

	public Vector<Aluno> consultarAlunoPorMae(String nomeMae) {
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String SELECT_ALUNO = "SELECT *FROM Aluno WHERE nome_mae LIKE ?;";
		Vector<Aluno> alunos = new Vector<Aluno>();
		Aluno aluno;
		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			ps.setString(1, "%" + nomeMae + "%");
			rs = ps.executeQuery();

			while (rs.next()) {
				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);

				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
						.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

				aluno.setIdade(idade);
				alunos.add(aluno);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return alunos;
	}

	@SuppressWarnings("deprecation")
	private int calcularIdadeAluno(String nascimento) {
		Date agora = null;
		// dataAtual
		ManipulacaoData.pegarDataAtual();
		String dAtual = ManipulacaoData.getIntegerDia() + "" + "/"
				+ ManipulacaoData.getIntegerMes() + "" + "/"
				+ ManipulacaoData.getIntegerAno() + "";

		SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy");

		try {
			agora = format.parse(dAtual);
		} catch (ParseException e1) {
			e1.printStackTrace();
		}

		int idade = -5;
		// calcular a idade
		try {
			Date nasc = format.parse(nascimento);

			idade = (agora.getYear() - nasc.getYear());
			boolean ehMenor = this.compararDatas(agora, nasc);

			if (ehMenor) {
				idade--;
			}
		} catch (ParseException e) {
			e.printStackTrace();
		}

		return idade;
	}

	private boolean compararDatas(Date agora, Date nasc) {
		int now = agora.getMonth();
		int born = nasc.getMonth();

		if (now < born) {
			return true;
		} else if (now > born) {
			return false;
		} else {
			now = agora.getDay();
			born = nasc.getDay();

			if (now < born) {
				return true;
			} else {
				return false;
			}
		}
	}

	@SuppressWarnings("deprecation")
	public Vector<Aluno> consultarAlunoPorIdade(int min, int max) {
		Connection conn = conexao.conectarBD();

		final String SELECT_ALUNO = "SELECT *FROM Aluno";
		ResultSet rs = null;
		Aluno aluno;
		Vector<Aluno> alunos = new Vector<Aluno>();

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			rs = ps.executeQuery();

			while (rs.next()) {

				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);

				if (idade >= min && idade <= max) {

					byte[] foto = rs.getBytes(18);

					String podeSair = (String) rs.getObject(15);
					boolean sair = false;
					String temIrmao = (String) rs.getObject(19);
					boolean irmao = false;

					if (podeSair.equals("S")) {
						sair = true;
					}
					if (temIrmao.equals("S")) {
						irmao = true;
					}

					Vector<String> telefones = new Vector<String>(3);
					telefones.add(0, (String) rs.getObject(20));
					telefones.add(1, (String) rs.getObject(21));
					telefones.add(2, (String) rs.getObject(22));

					aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
							.getInt(1)), (String) rs.getObject(3), (String) rs
							.getObject(4), (String) rs.getObject(5), ((String) rs
							.getObject(6)).charAt(0), nascimento, (String) rs
							.getObject(8), (String) rs.getObject(9), (String) rs
							.getObject(10), (String) rs.getObject(11), (String) rs
							.getObject(12), (String) rs.getObject(13), (String) rs
							.getObject(14), sair, (Integer) rs.getObject(16),
							(Float) rs.getObject(17), foto, irmao, telefones, 
							(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

					aluno.setIdade(idade);
					alunos.add(aluno);

				}
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return alunos;

	}

	public Vector<Aluno> consultarAlunoPorNome(String nomeAluno) {
		Connection conn = conexao.conectarBD();
		final String SELECT_ALUNO = "SELECT *FROM Aluno where nome LIKE ? ORDER BY nome;";
		ResultSet rs = null;
		Aluno aluno;
		Vector<Aluno> alunos = new Vector<Aluno>();

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			ps.setString(1, "%" + nomeAluno + "%");
			rs = ps.executeQuery(); 

			while (rs.next()) {
				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);
				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
						.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

				aluno.setIdade(idade);
				alunos.add(aluno);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return alunos;
	}

	public Vector<Aluno> consultarAlunosPagadores(String mesAno) {
		Connection conn = conexao.conectarBD();
		Vector<Aluno> alunos = new Vector<Aluno>();
		Aluno aluno;
		ResultSet rs = null;
		;
		final String SELECT_ALUNO_MENSALIDADE = "SELECT * FROM Aluno A, Pagamento_Mensalidade P"
				+ "WHERE A.cod_aluno = P.cod_aluno and P.mes_ano = ? ORDER BY A.nome";
		try {
			ps = conn.prepareStatement(SELECT_ALUNO_MENSALIDADE);
			ps.setString(1, mesAno);
			rs = ps.executeQuery();

			while (rs.next()) {
				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);
				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
						.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

				aluno.setIdade(idade);
				alunos.add(aluno);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return alunos;
	}

	// se der erro  pq no segundo conjunto tem duas tabelas - gambiarra mode on
	// :D
	public Vector<Aluno> consultarAlunosDevedores(String mesAno) {
		Vector<Aluno> alunosDevedores = new Vector<Aluno>();
		Vector<Integer> codigosDevedores = new Vector<Integer>();
		Aluno aluno;
		ResultSet rs = null;
		Connection conn = conexao.conectarBD();

		final String SELECT_ALUNO_MENSALIDADE = "(SELECT cod_aluno FROM Aluno) MINUS "
				+ "(SELECT cod_aluno FROM Aluno A, Pagamento_Mensalidade P "
				+ "where A.cod_aluno = P.cod_aluno and P.mes_ano = ?)";

		try {
			ps = conn.prepareStatement(SELECT_ALUNO_MENSALIDADE);
			ps.setString(1, mesAno);
			rs = ps.executeQuery();

			while (rs.next()) {
				Integer cod = (Integer) rs.getObject(1);
				codigosDevedores.add(cod);
			}
			rs.close();
			ps.close();
		} catch (SQLException e1) {
			e1.printStackTrace();
		}

		final String SELECT_ALUNO = "SELECT *FROM ALUNO where cod_aluno = ?";

		for (int i = 0; i < codigosDevedores.size(); i++) {

			try {
				ps = conn.prepareStatement(SELECT_ALUNO);
				ps.setInt(1, codigosDevedores.get(i));
				rs = ps.executeQuery();

				while (rs.next()) {
					byte[] foto = rs.getBytes(18);

					String podeSair = (String) rs.getObject(15);
					boolean sair = false;
					String temIrmao = (String) rs.getObject(19);
					boolean irmao = false;

					if (podeSair.equals("S")) {
						sair = true;
					}
					if (temIrmao.equals("S")) {
						irmao = true;
					}

					// calcular a idade
					String nascimento = (String) rs.getObject(7);
					int idade = this.calcularIdadeAluno(nascimento);
					Vector<String> telefones = new Vector<String>(3);
					telefones.add(0, (String) rs.getObject(20));
					telefones.add(1, (String) rs.getObject(21));
					telefones.add(2, (String) rs.getObject(22));
					
					
					aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
							.getInt(1)), (String) rs.getObject(3), (String) rs
							.getObject(4), (String) rs.getObject(5), ((String) rs
							.getObject(6)).charAt(0), nascimento, (String) rs
							.getObject(8), (String) rs.getObject(9), (String) rs
							.getObject(10), (String) rs.getObject(11), (String) rs
							.getObject(12), (String) rs.getObject(13), (String) rs
							.getObject(14), sair, (Integer) rs.getObject(16),
							(Float) rs.getObject(17), foto, irmao, telefones, 
							(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

					aluno.setIdade(idade);
					alunosDevedores.add(aluno);
				}

				rs.close();
				ps.close();

			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		conexao.fecharConexao();
		return alunosDevedores;
	}

	public Vector<Aluno> consultarAlunoPorDanca(int chaveDanca,
			int chaveFestival) {
		Connection conn = conexao.conectarBD();
		final String SELECT_ALUNO = "SELECT *FROM Aluno A, participa P, Danca D, Festival F"
				+ " WHERE P.cod_aluno = A.cod_aluno AND D.cod_danca = ? AND D.cod_danca = P.cod_danca"
				+ "F.cod_festival = ? AND F.cod_festival = D.cod_festival ORDER BY A.nome;";
		ResultSet rs = null;
		Aluno aluno;
		Vector<Aluno> alunos = new Vector<Aluno>();

		try {
			ps = conn.prepareStatement(SELECT_ALUNO);
			ps.setInt(1, chaveDanca);
			ps.setInt(2, chaveFestival);
			rs = ps.executeQuery();

			while (rs.next()) {
				byte[] foto = rs.getBytes(18);

				String podeSair = (String) rs.getObject(15);
				boolean sair = false;
				String temIrmao = (String) rs.getObject(19);
				boolean irmao = false;

				if (podeSair.equals("S")) {
					sair = true;
				}
				if (temIrmao.equals("S")) {
					irmao = true;
				}

				// calcular a idade
				String nascimento = (String) rs.getObject(7);
				int idade = this.calcularIdadeAluno(nascimento);
				Vector<String> telefones = new Vector<String>(3);
				telefones.add(0, (String) rs.getObject(20));
				telefones.add(1, (String) rs.getObject(21));
				telefones.add(2, (String) rs.getObject(22));

				aluno = new Aluno((String) rs.getObject(2), String.valueOf(rs
						.getInt(1)), (String) rs.getObject(3), (String) rs
						.getObject(4), (String) rs.getObject(5), ((String) rs
						.getObject(6)).charAt(0), nascimento, (String) rs
						.getObject(8), (String) rs.getObject(9), (String) rs
						.getObject(10), (String) rs.getObject(11), (String) rs
						.getObject(12), (String) rs.getObject(13), (String) rs
						.getObject(14), sair, (Integer) rs.getObject(16),
						(Float) rs.getObject(17), foto, irmao, telefones, 
						(String) rs.getObject(24), (String) rs.getObject(25), (String) rs.getObject(26));

				aluno.setIdade(idade);
				alunos.add(aluno);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return alunos;
	}

	/*
	 * public static void main(String[] args) { RepositorioAluno rep = new
	 * RepositorioAluno(); Vector<String> telefones = new Vector<String>(3);
	 * telefones.add(0, "8152013694"); telefones.add(1, ""); telefones.add(2,
	 * "8110225479"); Aluno caue = new Aluno("Caue Botelho", 2, "07890520409",
	 * "7777137", "Rua Dom Carlos Coelho # Boa Vista", 'M', "20071989",
	 * "bruno, frescura, fome", "Mazzarello", "6 Serie", "Siria Silva",
	 * "Psicologa", "Alexandre Ribeiro Botelho", "Educador", true, 10, 0.0,
	 * null, false, telefones); caue.setCodigoEscola(3); //
	 * rep.inserirAluno(caue); rep.atualizarAluno(caue);
	 * 
	 * Vector<Aluno> alunos = rep.consultarAlunoPorIdade(12, 20);
	 * 
	 * for (int i = 0; i < alunos.size(); i++) { System.out.println("nome: " +
	 * alunos.get(i).getNome() + " idade: " + alunos.get(i).getIdade());
	 * 
	 * }
	 * 
	 * boolean s = rep.existeAluno("Alice Lucena",
	 * "Vania Maria Lucena Cavalcanti"); boolean n =
	 * rep.existeAluno("Bruno Sabino", "Ivanise Sabino");
	 * 
	 * System.out.println(s + " " + n); }
	 */
}

// funcionando = atualizar, remover, inserir, consultarIdade
