package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.Turma;
import conexao.Conexao;

public class RepositorioCompoe {
	PreparedStatement ps;
	Conexao conexao;

	public RepositorioCompoe() {
		conexao = new Conexao();

	}

	public void inserirCompoe(Vector<Integer> codigoTurmas, int codigoAluno) {
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando;

		for (int i = 0; i < codigoTurmas.size(); i++) {
			conn = c.conectarBD();

			comando = "INSERT INTO Compoe VALUES (?, ?); ";

			try {
				PreparedStatement ps = conn.prepareStatement(comando);
				ps.setInt(1, codigoTurmas.get(i));
				ps.setInt(2, codigoAluno);
				ps.executeUpdate();
				ps.close();
				c.fecharConexao();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public boolean removerCompoe(int codigoTurma, int codigoAluno) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM compoe WHERE codigo_turma= ? and cod_aluno=?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoTurma);
			ps.setInt(2, codigoAluno);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean removerTodasTurmasDoAluno(int codigoAluno) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM compoe WHERE cod_aluno=?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoAluno);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Vector<Turma> consultarTurmaPorAluno(int codigoAluno) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT * FROM Turma T,Compoe C WHERE cod_aluno = ? and C.codigo_turma = T.codigo_turma;";
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoAluno);
			rs = ps.executeQuery();

			while (rs.next()) {
				turma = new Turma(String.valueOf(rs.getInt(1)), rs.getString(2), rs
						.getString(3), rs.getString(4), rs.getInt(5), rs
						.getInt(6), rs.getInt(7));

				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}

	public static void main(String[] args) {
		// Vector<Integer> a = new Vector<Integer>();
		// a.add(1);
		// a.add(2);
		//		
		// new RepositorioCompoe().inserirCompoe( a,1);
		// new RepositorioCompoe().removerTodasTurmasDoAluno(1);
		Vector<Turma> t = new RepositorioCompoe().consultarTurmaPorAluno(1);
		System.out.println(t.size() + "//");
		for (int i = 0; i < t.size(); i++) {
			Turma tu = t.get(i);
			System.out.println(tu.getCodigoTurma());

		}
	}
}