package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import conexao.Conexao;

import basicas.Danca;
import basicas.Despesa;
import basicas.Festival;


public class RepositorioDanca {
	PreparedStatement ps;
	Conexao conexao = null;
	
	public void inserirDanca(Danca danca){
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando = "INSERT INTO Danca VALUES (?,?,?,?); ";

		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, danca.getCod_danca());
			ps.setString(2, danca.getNome());
			ps.setInt(3, danca.getCodigoFestival());
			ps.setDouble(4, danca.getValorRoupa());
			ps.executeUpdate();
			ps.close();
			c.fecharConexao();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	


	}
	public boolean atualizarDanca(int codigoDanca, Danca danca){

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "UPDATE Danca SET nome = ? WHERE codigo_danca= ?";
		String comando2 = "UPDATE Danca SET valor = ? WHERE codigo_danca= ?";
		
		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			



			
			ps.setString(1, danca.getNome());
			ps.setInt(2, codigoDanca);
			
			ps2.setDouble(1, danca.getValorRoupa());
			ps2.setInt(2, codigoDanca);

		
			ps.execute();
			ps2.execute();

			ps.close();
			ps2.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return retorno;
	}	
	
	public boolean removerDanca(int codigoDanca){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Danca WHERE codigo_danca = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoDanca);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
	
		public Vector<Danca> consultarDancaPorNome(String nome) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Danca WHERE nome = ?;";
		Vector<Danca> dancas= new Vector<Danca>();
		Danca danca;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, nome);
			rs = ps.executeQuery();

			while (rs.next()) {
				danca = new Danca((String)rs.getString(1),(String)rs.getString(2) ,(int) rs.getInt(3), (double) rs.getDouble(4));
			
				dancas.add(danca);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return dancas;
	}
		public Danca consultarDancaPeloCodigo(int codigoDanca) {
			conexao = new Conexao();
			Connection conn = conexao.conectarBD();
			ResultSet rs = null;
			final String comando = "SELECT *FROM Danca WHERE codigo_danca= ?;";
			Danca danca = null;
			try {
				ps = conn.prepareStatement(comando);
				ps.setInt(1, codigoDanca);
				rs = ps.executeQuery();
				rs.next();
				
				danca = new Danca((String)rs.getString(1),(String)rs.getString(2) ,(int) rs.getInt(3), (double) rs.getDouble(4));
				

				rs.close();
				ps.close();

			} catch (SQLException e) {
				e.printStackTrace();
			}

			conexao.fecharConexao();

			return danca;
		}

	public Vector<Danca> consultarDancasPorCodigoDeFestival(int codigoFestival) {
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Danca WHERE codigo_festival LIKE ?;";
		Vector<Danca> dancas= new Vector<Danca>();
		Danca danca;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoFestival);
			rs = ps.executeQuery();

			while (rs.next()) {
				danca = new Danca((String)rs.getString(1),(String)rs.getString(2) ,(int) rs.getInt(3), (double) rs.getDouble(4));
			
				dancas.add(danca);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return dancas;
	}
	public boolean existeDanca(int codigoDanca){

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Danca WHERE codigo_danca= ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoDanca);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if(rs.getInt(1) != 0){

				retorno = true;			
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
		
	public Vector<Danca> gerarRelatorioDanca() {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Danca ;";
		Vector<Danca> dancas= new Vector<Danca>();
		Danca danca;
		try {

			ps = conn.prepareStatement(comando);
			rs = ps.executeQuery();

			while (rs.next()) {
				danca = new Danca((String)rs.getString(1),(String)rs.getString(2) ,(int) rs.getInt(3), (double) rs.getDouble(4));
			
				dancas.add(danca);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return dancas;
	}


	/*public static void main(String[] args) {
		
		Danca danca = new Danca(4, "quadrilha", 1, 20.50);
		Danca danca2 = new Danca(5, "caboclinho", 1, 25.50);
		Danca danca3 = new Danca(6, "farra",1, 30.50);
		RepositorioDanca r = new RepositorioDanca();*/
//		r.inserirDanca(danca3);
//		r.inserirDanca(danca2);
//		r.inserirDanca(danca);
////		r.removerDanca(1);
//		r.atualizarDanca(2, danca3);
		
//		Danca danca4 = r.consultarDancaPorNome("quadrilha").get(0);
//		Danca danca5 = r.consultarDancasPorCodigoDeFestival(1).get(1);
//		Danca danca6 = r.consultarDancasPorCodigoDeFestival(1).get(1);
//		
//		System.out.println(danca4.getCodigoFestival()+" "+danca4.getNome());
//		System.out.println(danca5.getCodigoFestival()+" "+danca5.getNome());
//		System.out.println(danca6.getCodigoFestival()+" "+danca6.getNome());
//		
//		System.out.println(r.existe(1));
//		System.out.println(r.existe(2));
//		System.out.println(r.existe(10));
//		Vector<Danca> dancas = new Vector<Danca>();
		/*Danca danc = r.consultarDancaPeloCodigo(2);
		System.out.println(danc.getCod_danca()+" "+danc.getNome());*/
//		for(int i =0;i<dancas.size();i++){
//			Danca d = dancas.get(i);
//		}
		

}
