package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.Danca;
import basicas.Despesa;
import basicas.Dias;
import basicas.Festival;
import conexao.Conexao;

public class RepositorioDias {

	PreparedStatement ps;
	Conexao conexao = null;
	
	public void inserirDias(Dias dias){
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando = "INSERT INTO Dias VALUES (?,?,?,?,?,?); ";
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, dias.getDia());
			ps.setInt(2, dias.getCodigoTurma());
			ps.setInt(3, dias.getHoraInicio());
			ps.setInt(4, dias.getMinutoInicio());
			ps.setInt(5, dias.getHoraFinal());
			ps.setInt(6, dias.getMinutoFinal());
			ps.executeUpdate();
			ps.close();
            c.fecharConexao();			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}
	
		
	public boolean removerDias(String dia, int codigoTurma ){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		//// cuidado  pois a chave primria  com mais de um atributo
		String comando = "DELETE FROM Dias WHERE dias = ? and codigo_turma = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, dia);
			ps.setInt(2, codigoTurma);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
	
	public boolean atualizarDias(String dias,int codigoTurma, Dias dia){

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando  = "UPDATE Dias SET dias = ? WHERE dias = ? and codigo_turma = ?";
		String comando2 = "UPDATE Dias SET codigo_turma = ? WHERE dias = ? and codigo_turma = ?";
		String comando3 = "UPDATE Dias SET hora_inicio = ? WHERE dias = ? and codigo_turma = ?";
		String comando4 = "UPDATE Dias SET minuto_inicio = ? WHERE dias = ? and codigo_turma = ?";
		String comando5 = "UPDATE Dias SET hora_final= ? WHERE dias = ? and codigo_turma = ?";
		String comando6 = "UPDATE Dias SET minuto_final = ? WHERE dias = ? and codigo_turma = ?";

		try {

			PreparedStatement ps  = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			PreparedStatement ps3 = conn.prepareStatement(comando3);
			PreparedStatement ps4 = conn.prepareStatement(comando4);
			PreparedStatement ps5 = conn.prepareStatement(comando5);
			PreparedStatement ps6 = conn.prepareStatement(comando6);

			ps.setString(1, dia.getDia());
			ps.setString(2, dias);
			ps.setInt(3, codigoTurma);

			ps2.setInt(1, dia.getCodigoTurma());
			ps2.setString(2, dias);
			ps2.setInt(3, codigoTurma);
			
			ps3.setInt(1, dia.getHoraInicio());
			ps3.setString(2, dias);
			ps3.setInt(3, codigoTurma);
			
			ps4.setInt(1, dia.getMinutoInicio());
			ps4.setString(2, dias);
			ps4.setInt(3, codigoTurma);
			
			ps5.setInt(1, dia.getHoraFinal());
			ps5.setString(2, dias);
			ps5.setInt(3, codigoTurma);
			
			ps6.setInt(1, dia.getMinutoFinal());
			ps6.setString(2, dias);
			ps6.setInt(3, codigoTurma);
			
			ps.execute();
			ps2.execute();
			ps3.execute();
			ps4.execute();
			ps5.execute();
			ps6.execute();
			
			ps.close();
			ps2.close();
			ps3.close();
			ps4.close();
			ps5.close();
			ps6.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return retorno;
	}
	public Vector<Dias> consultarDiasPorCodigoTurma(int codigoTurma) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Dias WHERE codigo_turma = ?;";
		Vector<Dias> dias = new Vector<Dias>();
		Dias dia;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoTurma);
			rs = ps.executeQuery();

			while (rs.next()) {
				
				dia = new Dias(rs.getString(1), rs.getInt(2), rs.getInt(3), rs.getInt(4), rs.getInt(5), rs.getInt(6));
				
				dias.add(dia);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return dias;
	}
	public Vector<Dias> gerarRelatorioDanca() {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Dias ;";
		Vector<Dias> dias= new Vector<Dias>();
		Dias dia;
		try {

			ps = conn.prepareStatement(comando);
			rs = ps.executeQuery();

			while (rs.next()) {
				dia = new Dias(rs.getString(1), rs.getInt(2), rs.getInt(3), rs.getInt(4), rs.getInt(5), rs.getInt(6));
			
				dias.add(dia);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return dias;
	}
	public boolean existe(String dia, int codigoTurma){

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Dias WHERE dias = ? and codigo_turma = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, dia);
			ps.setInt(2, codigoTurma);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if(rs.getInt(1) != 0){

				retorno = true;			
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}






	public static void main(String[] args) {
		
//		Dias d = new Dias("tera", 1, 18, 30, 20, 00);
//		Dias d2 = new Dias("quarta", 1, 14, 30, 20, 00);
//		Dias d3= new Dias("quinta", 1, 12, 30, 20, 00);
//		Dias d4 = new Dias("a", 1, 10, 30, 20, 00);
//		Dias d5 = new Dias("", 1, 10, 30, 20, 00);
//		RepositorioDias r = new RepositorioDias();
//		r.inserirDias(d5);
//		r.inserirDias(d2);
//		r.inserirDias(d3);
//		r.inserirDias(d4);
//		r.removerDias("tera", 1);
//		r.atualizarDias("quarta", 1, d);
//		Vector<Dias> dias = new Vector<Dias>();
//		dias = r.gerarRelatorioDanca();
//		for(int i = 0;i<dias.size();i++){
//			Dias di = dias.get(i);
//			System.out.println(di.getCodigoTurma()+" "+di.getDia());
//		}
//		System.out.println(r.existe("tera", 1));
//		System.out.println(r.existe("quarta", 1));
//		System.out.println(r.existe("quinta", 2));
//		System.out.println(r.existe("quinta", 1));
		
	}
}
