package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.EscolaParceira;
import conexao.Conexao;

//Lembrar de throws as excees pra interface e tratar l (mtodo pode ser void :D)

public class RepositorioEscolaParceira {

	private PreparedStatement ps;
	private Conexao conexao;

	public RepositorioEscolaParceira() {
		this.conexao = new Conexao();
	}

	// desse jeito no existe escolas com o mesmo nome, no faz sentido a
	// consulta retornar Vector
	public boolean existeEscola(String nomeEscola) {
		Vector<EscolaParceira> escolas = this.consultarEscola(nomeEscola);
		return escolas.size() > 0;
	}

	
	public void atualizarEscola(EscolaParceira escola) {
		Connection conn = conexao.conectarBD();
		final String UPDATE_ESCOLA  = "UPDATE Escola_parceira SET nome = ?, telefone = ?, responsavel = ?, endereco = ?;";

		try {
			ps = conn.prepareStatement(UPDATE_ESCOLA);
			ps.setString(1, escola.getCod_escola());
			ps.setString(2, escola.getNome());
			ps.setString(3, escola.getTelefone());
			ps.setString(4, escola.getEndereco());
			ps.setString(5, escola.getResponsavel());
			ps.executeUpdate();

			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}
		conexao.fecharConexao();
	}

	// o novo objeto  formado na GUI e vai descendo
	public void inserirEscola(EscolaParceira escola) {
		Connection conn = conexao.conectarBD();
		String comando = "INSERT INTO Escola_Parceira VALUES (?, ?,?,?,?);";
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, null);
			ps.setString(2, escola.getNome());
			ps.setString(3, escola.getTelefone());
			ps.setString(4, escola.getResponsavel());
			ps.setString(5, escola.getEndereco());
			ps.executeUpdate();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}
		conexao.fecharConexao();
	}
	
	public Vector<EscolaParceira> gerarRelatorioEscola(){
		Vector<EscolaParceira> escolas = new Vector<EscolaParceira>();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		EscolaParceira escola;
		final String SELECT_ESCOLA = "SELECT * FROM Escola_Parceira ORDER BY nome;";
		
		try {
			ps = conn.prepareStatement(SELECT_ESCOLA);

			rs = ps.executeQuery();

			while (rs.next()) {

				escola = new EscolaParceira((String) String.valueOf(rs.getObject(1)),
						(String) rs.getObject(2), (String) rs.getObject(3),
						(String) rs.getObject(4), (String) rs.getString(5));
				escolas.add(escola);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return escolas;
	}

	public Vector<EscolaParceira> consultarEscola(String nomeEscola) {
		String comando = "SELECT *FROM Escola_Parceira WHERE nome = ?;";
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		EscolaParceira escola;
		Vector<EscolaParceira> retorno = new Vector<EscolaParceira>();

		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, nomeEscola);
			rs = ps.executeQuery();

			while (rs.next()) {

				escola = new EscolaParceira( String.valueOf(rs.getInt(1)),
						(String) rs.getObject(2), (String) rs.getObject(3),
						(String) rs.getObject(4), (String) rs.getString(5));
				retorno.add(escola);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return retorno;
	}

	public void removerEscola(int codigoEscola) {
		final String DELETE_ESCOLA = "DELETE FROM Escola_Parceira WHERE cod_escola = ?;";
		Connection conn = conexao.conectarBD();

		try {
			ps = conn.prepareStatement(DELETE_ESCOLA);
			ps.setInt(1, codigoEscola);
			ps.executeUpdate();
			ps.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
	}

/*	public static void main(String[] args) {
		EscolaParceira escola = new EscolaParceira(15, "Jesus apaga a luz",
				"8188", "Rua Nmero zero", "Mainha");
		RepositorioEscolaParceira rep = new RepositorioEscolaParceira();
		rep.inserirEscola(escola);
		// rep.removerEscola(15);
		EscolaParceira e = new EscolaParceira(15, "as", "", "", "");
		rep.atualizarEscola(e, 15);
		Vector<EscolaParceira> vectorEscola = rep.consultarEscola("Arco iris");

		for (int i = 0; i < vectorEscola.size(); i++) {

			System.out.println(vectorEscola.get(i).getCod_escola());
			System.out.println(vectorEscola.get(i).getNome());

		}

	}*/
}