package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.EscolaParceira;
import basicas.Festival;
import conexao.Conexao;

public class RepositorioFestival {
	PreparedStatement ps;
	Conexao conexao = null;

	public void inserirFestival(Festival festival) {
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando = "INSERT INTO Festival VALUES (?,?,?,?,?,?); ";
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, null);
			ps.setString(2, festival.getNome());
			ps.setString(3, festival.getData());
			ps.setString(4, festival.getHorario());
			ps.setInt(5, festival.getLotacao());
			ps.setString(6, festival.getLocal());
			ps.executeUpdate();
			ps.close();
			c.fecharConexao();
		} catch (SQLException e) {
			e.printStackTrace();
		}

	}

	public boolean atualizarFestival(int codigoFestival, Festival festival) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "UPDATE Festival SET nome = ? WHERE codigo_festival = ?";
		String comando2 = "UPDATE Festival SET data_do_festival = ? WHERE codigo_festival = ?";
		String comando3 = "UPDATE Festival SET horario = ? WHERE codigo_festival = ?";
		String comando4 = "UPDATE Festival SET lotacao_maxima = ? WHERE codigo_festival = ?";
		String comando5 = "UPDATE Festival SET local_festival = ? WHERE codigo_festival = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			PreparedStatement ps3 = conn.prepareStatement(comando3);
			PreparedStatement ps4 = conn.prepareStatement(comando4);
			PreparedStatement ps5 = conn.prepareStatement(comando5);
			ps.setString(1, festival.getNome());
			ps.setInt(2, codigoFestival);

			ps2.setString(1, festival.getData());
			ps2.setInt(2, codigoFestival);

			ps3.setString(1, festival.getHorario());
			ps3.setInt(2, codigoFestival);

			ps4.setInt(1, festival.getLotacao());
			ps4.setInt(2, codigoFestival);

			ps5.setString(1, festival.getLocal());
			ps5.setInt(2, codigoFestival);

			ps.execute();
			ps2.execute();
			ps3.execute();
			ps4.execute();
			ps5.execute();

			ps.close();
			ps2.close();
			ps3.close();
			ps4.close();
			ps5.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean removerFestival(int codigoFestival) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Festival WHERE codigo_festival = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoFestival);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Vector<Festival> consultarFestivalPorNome(String nome) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Festival WHERE nome LIKE ?;";
		Vector<Festival> festivais = new Vector<Festival>();
		Festival festival;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, nome);
			rs = ps.executeQuery();

			while (rs.next()) {

				festival = new Festival((String) rs.getString(1), (String) rs
						.getString(2), (String) rs.getString(3), rs
						.getString(4), (int) rs.getInt(5), (String) rs
						.getString(6));

				festivais.add(festival);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return festivais;
	}

	public Vector<Festival> consultarFestivalPorLocal(String local) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Festival WHERE local_festival LIKE ?;";
		Vector<Festival> festivais = new Vector<Festival>();
		Festival festival;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, local);
			rs = ps.executeQuery();

			while (rs.next()) {

				festival = new Festival((String) rs.getString(1), (String) rs
						.getString(2), (String) rs.getString(3), rs
						.getString(4), (int) rs.getInt(5), (String) rs
						.getString(6));

				festivais.add(festival);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return festivais;
	}
	public Festival consultarFestivalPorCodigo(int codigoFestival) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Festival WHERE codigo_festival = ?;";
		Festival festival = null;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoFestival);
			rs = ps.executeQuery();
			rs.next();

			festival = new Festival((String) rs.getString(1), (String) rs
					.getString(2), (String) rs.getString(3), rs
					.getString(4), (int) rs.getInt(5), (String) rs
					.getString(6));


			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return festival;
	}

	

	public boolean existeFestival(int codigoFestival) {

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Festival WHERE codigo_festival= ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoFestival);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if (rs.getInt(1) != 0) {

				retorno = true;
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Vector<Festival> gerarRelatorioFestival() {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Festival;";
		Vector<Festival> festivais = new Vector<Festival>();
		Festival festival;
		try {
			ps = conn.prepareStatement(comando);
			rs = ps.executeQuery();

			while (rs.next()) {

				festival = new Festival((String) rs.getString(1), (String) rs
						.getString(2), (String) rs.getString(3), rs
						.getString(4), (int) rs.getInt(5), (String) rs
						.getString(6));

				festivais.add(festival);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return festivais;
	}

	public static void main(String[] args) {
//		Festival f = new Festival(1, "O Festival", "12092010", "1830", 500,
//				"Rio Doce");
		
//		Festival f3 = new Festival(2, "Eita", "12092010", "1800", 350,
//				"Rua do zero");
		RepositorioFestival r = new RepositorioFestival();
//		Festival f =r.consultarFestivalPorCodigo(2);
//		System.out.println(f.getNome()+" "+f.getCod_Festival());
//		r.inserirFestival(f);
//		r.inserirFestival(f3);
		//r.removerFestival(1);
//		r.removerFestival(5);
		
//		Festival fe = new Festival(2, "nsei", "20021989", "2045", 45, "Maranguape");
//		r.atualizarFestival(2, fe);
//		Vector<Festival>  festivais = new Vector<Festival>();
//		festivais = r.gerarRelatorioFestival();
//		System.out.println(festivais.get(0).getCod_Festival()+ " "+festivais.get(0).getNome());
//		System.out.println(festivais.get(1).getCod_Festival()+ " "+festivais.get(1).getNome());
//		if(festivais.size()==2){
//			System.out.println("true");
//		}
		
//		System.out.println(r.existe(1));
//		System.out.println(r.existe(5));
	}

}
