package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.Atendente;
import basicas.Funcionario;
import basicas.Professor;
import conexao.Conexao;

public class RepositorioFuncionario {

	public RepositorioFuncionario(){

	}


	/**
	 * 
	 * Atendente 1 = login com sucesso 0 = senha errada 3 = login inexistente
	 * Administrador 2 = login com sucesso
	 * @throws SQLException
	 */
	public int validarLogin(String login, String senha) throws SQLException {
		Connection conn = new Conexao().conectarBD();
		String comando = "SELECT senha, permissao from Atendente WHERE login like ?;";

		PreparedStatement ps = conn.prepareStatement(comando);
		ps.setString(1, login);
		ResultSet rs = ps.executeQuery();
		if (rs.next()) {
			int permissao = rs.getInt(2);
			String senhaArmazenada = rs.getString("senha");
			if (senha.equals(senhaArmazenada)) {
				if(permissao == 1){
					return 2;
				}else{
					return 1;
				}
			} else {
				return 0;
			}
		} else {
			return 3;
		}
	}


	/**MTODOS PARA INSERIR**/

	public boolean inserirProfessor(Professor p){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "INSERT INTO Funcionario VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
		String comando2 = "INSERT INTO Professor VALUES(?, ?)";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);

			ps.setString(1, p.getCpf());
			ps.setString(2, p.getRg());
			ps.setString(3, p.getNome());
			ps.setString(4, p.getSexo() + "");
			ps.setString(5, p.getNascimento());
			ps.setString(6, p.getEndereco());
			ps.setString(7, p.getEmail());
			ps.setString(8, p.getFuncao());
			ps.setFloat(9, p.getSalario());
			ps.setString(10, p.getTelefone());

			ps2.setString(1, p.getCpf());
			ps2.setFloat(2, p.getHora_aula());

			ps.execute();
			ps2.execute();

			ps.close();
			ps2.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;

	}

	public boolean inserirAtendente(Atendente a){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "INSERT INTO Funcionario VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
		String comando2 = "INSERT INTO Atendente VALUES(?, ?, ?, ?)";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);

			ps.setString(1, a.getCpf());
			ps.setString(2, a.getRg());
			ps.setString(3, a.getNome());
			ps.setString(4, a.getSexo() + "");
			ps.setString(5, a.getNascimento());
			ps.setString(6, a.getEndereco());
			ps.setString(7, a.getEmail());
			ps.setString(8, a.getFuncao());
			ps.setFloat(9, a.getSalario());
			ps.setString(10, a.getTelefone());
			
			System.out.println(a.getCpf());
			System.out.println(a.getLogin());
			System.out.println(a.getSenha());

			ps2.setString(1, a.getCpf());
			ps2.setString(2, a.getLogin());
			ps2.setString(3, a.getSenha());
			ps2.setInt(4, 0);

			ps.execute();
			ps2.execute();

			ps.close();
			ps2.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean inserirOutroFuncionario(Funcionario f){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "INSERT INTO Funcionario VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, f.getCpf());
			ps.setString(2, f.getRg());
			ps.setString(3, f.getNome());
			ps.setString(4, f.getSexo()+ "");
			ps.setString(5, f.getNascimento());
			ps.setString(6, f.getEndereco());
			ps.setString(7, f.getEmail());
			ps.setString(8, f.getFuncao());
			ps.setFloat(9, f.getSalario());
			ps.setString(10, f.getTelefone());

			ps.execute();
			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	/**MTODOS PARA ATUALIZAR**/

	public boolean atualizarProfessor(String cpf, Professor p){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "UPDATE Funcionario SET nome = ? WHERE cpf = ?";
		String comando2 = "UPDATE Funcionario SET sexo = ? WHERE cpf = ?";
		String comando3 = "UPDATE Funcionario SET data_nascimento = ? WHERE cpf = ?";
		String comando4 = "UPDATE Funcionario SET endereco = ? WHERE cpf = ?";
		String comando5 = "UPDATE Funcionario SET email = ? WHERE cpf = ?";
		String comando6 = "UPDATE Funcionario SET funcao = ? WHERE cpf = ?";
		String comando7 = "UPDATE Funcionario SET salario = ? WHERE cpf = ?";

		String comando8 = "UPDATE Professor SET hora_aula = ? WHERE cpf_professor = ?";

		String comando9 = "UPDATE Funcionario SET telefone = ? WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			PreparedStatement ps3 = conn.prepareStatement(comando3);
			PreparedStatement ps4 = conn.prepareStatement(comando4);
			PreparedStatement ps5 = conn.prepareStatement(comando5);
			PreparedStatement ps6 = conn.prepareStatement(comando6);
			PreparedStatement ps7 = conn.prepareStatement(comando7);
			PreparedStatement ps8 = conn.prepareStatement(comando8);
			PreparedStatement ps9 = conn.prepareStatement(comando9);

			ps.setString(1, p.getNome());
			ps.setString(2, cpf);

			ps2.setString(1, p.getSexo()+ "");
			ps2.setString(2, cpf);

			ps3.setString(1, p.getNascimento());
			ps3.setString(2, cpf);

			ps4.setString(1, p.getEndereco());
			ps4.setString(2, cpf);

			ps5.setString(1, p.getEmail());
			ps5.setString(2, cpf);

			ps6.setString(1, p.getFuncao());
			ps6.setString(2, cpf);

			ps7.setFloat(1, p.getSalario());
			ps7.setString(2, cpf);

			ps8.setFloat(1, p.getHora_aula());
			ps8.setString(2, cpf);

			ps9.setString(1, p.getTelefone());
			ps9.setString(2, cpf);

			ps.execute();
			ps2.execute();
			ps3.execute();
			ps4.execute();
			ps5.execute();
			ps6.execute();
			ps7.execute();
			ps8.execute();
			ps9.execute();

			ps.close();
			ps2.close();
			ps3.close();
			ps4.close();
			ps5.close();
			ps6.close();
			ps7.close();
			ps8.close();
			ps9.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean atualizarAtendente(String cpf, Atendente a){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "UPDATE Funcionario SET nome = ? WHERE cpf = ?";
		String comando2 = "UPDATE Funcionario SET sexo = ? WHERE cpf = ?";
		String comando3 = "UPDATE Funcionario SET data_nascimento = ? WHERE cpf = ?";
		String comando4 = "UPDATE Funcionario SET endereco = ? WHERE cpf = ?";
		String comando5 = "UPDATE Funcionario SET email = ? WHERE cpf = ?";
		String comando6 = "UPDATE Funcionario SET funcao = ? WHERE cpf = ?";
		String comando7 = "UPDATE Funcionario SET salario = ? WHERE cpf = ?";
		String comando8 = "UPDATE Atendente SET senha = ? WHERE cpf_atendente = ?";
		String comando9 = "UPDATE Funcionario SET telefone = ? WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			PreparedStatement ps3 = conn.prepareStatement(comando3);
			PreparedStatement ps4 = conn.prepareStatement(comando4);
			PreparedStatement ps5 = conn.prepareStatement(comando5);
			PreparedStatement ps6 = conn.prepareStatement(comando6);
			PreparedStatement ps7 = conn.prepareStatement(comando7);
			PreparedStatement ps8 = conn.prepareStatement(comando8);
			PreparedStatement ps9 = conn.prepareStatement(comando9);

			ps.setString(1, a.getNome());
			ps.setString(2, cpf);

			ps2.setString(1, a.getSexo()+ "");
			ps2.setString(2, cpf);

			ps3.setString(1, a.getNascimento());
			ps3.setString(2, cpf);

			ps4.setString(1, a.getEndereco());
			ps4.setString(2, cpf);

			ps5.setString(1, a.getEmail());
			ps5.setString(2, cpf);

			ps6.setString(1, a.getFuncao());
			ps6.setString(2, cpf);

			ps7.setFloat(1, a.getSalario());
			ps7.setString(2, cpf);

			ps8.setString(1, a.getSenha());
			ps8.setString(2, cpf);

			ps9.setString(1, a.getTelefone());
			ps9.setString(2, cpf);

			ps.execute();
			ps2.execute();
			ps3.execute();
			ps4.execute();
			ps5.execute();
			ps6.execute();
			ps7.execute();
			ps8.execute();
			ps9.execute();

			ps.close();
			ps2.close();
			ps3.close();
			ps4.close();
			ps5.close();
			ps6.close();
			ps7.close();
			ps8.close();
			ps9.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean atualizarOutroFuncionario(String cpf, Funcionario f){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "UPDATE Funcionario SET nome = ? WHERE cpf = ?";
		String comando2 = "UPDATE Funcionario SET sexo = ? WHERE cpf = ?";
		String comando3 = "UPDATE Funcionario SET data_nascimento = ? WHERE cpf = ?";
		String comando4 = "UPDATE Funcionario SET endereco = ? WHERE cpf = ?";
		String comando5 = "UPDATE Funcionario SET email = ? WHERE cpf = ?";
		String comando6 = "UPDATE Funcionario SET funcao = ? WHERE cpf = ?";
		String comando7 = "UPDATE Funcionario SET salario = ? WHERE cpf = ?";
		String comando8 = "UPDATE Funcionario SET telefone = ? WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			PreparedStatement ps3 = conn.prepareStatement(comando3);
			PreparedStatement ps4 = conn.prepareStatement(comando4);
			PreparedStatement ps5 = conn.prepareStatement(comando5);
			PreparedStatement ps6 = conn.prepareStatement(comando6);
			PreparedStatement ps7 = conn.prepareStatement(comando7);
			PreparedStatement ps8 = conn.prepareStatement(comando8);

			ps.setString(1, f.getNome());
			ps.setString(2, cpf);

			ps2.setString(1, f.getSexo()+ "");
			ps2.setString(2, cpf);

			ps3.setString(1, f.getNascimento());
			ps3.setString(2, cpf);

			ps4.setString(1, f.getEndereco());
			ps4.setString(2, cpf);

			ps5.setString(1, f.getEmail());
			ps5.setString(2, cpf);

			ps6.setString(1, f.getFuncao());
			ps6.setString(2, cpf);

			ps7.setFloat(1, f.getSalario());
			ps7.setString(2, cpf);

			ps8.setString(1, f.getTelefone());
			ps8.setString(2, cpf);

			ps.execute();
			ps2.execute();
			ps3.execute();
			ps4.execute();
			ps5.execute();
			ps6.execute();
			ps7.execute();
			ps8.execute();

			ps.close();
			ps2.close();
			ps3.close();
			ps4.close();
			ps5.close();
			ps6.close();
			ps7.close();
			ps8.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	/**MTODOS PARA REMOVER**/

	public boolean removerProfessor(String cpf){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Professor WHERE cpf_professor = ?";
		String comando2 = "DELETE FROM Funcionario WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);

			ps.setString(1, cpf);
			ps2.setString(1, cpf);

			ps.execute();
			ps2.execute();

			ps.close();
			ps2.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean removerAtendente(String cpf){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Atendente WHERE cpf_atendente = ?";
		String comando2 = "DELETE FROM Funcionario WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);

			ps.setString(1, cpf);
			ps2.setString(1, cpf);

			ps.execute();
			ps2.execute();

			ps.close();
			ps2.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean removerOutroFuncionario(String cpf){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Funcionario WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, cpf);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	/**MTODOS PARA CONSULTAR FUNCIONRIO**/

	public Vector<Funcionario> consultarFuncionarioPorNome(String nome){

		Vector<Funcionario> retorno = new Vector<Funcionario>();
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT * FROM Funcionario WHERE nome LIKE ? ORDER BY nome";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, "%" + nome + "%");

			ResultSet rs = ps.executeQuery();

			while(rs.next()){

				if(rs.getString(8).equalsIgnoreCase("professor")
						|| rs.getString(8).equalsIgnoreCase("professora")){

					float hora_aula = consultarHoraAulaProfessor(rs.getString(1));
					Professor professor = new Professor(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), hora_aula, rs.getString(10));
					retorno.add(professor);

				}else if(rs.getString(8).equalsIgnoreCase("atendente")){

					String login = consultarLoginAtendente(rs.getString(1));
					String senha = consultarSenhaAtendente(rs.getString(1));
					Atendente atendente = new Atendente(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), login, senha, rs.getString(10));
					retorno.add(atendente);

				}else{

					Funcionario outroFuncionario = new Funcionario(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), rs.getString(10));
					retorno.add(outroFuncionario);
				}

			}			

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Funcionario consultarFuncionarioPorCPF(String cpf){

		Funcionario retorno = null;
		System.out.println(cpf);
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT * FROM Funcionario WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, cpf);

			ResultSet rs = ps.executeQuery();

			if(rs.next()){
				
				if(rs.getString(8).equalsIgnoreCase("professor")
						|| rs.getString(8).equalsIgnoreCase("professora")){
					
					float hora_aula = consultarHoraAulaProfessor(rs.getString(1));
					Professor professor = new Professor(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), hora_aula, rs.getString(10));
					retorno = professor;
					
				}else if(rs.getString(8).equalsIgnoreCase("atendente")){
					
					String login = consultarLoginAtendente(rs.getString(1));
					String senha = consultarSenhaAtendente(rs.getString(1));
					Atendente atendente = new Atendente(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), login, senha, rs.getString(10));
					retorno = atendente;
					
				}else{
					
					Funcionario outroFuncionario = new Funcionario(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), rs.getString(10));
					retorno = outroFuncionario;
				}
			}


			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;

	}

	public Vector<Funcionario> consultarFuncionarioPorFuncao(String funcao){

		Vector<Funcionario> retorno = new Vector<Funcionario>();
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT * FROM Funcionario WHERE funcao LIKE '%' ? '%' ORDER BY nome";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, funcao);

			ResultSet rs = ps.executeQuery();

			while(rs.next()){

				if(rs.getString(8).equalsIgnoreCase("professor")
						|| rs.getString(8).equalsIgnoreCase("professora")){

					float hora_aula = consultarHoraAulaProfessor(rs.getString(1));
					Professor professor = new Professor(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), hora_aula, rs.getString(10));
					retorno.add(professor);

				}else if(rs.getString(8).equalsIgnoreCase("atendente")){

					String login = consultarLoginAtendente(rs.getString(1));
					String senha = consultarSenhaAtendente(rs.getString(1));
					Atendente atendente = new Atendente(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), login, senha, rs.getString(10));
					retorno.add(atendente);

				}else{

					Funcionario outroFuncionario = new Funcionario(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), rs.getString(10));
					retorno.add(outroFuncionario);
				}			

			}			

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;		

	}

	public Vector<Funcionario> gerarRelatorioFuncionarios(){

		Vector<Funcionario> retorno = new Vector<Funcionario>();
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT * FROM Funcionario ORDER BY nome";


		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ResultSet rs = ps.executeQuery();

			while(rs.next()){

				if(rs.getString(8).equalsIgnoreCase("professor")
						|| rs.getString(8).equalsIgnoreCase("professora")){

					float hora_aula = consultarHoraAulaProfessor(rs.getString(1));
					Professor professor = new Professor(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), hora_aula, rs.getString(10));
					retorno.add(professor);

				}else if(rs.getString(8).equalsIgnoreCase("atendente")){

					String login = consultarLoginAtendente(rs.getString(1));
					String senha = consultarSenhaAtendente(rs.getString(1));
					Atendente atendente = new Atendente(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), login, senha, rs.getString(10));
					retorno.add(atendente);

				}else{

					Funcionario outroFuncionario = new Funcionario(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4).charAt(0), rs.getString(5), rs.getString(6), rs.getString(7), rs.getString(8), rs.getFloat(9), rs.getString(10));
					retorno.add(outroFuncionario);
				}			

			}			

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;		
	}

	public float consultarHoraAulaProfessor(String cpf){

		float retorno = 0;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT hora_aula FROM Professor WHERE cpf_professor = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, cpf);

			ResultSet rs = ps.executeQuery();

			rs.next();

			retorno = rs.getFloat(1);			

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;		

	}

	public String consultarLoginAtendente(String cpf){

		String retorno = "";
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT login FROM Atendente WHERE cpf_atendente = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, cpf);

			ResultSet rs = ps.executeQuery();

		
			if(rs.next()) {
				
				retorno = rs.getString(1);			
				
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;		
	}

	/**
	 * mrsl
	 */
	public Vector<Professor> gerarRelatorioProfessores() {
		Vector<Professor> retorno = new Vector<Professor>();
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT * FROM Funcionario F, Professor P WHERE F.cpf = P.cpf_professor ORDER BY F.nome";

		try {


			PreparedStatement ps = conn.prepareStatement(comando);

			ResultSet rs = ps.executeQuery();

			while (rs.next()) {

				//float hora_aula = consultarHoraAulaProfessor(rs.getString(1));
				Professor professor = new Professor(rs.getString(1), rs
						.getString(2), rs.getString(3), rs.getString(4).charAt(
								0), rs.getString(5), rs.getString(6), rs.getString(7),
								rs.getString(8), rs.getFloat(9), rs.getFloat(11), rs
								.getString(10));
				retorno.add(professor);

			}

			rs.close();
			ps.close();

			c.fecharConexao();


		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public String consultarSenhaAtendente(String cpf){

		String retorno = "";
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT senha FROM Atendente WHERE cpf_atendente = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, cpf);

			ResultSet rs = ps.executeQuery();

			if(rs.next()){
				
				retorno = rs.getString(1);			
			}


			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;		

	}

	public Vector<Atendente> gerarRelatorioAtendentes() {
		Vector<Atendente> retorno = new Vector<Atendente>();

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT * FROM Funcionario F, Atendente P WHERE F.cpf = P.cpf_atendente ORDER BY F.nome";


		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ResultSet rs = ps.executeQuery();

			while (rs.next()) {

				Atendente atendente = new Atendente(rs.getString(1), rs

						.getString(2), rs.getString(3), rs.getString(4)
						.charAt(0), rs.getString(5), rs.getString(6), rs
						.getString(7), rs.getString(8), rs.getFloat(9),
						rs.getString(11), rs.getString(12), rs.getString(10));
				retorno.add(atendente);


			}

			rs.close();
			ps.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
	
    public Atendente consultarAtendentePorLogin(String login)
            throws SQLException {

        Atendente atendente;
        Conexao c = new Conexao();
        Connection conn = c.conectarBD();

        String comando = "SELECT * FROM Funcionario F, Atendente P WHERE F.cpf = P.cpf_atendente AND P.login = ? order by F.nome";

        PreparedStatement ps = conn.prepareStatement(comando);
        ps.setString(1, login);

        ResultSet rs = ps.executeQuery();

        boolean b = rs.next();
        if (b) {
            atendente = new Atendente(rs.getString(1), rs.getString(2), rs
                    .getString(3), rs.getString(4).charAt(0), rs.getString(5),
                    rs.getString(6), rs.getString(7), rs.getString(8), rs
                            .getFloat(9), rs.getString(11), rs.getString(12),
                    rs.getString(10));
        } else {
            atendente = null;
        }

        rs.close();
        ps.close();
        c.fecharConexao();

        return atendente;
    }

	/**MTODO EXISTE FUNCIONRIO**/

	public boolean existe(String cpf){

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Funcionario WHERE cpf = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, cpf);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if(rs.getInt(1) != 0){

				retorno = true;			
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}


	public static void main(String[] args) {

	/*	Atendente a = new Atendente("07266998845", "78998877", "Alice Lucena", "F", "10022010", "Rua Maria Quitria, 55, Cordeiro, Recife-Pe", "alco@cin.ufpe.br", "Atendente de padaria :D", (float)1555.22, "alco", "Alice", "8198838141");
		Professor p = new Professor("08702494442", "7424201", "Davi de Alice Carneiro", "M", "16091990","Rua Vinte e Seis, 60, Rio Doce, Olinda-Pe", "dfc.davi@hotmail.com", "Professor de IUM", (float)6999.20, (float)40.55, "8191838141");
		Funcionario outro = new Funcionario("02554444569", "8775521", "Joaquina Silva", "F", "15081995","Rua Josivaldo Antunes, 40, Bairro Novo, Olinda-Pe", "zelador@hotmail.com", "Zelador", (float)1000.21, "8199887554");

*/
	//	RepositorioFuncionario r = new RepositorioFuncionario();

		//r.inserirAtendente(a);
		//r.inserirProfessor(p);
		//r.inserirOutroFuncionario(outro);

		//r.atualizarAtendente("07266998845", new Atendente("", "", "Alice Lucena Cavalcanti de Oliveira", "F", "10022010", "Rua Jussara Ferreira, 1585, Boa Viagem, Recife-Pe", "lco.alice@gmail.com", "atendente", (float)255.77, "", "alicinha", "8481556554"));
		//r.atualizarProfessor("08702494442", new Professor("", "", "David Alice Frana", "M", "16091990","Rua Vinte e Seis, 60, Rio Doce, Olinda-Pe", "-", "professor de padaria", (float)6999.20, (float)40.55), "6491836654");
		//r.atualizarOutroFuncionario("02554444569", new Funcionario("", "", "Joaquina Maria da Silva Sousa", "F", "15081995","Rua Joo da Costa, 40, Bairro Novo, Olinda-Pe", "zelador@cin.ufpe.br", "padaria", (float)1500.21), "2198877455");

		//r.removerAtendente("07266998845");
		//r.removerProfessor("08702494442");
		//r.removerOutroFuncionario("02554444569");

	 //**Consultar funcionrio por CPF**/
		
		RepositorioFuncionario r = new RepositorioFuncionario();
		Funcionario f = r.consultarFuncionarioPorCPF("12");

		if(f instanceof Atendente){

			System.out.println("CPF: " + ((Atendente)f).getCpf() + '\n' +
							   "R.G: " + ((Atendente)f).getRg() + '\n' +
							   "NOME: " + ((Atendente)f).getNome()+ '\n' +
							   "SEXO: " + ((Atendente)f).getSexo() + '\n' +
							   "DATA NASCIMENTO: " + ((Atendente)f).getNascimento() + '\n' +
							   "ENDEREO: " + ((Atendente)f).getEndereco() + '\n' +
							   "EMAIL: " + ((Atendente)f).getEmail() + '\n' +
							   "FUNO: " + ((Atendente)f).getFuncao() + '\n' +
							   "SALRIO: " + ((Atendente)f).getSalario() + '\n' +
							   "LOGIN: " + ((Atendente)f).getLogin() + '\n' + 
							   "SENHA: " + ((Atendente)f).getSenha() + '\n' +
							   "TELEFONE: " + ((Atendente)f).getTelefone());

		}else if(f instanceof Professor){

			System.out.println("CPF: " + ((Professor)f).getCpf() + '\n' +
					   "R.G: " + ((Professor)f).getRg() + '\n' +
					   "NOME: " + ((Professor)f).getNome()+ '\n' +
					   "SEXO: " + ((Professor)f).getSexo() + '\n' +
					   "DATA NASCIMENTO: " + ((Professor)f).getNascimento() + '\n' +
					   "ENDEREO: " + ((Professor)f).getEndereco() + '\n' +
					   "EMAIL: " + ((Professor)f).getEmail() + '\n' +
					   "FUNO: " + ((Professor)f).getFuncao() + '\n' +
					   "SALRIO: " + ((Professor)f).getSalario() + '\n' +
					   "HORA_AULA: " + ((Professor)f).getHora_aula()+ '\n' +
					   "TELEFONE: " + ((Professor)f).getTelefone());

		}else{

			System.out.println("CPF: " + f.getCpf() + '\n' +
					   "R.G: " + f.getRg() + '\n' +
					   "NOME: " + f.getNome()+ '\n' +
					   "SEXO: " + f.getSexo() + '\n' +
					   "DATA NASCIMENTO: " + f.getNascimento() + '\n' +
					   "ENDEREO: " + f.getEndereco() + '\n' +
					   "EMAIL: " + f.getEmail() + '\n' +
					   "FUNO: " + f.getFuncao() + '\n' +
					   "SALRIO: " + f.getSalario()+ '\n' +
					   "TELEFONE: " + f.getTelefone());

		}

	  /**Consultar funcionrio por nome**//*

		Vector<Funcionario> f = r.consultarFuncionarioPorNome("Alice");

		for(int i = 0; i < f.size(); i++){

			if(f.get(i) instanceof Atendente){

				System.out.println("CPF: " + ((Atendente)f.get(i)).getCpf() + '\n' +
						"R.G: " + ((Atendente)f.get(i)).getRg() + '\n' +
						"NOME: " + ((Atendente)f.get(i)).getNome()+ '\n' +
						"SEXO: " + ((Atendente)f.get(i)).getSexo() + '\n' +
						"DATA NASCIMENTO: " + ((Atendente)f.get(i)).getNascimento() + '\n' +
						"ENDEREO: " + ((Atendente)f.get(i)).getEndereco() + '\n' +
						"EMAIL: " + ((Atendente)f.get(i)).getEmail() + '\n' +
						"FUNO: " + ((Atendente)f.get(i)).getFuncao() + '\n' +
						"SALRIO: " + ((Atendente)f.get(i)).getSalario() + '\n' +
						"LOGIN: " + ((Atendente)f.get(i)).getLogin() + '\n' + 
						"SENHA: " + ((Atendente)f.get(i)).getSenha()+ '\n' +
						"TELEFONE: " + ((Atendente)f.get(i)).getTelefone());

				System.out.println();

			}else if(f.get(i) instanceof Professor){

				System.out.println("CPF: " + ((Professor)f.get(i)).getCpf() + '\n' +
						"R.G: " + ((Professor)f.get(i)).getRg() + '\n' +
						"NOME: " + ((Professor)f.get(i)).getNome()+ '\n' +
						"SEXO: " + ((Professor)f.get(i)).getSexo() + '\n' +
						"DATA NASCIMENTO: " + ((Professor)f.get(i)).getNascimento() + '\n' +
						"ENDEREO: " + ((Professor)f.get(i)).getEndereco() + '\n' +
						"EMAIL: " + ((Professor)f.get(i)).getEmail() + '\n' +
						"FUNO: " + ((Professor)f.get(i)).getFuncao() + '\n' +
						"SALRIO: " + ((Professor)f.get(i)).getSalario() + '\n' +
						"HORA_AULA: " + ((Professor)f.get(i)).getHora_aula()+ '\n' +
						"TELEFONE: " + ((Professor)f.get(i)).getTelefone());
				System.out.println();

			}else{

				System.out.println("CPF: " + f.get(i).getCpf() + '\n' +
						"R.G: " + f.get(i).getRg() + '\n' +
						"NOME: " + f.get(i).getNome()+ '\n' +
						"SEXO: " + f.get(i).getSexo() + '\n' +
						"DATA NASCIMENTO: " + f.get(i).getNascimento() + '\n' +
						"ENDEREO: " + f.get(i).getEndereco() + '\n' +
						"EMAIL: " + f.get(i).getEmail() + '\n' +
						"FUNO: " + f.get(i).getFuncao() + '\n' +
						"SALRIO: " + f.get(i).getSalario()+ '\n' +
						"TELEFONE: " + f.get(i).getTelefone());
				System.out.println();
			}

		}

	   *//**Consultar funcionrio por funo**//*

		Vector<Funcionario> f = r.consultarFuncionarioPorFuncao("padaria");

		for(int i = 0; i < f.size(); i++){

			if(f.get(i) instanceof Atendente){

				System.out.println("CPF: " + ((Atendente)f.get(i)).getCpf() + '\n' +
						"R.G: " + ((Atendente)f.get(i)).getRg() + '\n' +
						"NOME: " + ((Atendente)f.get(i)).getNome()+ '\n' +
						"SEXO: " + ((Atendente)f.get(i)).getSexo() + '\n' +
						"DATA NASCIMENTO: " + ((Atendente)f.get(i)).getNascimento() + '\n' +
						"ENDEREO: " + ((Atendente)f.get(i)).getEndereco() + '\n' +
						"EMAIL: " + ((Atendente)f.get(i)).getEmail() + '\n' +
						"FUNO: " + ((Atendente)f.get(i)).getFuncao() + '\n' +
						"SALRIO: " + ((Atendente)f.get(i)).getSalario() + '\n' +
						"LOGIN: " + ((Atendente)f.get(i)).getLogin() + '\n' + 
						"SENHA: " + ((Atendente)f.get(i)).getSenha()+ '\n' +
						"TELEFONE: " + ((Atendente)f.get(i)).getTelefone());

				System.out.println();

			}else if(f.get(i) instanceof Professor){

				System.out.println("CPF: " + ((Professor)f.get(i)).getCpf() + '\n' +
						"R.G: " + ((Professor)f.get(i)).getRg() + '\n' +
						"NOME: " + ((Professor)f.get(i)).getNome()+ '\n' +
						"SEXO: " + ((Professor)f.get(i)).getSexo() + '\n' +
						"DATA NASCIMENTO: " + ((Professor)f.get(i)).getNascimento() + '\n' +
						"ENDEREO: " + ((Professor)f.get(i)).getEndereco() + '\n' +
						"EMAIL: " + ((Professor)f.get(i)).getEmail() + '\n' +
						"FUNO: " + ((Professor)f.get(i)).getFuncao() + '\n' +
						"SALRIO: " + ((Professor)f.get(i)).getSalario() + '\n' +
						"HORA_AULA: " + ((Professor)f.get(i)).getHora_aula()+ '\n' +
						"TELEFONE: " + ((Professor)f.get(i)).getTelefone());
				System.out.println();

			}else{

				System.out.println("CPF: " + f.get(i).getCpf() + '\n' +
						"R.G: " + f.get(i).getRg() + '\n' +
						"NOME: " + f.get(i).getNome()+ '\n' +
						"SEXO: " + f.get(i).getSexo() + '\n' +
						"DATA NASCIMENTO: " + f.get(i).getNascimento() + '\n' +
						"ENDEREO: " + f.get(i).getEndereco() + '\n' +
						"EMAIL: " + f.get(i).getEmail() + '\n' +
						"FUNO: " + f.get(i).getFuncao() + '\n' +
						"SALRIO: " + f.get(i).getSalario()+ '\n' +
						"TELEFONE: " + f.get(i).getTelefone());
				System.out.println();
			}

		}

	    *//**Gerar relatorio de funcionarios**//*

		Vector<Funcionario> f = r.gerarRelatorioFuncionarios();

		for(int i = 0; i < f.size(); i++){

			if(f.get(i) instanceof Atendente){

				System.out.println("CPF: " + ((Atendente)f.get(i)).getCpf() + '\n' +
						"R.G: " + ((Atendente)f.get(i)).getRg() + '\n' +
						"NOME: " + ((Atendente)f.get(i)).getNome()+ '\n' +
						"SEXO: " + ((Atendente)f.get(i)).getSexo() + '\n' +
						"DATA NASCIMENTO: " + ((Atendente)f.get(i)).getNascimento() + '\n' +
						"ENDEREO: " + ((Atendente)f.get(i)).getEndereco() + '\n' +
						"EMAIL: " + ((Atendente)f.get(i)).getEmail() + '\n' +
						"FUNO: " + ((Atendente)f.get(i)).getFuncao() + '\n' +
						"SALRIO: " + ((Atendente)f.get(i)).getSalario() + '\n' +
						"LOGIN: " + ((Atendente)f.get(i)).getLogin() + '\n' + 
						"SENHA: " + ((Atendente)f.get(i)).getSenha()+ '\n' +
						"TELEFONE: " + ((Atendente)f.get(i)).getTelefone());

				System.out.println();

			}else if(f.get(i) instanceof Professor){

				System.out.println("CPF: " + ((Professor)f.get(i)).getCpf() + '\n' +
						"R.G: " + ((Professor)f.get(i)).getRg() + '\n' +
						"NOME: " + ((Professor)f.get(i)).getNome()+ '\n' +
						"SEXO: " + ((Professor)f.get(i)).getSexo() + '\n' +
						"DATA NASCIMENTO: " + ((Professor)f.get(i)).getNascimento() + '\n' +
						"ENDEREO: " + ((Professor)f.get(i)).getEndereco() + '\n' +
						"EMAIL: " + ((Professor)f.get(i)).getEmail() + '\n' +
						"FUNO: " + ((Professor)f.get(i)).getFuncao() + '\n' +
						"SALRIO: " + ((Professor)f.get(i)).getSalario() + '\n' +
						"HORA_AULA: " + ((Professor)f.get(i)).getHora_aula()+ '\n' +
						"TELEFONE: " + ((Professor)f.get(i)).getTelefone());
				System.out.println();

			}else{

				System.out.println("CPF: " + f.get(i).getCpf() + '\n' +
						"R.G: " + f.get(i).getRg() + '\n' +
						"NOME: " + f.get(i).getNome()+ '\n' +
						"SEXO: " + f.get(i).getSexo() + '\n' +
						"DATA NASCIMENTO: " + f.get(i).getNascimento() + '\n' +
						"ENDEREO: " + f.get(i).getEndereco() + '\n' +
						"EMAIL: " + f.get(i).getEmail() + '\n' +
						"FUNO: " + f.get(i).getFuncao() + '\n' +
						"SALRIO: " + f.get(i).getSalario()+ '\n' +
						"TELEFONE: " + f.get(i).getTelefone());
				System.out.println();
			}

		}

	}*/

}
}
