package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.Dias;
import basicas.EscolaParceira;
import basicas.Ingresso;
import conexao.Conexao;

public class RepositorioIngresso {
	PreparedStatement ps;
	
	public void inserirEscola(Ingresso ingresso){
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando = "INSERT INTO Ingresso VALUES (?,?,?); ";
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, ingresso.getLocalAssento());
			ps.setInt(2, ingresso.getCodigoFestival());
			ps.setDouble(3,	ingresso.getValor());
			ps.executeUpdate();
			ps.close();
            c.fecharConexao();			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}
	public boolean atualizarIngresso(String localAssento,int codigoFestival, Ingresso ingresso){

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "UPDATE Ingresso SET valor = ? WHERE local_assento = ? and codigo_festival = ?";
		

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setDouble(1, ingresso.getValor());
			ps.setString(2, localAssento);
			ps.setInt(3, codigoFestival);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return retorno;
	}	
	public boolean removerIngresso(String localAssento, int codigoFestival){

		boolean retorno = false;

		Conexao c = new Conexao(); 
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Ingresso WHERE local_assento = ? and codigo_festival = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, localAssento);
			ps.setInt(2, codigoFestival);
			
			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
	public Vector<Ingresso> gerarRelatorioIngresso() {
		Conexao conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Ingresso;";
		Vector<Ingresso> ingressos= new Vector<Ingresso>();
		Ingresso ingresso;
		try {

			ps = conn.prepareStatement(comando);
			rs = ps.executeQuery();

			while (rs.next()) {
				
				ingresso = new Ingresso((String)rs.getString(1), (int)rs.getInt(2), (double)rs.getDouble(3));
				ingressos.add(ingresso);
			
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return ingressos;
	}
	public boolean existe( String localAssento,int codigoFestival){

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Ingresso WHERE local_assento= ? and codigo_festival= ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, localAssento);
			ps.setInt(2, codigoFestival);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if(rs.getInt(1) != 0){

				retorno = true;			
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
	
	public Vector<Ingresso> consultarIngressosPorCodigoFestival(int codigoFestival) {
		Conexao conexao;
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Ingresso WHERE codigo_festival = ?;";
		Vector<Ingresso> ingressos = new Vector<Ingresso>();
		Ingresso ingresso;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoFestival);
			rs = ps.executeQuery();

			while (rs.next()) {
				
				ingresso = new Ingresso((String)rs.getString(1), (int)rs.getInt(2), (double)rs.getDouble(3));
				ingressos.add(ingresso);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return ingressos;
	}
	
	public Ingresso consultarIngressoPorCodigoFestivalELocalAssento(int codigoFestival, String localAssento) {
		Conexao conexao;
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Ingresso WHERE codigo_festival = ? and local_assento=?;";
		Vector<Ingresso> ingressos = new Vector<Ingresso>();
		Ingresso ingresso = null;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoFestival);
			ps.setString(2, localAssento);
			rs = ps.executeQuery();
			rs.next();
				
				ingresso = new Ingresso((String)rs.getString(1), (int)rs.getInt(2), (double)rs.getDouble(3));

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return ingresso;
	}







	public static void main(String[] args) {
//		Ingresso i = new Ingresso("5C", 2, 25.50);
//		Ingresso i2 = new Ingresso("5E", 1, 50);
//		Ingresso i3 = new Ingresso("5C", 2, 25);
//		
//		RepositorioIngresso r = new RepositorioIngresso();
//		//	r.inserirEscola(i);
//		r.inserirEscola(i2);
//		r.inserirEscola(i3);
//		r.removerIngresso("4B", 1);
//		r.atualizarIngresso("5C", 2, i);
//		
//		Vector<Ingresso> ingressos = new Vector<Ingresso>();
//		Ingresso ingre =r.consultarIngressoPorCodigoFestivalELocalAssento(2, "5C"); 
//		System.out.println(ingre.getLocalAssento()+" "+ingre.getCodigoFestival()+" "+ ingre.getValor());
////		ingressos = 
//		for(int x =0;x<ingressos.size();x++){
//			Ingresso ing = ingressos.get(x);
//			System.out.println(ing.getLocalAssento()+" "+ing.getCodigoFestival()+" "+ ing.getValor());
//		}
//		System.out.println(r.existe("5c", 2));
//		System.out.println(r.existe("5C", 1));
	}
}
