package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.Despesa;
import basicas.Modalidade;

import conexao.Conexao;

public class RepositorioModalidade {
	PreparedStatement ps;
	Conexao conexao;

	public RepositorioModalidade() {
		conexao = new Conexao();
	}
	public void inserirModalidade(Modalidade modalidade) {
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando = "INSERT INTO Modalidade VALUES (?, ?); ";

		try {
			PreparedStatement ps = conn.prepareStatement(comando);
			ps.setString(1, modalidade.getNome());
			ps.setDouble(2, modalidade.getValor());
			ps.executeUpdate();
			ps.close();
			c.fecharConexao();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public boolean atualizarModalidade(String nome, Modalidade modalidade) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando2 = "UPDATE Modalidade SET valor = ? WHERE nome = ?";

		try {

			PreparedStatement ps2 = conn.prepareStatement(comando2);

			ps2.setDouble(1, modalidade.getValor());
			ps2.setString(2, nome);

			ps2.execute();

			ps2.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean removerModalidade(String nome) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Modalidade WHERE nome = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, nome);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Modalidade consultarModalidadePorNome(String nome) {

		String comando = "SELECT *FROM Modalidade WHERE nome like ?;";
		
		
		Connection conn = conexao.conectarBD();
		
		ResultSet rs = null;

		Modalidade retorno = null;

		try {
			ps = conn.prepareStatement(comando);
			
			ps.setString(1, nome);
			rs = ps.executeQuery();
			rs.next();

			retorno = new Modalidade((String) rs.getString(1), (Double) rs
					.getDouble(2));

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return retorno;
	}
	
	public boolean existeModalidade(String nome){

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Modalidade WHERE nome = ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setString(1, nome);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if(rs.getInt(1) != 0){

				retorno = true;			
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}
	
	
	public Vector<Modalidade> gerarRelatorioModalidade() {
		
		String comando = "SELECT *FROM Modalidade ;";
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		
		Vector<Modalidade> modalidades = new Vector<Modalidade>();

		Modalidade modalidade = null;

		try {
			ps = conn.prepareStatement(comando);
			rs = ps.executeQuery();
			while(rs.next()){

			modalidade= new Modalidade((String) rs.getString(1), (Double) rs
					.getDouble(2));
			modalidades.add(modalidade);
			
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
		return modalidades;
	}



	public static void main(String[] args) {
//		Modalidade mod = new Modalidade("Ballet", 80);
//		Modalidade mod2 = new Modalidade("Forro", 80.45);
//		Modalidade mod3 = new Modalidade("Ballet", 80);
//		Modalidade mod4 = new Modalidade("valsa", 80);
//		Modalidade mod5 = new Modalidade("brega", 80);
		
		
//		RepositorioModalidade r = new RepositorioModalidade();
		
//		System.out.println(r.existe("Ballet"));
//		System.out.println(r.existe(""));
//		System.out.println(r.existe("asdf"));
		
//		Vector<Modalidade> modalidades = new Vector<Modalidade>();
//		modalidades = r.gerarRelatorioModalidade();
//		for(int i = 0;i<modalidades.size();i++){
//			Modalidade m =modalidades.get(i);
//			System.out.println(m.getNome()+" "+m.getValor());
//		}
		
//		Modalidade mo1 = r.consultarModalidadePorNome("Ballet");
//		Modalidade mo2 = r.consultarModalidadePorNome("brega");
//		
//		System.out.println(mo1.getNome()+" "+mo1.getValor());
//		System.out.println(mo2.getNome()+" "+mo2.getValor());
		 
		 //r.inserirModalidade(mod);
		 //r.inserirModalidade(mod2);
//		 r.inserirModalidade(mod3);
//		 r.inserirModalidade(mod4);
//		 r.inserirModalidade(mod5);
		 
		 
//		Modalidade m = new Modalidade("danca", 50.45);
//		r.atualizarModalidade("Ballet", m);
//		
//		Modalidade m2 = new Modalidade("", 60.45);
//		r.atualizarModalidade("brega", m2);
//		
//		Modalidade m3 = new Modalidade(null, 50.45);
//		r.atualizarModalidade("valsa", m3);
//		
//		//r.removerModalidade("Forro");
//		r.removerModalidade("asdf");
		
		
		
	}

}