package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import util.QuickSort;
import basicas.Aluno;
import conexao.Conexao;

//as datas devem ser armazenadas no formato dd/MM/yyyy ALWAYS! - GAMBIARRA ;D

//os mes_ano so armazenados na forma MM/yyyy.

public class RepositorioPagamentoMensalidade {
	private PreparedStatement ps;
	private Conexao conexao;

	public RepositorioPagamentoMensalidade() {
		conexao = new Conexao();
	}

	// esse  o pagarMensalidade
	public void inserirMensalidade(String mesAno, int codAluno,
			String dataPagamento, double valorPago) {
		Connection conn = conexao.conectarBD();
		final String INSERT_MENSALIDADE = "INSERT INTO Pagamento_Mensalidade values (?, ?, ?, ?);";
		try {
			ps = conn.prepareStatement(INSERT_MENSALIDADE);
			mesAno = mesAno.substring(0,2) + mesAno.substring(3,7);
			ps.setString(1, mesAno);
			ps.setInt(2, codAluno);
			ps.setString(3, dataPagamento);
			ps.setDouble(4, valorPago);
			ps.executeUpdate();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();
	}

	/*
	 * public void removerMensalidade(String mesAno, int codAluno) { Connection
	 * conn = conexao.conectarBD(); final String DELETE_MENSALIDADE =
	 * "DELETE FROM Pagamento_Mensalidade WHERE mes_ano = ? and cod_aluno = ?;";
	 * try { ps = conn.prepareStatement(DELETE_MENSALIDADE); ps.setString(1,
	 * mesAno); ps.setInt(2, codAluno); ps.executeUpdate(); ps.close();
	 * 
	 * } catch (SQLException e) { e.printStackTrace(); }
	 * 
	 * conexao.fecharConexao(); }
	 */

	/*
	 * public Vector<Mensalidade> pegarMensalidadesNaoPagasPorAluno(int
	 * codigoAluno) throws SQLException{ Connection conn = conexao.conectarBD();
	 * ResultSet rs = null; Vector<Mensalidade> naoPagas = new
	 * Vector<Mensalidade>(); final String SELECT_MENSALIDADE =
	 * "(SELECT mes_ano FROM Pagamento_Mensalidade " + "WHERE cod_aluno = ?)";
	 * 
	 * ps = conn.prepareStatement(SELECT_MENSALIDADE); ps.setInt(1,
	 * codigoAluno); rs = ps.executeQuery(); String mes_ano = null;
	 * Vector<String> pagas = new Vector<String>();
	 * 
	 * while(rs.next()){ mes_ano = rs.getString(1); pagas.add(mes_ano); }
	 * rs.close(); ps.close();
	 * 
	 * String SELECT_MATRICULA =
	 * "SELECT data_matricula FROM Aluno WHERE cod_aluno = ?;"; ps =
	 * conn.prepareStatement(SELECT_MATRICULA); ps.setInt(1, codigoAluno); rs =
	 * ps.executeQuery();
	 * 
	 * String matricula = rs.getString(1); ManipulacaoData.pegarDataAtual();
	 * String dataAtual = ManipulacaoData.getData();
	 * 
	 * return naoPagas; }
	 */

	public String consultarProximaMensalidade(Aluno aluno, int codigoAluno)
			throws SQLException {
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		String mensalidade = "";
		Integer[] mensalidades = new Integer[0];
		final String TAMANHO = "SELECT count(*) FROM Pagamento_Mensalidade WHERE cod_aluno = ?";

		ps = conn.prepareStatement(TAMANHO);
		ps.setInt(1, codigoAluno);
		rs = ps.executeQuery();

		rs.next();
		int tamanho = rs.getInt(1);

		rs.close();
		ps.close();
		
		if (tamanho <= 0) {
			mensalidade = this.consultarDataMatricula(codigoAluno, conn);

		} else {
			
			final String SELECT_MENSALIDADE = "SELECT mes_ano FROM Pagamento_Mensalidade "
				+ "WHERE cod_aluno = ?;";
			
			ps = conn.prepareStatement(SELECT_MENSALIDADE);
			ps.setInt(1, codigoAluno);
			rs = ps.executeQuery();
			
			mensalidades = new Integer[tamanho];
			tamanho = 0;	
			
			while (rs.next()) {
				mensalidade = rs.getString(1);
				//inverte mes e ano pra ordenar
				mensalidade = mensalidade.substring(2, 6)
						+ mensalidade.substring(0, 2);

				mensalidades[tamanho] = Integer.parseInt(mensalidade);
				tamanho++;
			}

			//pega a maior paga at o momento
			QuickSort quick = new QuickSort(mensalidades);
			quick.quicksort(0, tamanho-1);
			mensalidade = String.valueOf(quick.getArray()[tamanho-1]);
			
			//desinverte
			mensalidade = mensalidade.substring(4, 6)
					+ mensalidade.substring(0, 4);

			//pega a proxima mensalidade que o cara tem que pagar
			mensalidade = this.buscarProximaMensalidade(mensalidade);
			rs.close();
			ps.close();

		}
		//poe a barra
		mensalidade = mensalidade.substring(0, 2) + "/"
				+ mensalidade.substring(2, 6);

		return mensalidade;
		// retorna na forma MM/yyyy
	}

	private String consultarDataMatricula(int codigoAluno, Connection conn)
			throws SQLException {
		String SELECT_MATRICULA = " SELECT data_matricula FROM Aluno WHERE cod_aluno = ?";
		ps = conn.prepareStatement(SELECT_MATRICULA);
		ps.setInt(1, codigoAluno);
		String matricula = "";
		ResultSet rs = ps.executeQuery();
		if (rs.next()) {
			matricula = rs.getString(1);
			matricula = matricula.substring(3, 5) + matricula.substring(6, 10);
		}

		rs.close();
		ps.close();

		return matricula;
	}

	private String buscarProximaMensalidade(String ultimaPaga) {
		int mes = Integer.parseInt(ultimaPaga.substring(0, 2));
		int ano = Integer.parseInt(ultimaPaga.substring(2, 6));

		if (mes < 12) {
			ultimaPaga = (mes + 1) + "" + ano;
			if(mes < 10){
				ultimaPaga = "0" + ultimaPaga;
			}
		} else {
			ultimaPaga = "01" + (ano + 1);
		}

		return ultimaPaga;
	}

	
}
