package repositorios;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import basicas.Atendente;
import basicas.Festival;
import basicas.Turma;

import conexao.Conexao;

public class RepositorioTurma {
	PreparedStatement ps;
	Conexao conexao = null;

	public void inserirTurma(Turma turma) {
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();
		String comando = "INSERT INTO Turma VALUES (?, ?, ?, ?, ?, ?, ?); ";
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, null);
			ps.setString(2, turma.getNomeModalidade());
			ps.setString(3, turma.getCpfProfessor());
			ps.setString(4, turma.getNome());
			ps.setInt(5, turma.getIdadeMinima());
			ps.setInt(6, turma.getIdadeMaxima());
			ps.setInt(7, turma.getSala());
			ps.executeUpdate();
			ps.close();
			c.fecharConexao();
		} catch (SQLException e) {
			e.printStackTrace();
		}

	}



	public boolean atualizarTurma(int codigoTurma, Turma t) {
		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando  = "UPDATE Turma SET nome = ? WHERE codigo_turma = ?";
		String comando2 = "UPDATE Turma SET idade_minima = ? WHERE codigo_turma = ?";
		String comando3 = "UPDATE Turma SET idade_maxima = ? WHERE codigo_turma = ?";
		String comando4 = "UPDATE Turma SET sala = ? WHERE codigo_turma= ?";
		String comando5 = "UPDATE Turma SET cpf_prof = ? WHERE codigo_turma= ?";
		String comando6 = "UPDATE Turma SET nome_modalidade = ? WHERE codigo_turma= ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);
			PreparedStatement ps2 = conn.prepareStatement(comando2);
			PreparedStatement ps3 = conn.prepareStatement(comando3);
			PreparedStatement ps4 = conn.prepareStatement(comando4);
			PreparedStatement ps5 = conn.prepareStatement(comando5);
			PreparedStatement ps6 = conn.prepareStatement(comando6);


			ps.setString(1, t.getNome());
			ps.setInt(2, codigoTurma);

			ps2.setInt(1, t.getIdadeMinima());
			ps2.setInt(2, codigoTurma);

			ps3.setInt(1, t.getIdadeMaxima());
			ps3.setInt(2, codigoTurma);

			ps4.setInt(1, t.getSala());
			ps4.setInt(2, codigoTurma);
			
			ps5.setString(1, t.getCpfProfessor());
			ps5.setInt(2, codigoTurma);
			
			ps6.setString(1, t.getNomeModalidade());
			ps6.setInt(2, codigoTurma);

			ps.execute();
			ps2.execute();
			ps3.execute();
			ps4.execute();
			ps5.execute();
			ps6.execute();


			ps.close();
			ps2.close();
			ps3.close();
			ps4.close();
			ps5.close();
			ps6.close();


			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public boolean removerTurma(int codigoTurma) {

		boolean retorno = false;

		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "DELETE FROM Turma WHERE codigo_turma= ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoTurma);

			ps.execute();

			ps.close();

			c.fecharConexao();

			retorno = true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Vector<Turma> consultarTurmaPorCpfProfessor(String cpfProfessor) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE cpf_prof = ?;";
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, cpfProfessor);
			rs = ps.executeQuery();

			while (rs.next()) {

				turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
						(String) rs.getString(3), (String) rs.getString(4),
						(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));

				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}

	public Vector<Turma> consultarTurmaPorSala(String sala) {

		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE sala LIKE ?;";
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, sala);
			rs = ps.executeQuery();

			while (rs.next()) {

				turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
						(String) rs.getString(3), (String) rs.getString(4),
						(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));


				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}
	public Turma consultarPeloCodigo(int codigoTurma) {

		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE codigo_turma = ?;";
		Turma turma = null;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoTurma);
			rs = ps.executeQuery();
			rs.next();

			turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
					(String) rs.getString(3), (String) rs.getString(4),
					(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));



			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turma;
	}

	public Vector<Turma> consultarTurmaPorNome(String nome) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE nome LIKE ?;";
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, nome);
			rs = ps.executeQuery();

			while (rs.next()) {

				turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
						(String) rs.getString(3), (String) rs.getString(4),
						(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));


				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}
	public Vector<Turma> consultarTurmaPorNomeModalidade(String nomeModalidade) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE nome_modalidade LIKE ?;";
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			ps.setString(1, nomeModalidade);
			rs = ps.executeQuery();

			while (rs.next()) {

				turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
						(String) rs.getString(3), (String) rs.getString(4),
						(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));

				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}


	public Vector<Turma> consultarTurmaPorFaixaEtaria(int idadeDada){
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE idade_minima<=? and idade_maxima >= ?;";
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, idadeDada);
			ps.setInt(2, idadeDada);
			rs = ps.executeQuery();

			while (rs.next()) {

				turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
						(String) rs.getString(3), (String) rs.getString(4),
						(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));

				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}

	public Vector<Turma> gerarRelatorioTurma() {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma;" ;
		Vector<Turma> turmas = new Vector<Turma>();
		Turma turma;
		try {
			ps = conn.prepareStatement(comando);
			rs = ps.executeQuery();

			while (rs.next()) {

				turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
						(String) rs.getString(3), (String) rs.getString(4),
						(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));
				turmas.add(turma);
			}

			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turmas;
	}


	public boolean existe(int codigoTurma){

		boolean retorno = false;
		Conexao c = new Conexao();
		Connection conn = c.conectarBD();

		String comando = "SELECT COUNT(*) FROM Turma WHERE codigo_turma= ?";

		try {

			PreparedStatement ps = conn.prepareStatement(comando);

			ps.setInt(1, codigoTurma);

			ResultSet rs = ps.executeQuery();

			rs.next();

			if(rs.getInt(1) != 0){

				retorno = true;			
			}

			ps.close();

			rs.close();

			c.fecharConexao();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return retorno;
	}

	public Turma consultarTurmaPorCodigo(int codigoTurma) {
		conexao = new Conexao();
		Connection conn = conexao.conectarBD();
		ResultSet rs = null;
		final String comando = "SELECT *FROM Turma WHERE codigo_turma = ?;";
		Turma turma = null;
		try {
			ps = conn.prepareStatement(comando);
			ps.setInt(1, codigoTurma);
			rs = ps.executeQuery();


			turma = new Turma((String) rs.getString(1), (String) rs.getString(2),
					(String) rs.getString(3), (String) rs.getString(4),
					(int) rs.getInt(5), (int) rs.getInt(6), (int) rs.getInt(7));


			rs.close();
			ps.close();

		} catch (SQLException e) {
			e.printStackTrace();
		}

		conexao.fecharConexao();

		return turma;
	}



	public static void main(String[] args) {
		//		Turma t = new Turma(2, "Ballet", "07890520409", "B2", 5, 10, "2");
		//		Turma t2 = new Turma(1, "valsa", "07890520409", "C1", 500, 1, "90");
		//		RepositorioTurma r = new RepositorioTurma();
		//		Vector<Turma> turmas = new Vector<Turma>();
		//		turmas = r.consultarTurmaPorSala("2");
		////		System.out.println(tur.getCodigoTurma()+" "+tur.getNomeModalidade()+" "+tur.getCpfProfessor()+" "+tur.getSala());
		//		for(int i=0;i<turmas.size();i++){
		//				Turma tur = turmas.get(i);
		//				System.out.println(tur.getCodigoTurma()+" "+tur.getNomeModalidade()+" "+tur.getCpfProfessor()+" "+tur.getSala());
		//		}
		////		
		////		System.out.println(r.existe(1));
		////		System.out.println(r.existe(2));
		//		
		//		
		////		r.inserirTurma(t);
		////		r.removerTurma(2);
		//		r.atualizarTurma(1, t2);
	}
}
