package util;

public class QuickSort {
    private Integer[] array;
    int contadorDeCusto, numeroTrocas;
    
    public Integer[] getArray() {
		return array;
	}

    public QuickSort(Integer[] array) {
            this.array = array;
            this.contadorDeCusto = 0;
            this.numeroTrocas = 0;
    }

    public void quicksort(int comeco, int fim) {
            if (comeco < fim) {
                    int p = this.particiona(comeco, fim);
                    this.quicksort(comeco, p - 1);
                    this.quicksort(p + 1, fim);
            }
    }

    private int particiona(int comeco, int fim) {
            contadorDeCusto++;
            Integer meio = array[(comeco + fim) / 2];
            array[(comeco + fim) / 2] = array[comeco];
            array[comeco] = meio;
            int i = comeco + 1;
            int f = fim;
            int pivo = array[comeco];
            while (i <= f) {
                    while (i <= fim && array[i] <= pivo)
                            i++;
                    while (array[f] > pivo)
                            f--;
                    // Se no cruzou
                    if (i < f) {
                            numeroTrocas++;
                            Integer temp = array[i];
                            array[i] = array[f];
                            array[f] = temp;
                    }
            }
            Integer tempy = array[comeco];
            array[comeco] = array[f];
            array[f] = tempy;

            return f;
    }
}